'use strict';
goog.provide('Blockly.Arduino.ruilong');
goog.require('Blockly.Arduino');

//闪灯模块
Blockly.Arduino.ruilong_lamp = function() {
  var dropdown_pin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var dropdown_stat = this.getFieldValue('STAT');
  var code = "";
  if(window.isNaN(dropdown_pin)){
    code = code+'pinMode('+dropdown_pin+', OUTPUT);\n';
  }else{
    Blockly.Arduino.setups_['setup_output_'+dropdown_pin] = 'pinMode('+dropdown_pin+', OUTPUT);';
  }
  code += 'digitalWrite('+dropdown_pin+','+dropdown_stat+');\n'
  return code;
};
//蜂鸣器、继电器、震动马达等
Blockly.Arduino.ruilong_buzzer = Blockly.Arduino.ruilong_lamp;
Blockly.Arduino.ruilong_relay = Blockly.Arduino.ruilong_lamp;
Blockly.Arduino.ruilong_vibrator = Blockly.Arduino.ruilong_lamp;
Blockly.Arduino.ruilong_motor = Blockly.Arduino.ruilong_lamp;
Blockly.Arduino.ruilong_usb = Blockly.Arduino.ruilong_lamp;
Blockly.Arduino.ruilong_relay_3A = Blockly.Arduino.ruilong_lamp;
Blockly.Arduino.ruilong_led = Blockly.Arduino.ruilong_lamp;

//语音模块（68段日常用语）
Blockly.Arduino.ruilong_pins_voice = function() {
  var code = this.getFieldValue('VOICE');
  return [code, Blockly.Arduino.ORDER_ATOMIC];
};

Blockly.Arduino.ruilong_voice = function() {
  var dropdown_pin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var dropdown_voice =  Blockly.Arduino.valueToCode(this, 'VOICE',Blockly.Arduino.ORDER_ATOMIC);
  var wait_time = Blockly.Arduino.valueToCode(this, 'WAIT', Blockly.Arduino.ORDER_ASSIGNMENT) || '0'; 
   Blockly.Arduino.definitions_['define_RL_Voice68_h'] = '#include<RL_Voice68.h>\n';
   Blockly.Arduino.definitions_['define_Voice68'] = 'VOICE_68 voice_'+dropdown_pin +'('+dropdown_pin+');';
   Blockly.Arduino.setups_['setup_Voice68'+dropdown_pin] = 'voice_'+dropdown_pin +'.begin();';
   var code =  'voice_'+dropdown_pin +'.send_data('+dropdown_voice+'); //volume control 0xE0-E7;\n';
       code += 'delay('+wait_time +');\n'
     
  return code;
};

Blockly.Arduino.ruilong_voice_NUM = function() {
  var dropdown_pin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var num =  Blockly.Arduino.valueToCode(this, 'NUM',Blockly.Arduino.ORDER_ATOMIC);
  var wait_time = Blockly.Arduino.valueToCode(this, 'WAIT', Blockly.Arduino.ORDER_ASSIGNMENT) || '0'; 
   Blockly.Arduino.definitions_['define_RL_Voice68_h'] = '#include<RL_Voice68.h>\n';
   Blockly.Arduino.definitions_['define_Voice68'] = 'VOICE_68 voice_'+dropdown_pin +'('+dropdown_pin+');';
   Blockly.Arduino.setups_['setup_Voice68'+dropdown_pin] = 'voice_'+dropdown_pin +'.begin();';
   var code =  'voice_'+dropdown_pin +'.broadcast_float('+num+'); \n';
       code += 'delay('+wait_time +');\n'
     
  return code;
};
//GD5800 串口MP3模块 控制播放
Blockly.Arduino.ruilong_GD5800_UART_MP3_CONTROL = function () {
  var rxpin = Blockly.Arduino.valueToCode(this, 'RXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var txpin = Blockly.Arduino.valueToCode(this, 'TXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var CONTROL_TYPE = this.getFieldValue('CONTROL_TYPE');
  Blockly.Arduino.definitions_['defineGD5800'] ='#include <GD5800_Serial.h>';
  Blockly.Arduino.definitions_['defineGD5800_ mp3'+rxpin+txpin] ='GD5800_Serial mp3_'+rxpin+txpin+'('+rxpin+', '+txpin+');';
  Blockly.Arduino.setups_['setup_ mp3'+rxpin+txpin] = ' mp3_'+rxpin+txpin+'.begin(9600);';
    var code =  'mp3_'+rxpin+txpin+'.'+CONTROL_TYPE+'\n';
        code += 'delay(100);\n';
return code;
};

//GD5800 串口MP3模块 循环模式
Blockly.Arduino.ruilong_GD5800_MP3_LOOP_MODE = function () {
  var rxpin = Blockly.Arduino.valueToCode(this, 'RXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var txpin = Blockly.Arduino.valueToCode(this, 'TXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var LOOP_MODE = this.getFieldValue('LOOP_MODE');
  Blockly.Arduino.definitions_['include_GD5800'] = '#include <GD5800_Serial.h>';
  Blockly.Arduino.definitions_['var_declare_GD5800_ mp3' + rxpin + txpin] = 'GD5800_Serial mp3' + rxpin + txpin + '(' + rxpin + ', ' + txpin + ');';
  Blockly.Arduino.setups_['setup_ mp3' + rxpin + txpin] = ' mp3' + rxpin + txpin + '.begin(9600);';
  var code = 'mp3' + rxpin + txpin + '.setLoopMode(' + LOOP_MODE + ');\n';
  return code;
};

//GD5800 串口MP3模块 EQ模式
Blockly.Arduino.ruilong_GD5800_MP3_EQ_MODE = function () {
  var rxpin = Blockly.Arduino.valueToCode(this, 'RXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var txpin = Blockly.Arduino.valueToCode(this, 'TXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var EQ_MODE = this.getFieldValue('EQ_MODE');
  Blockly.Arduino.definitions_['include_GD5800'] = '#include <GD5800_Serial.h>';
  Blockly.Arduino.definitions_['var_declare_GD5800_ mp3' + rxpin + txpin] = 'GD5800_Serial mp3' + rxpin + txpin + '(' + rxpin + ', ' + txpin + ');';
  Blockly.Arduino.setups_['setup_ mp3' + rxpin + txpin] = ' mp3' + rxpin + txpin + '.begin(9600);';
  var code = 'mp3' + rxpin + txpin + '.setEqualizer(' + EQ_MODE + ');\n';
  return code;
};

//GD5800 串口MP3模块 设置音量
Blockly.Arduino.ruilong_GD5800_MP3_VOL = function () {
  var rxpin = Blockly.Arduino.valueToCode(this, 'RXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var txpin = Blockly.Arduino.valueToCode(this, 'TXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var vol = Blockly.Arduino.valueToCode(this, 'vol', Blockly.Arduino.ORDER_ATOMIC);
  Blockly.Arduino.definitions_['include_GD5800'] = '#include <GD5800_Serial.h>';
  Blockly.Arduino.definitions_['var_declare_GD5800_ mp3' + rxpin + txpin] = 'GD5800_Serial mp3' + rxpin + txpin + '(' + rxpin + ', ' + txpin + ');';
  Blockly.Arduino.setups_['setup_ mp3' + rxpin + txpin] = ' mp3' + rxpin + txpin + '.begin(9600);';
  var code = 'mp3' + rxpin + txpin + '.setVolume(' + vol + ');\n';
  return code;
};

//GD5800 串口MP3模块 播放第N首
Blockly.Arduino.ruilong_GD5800_MP3_PLAY_NUM = function () {
  var rxpin = Blockly.Arduino.valueToCode(this, 'RXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var txpin = Blockly.Arduino.valueToCode(this, 'TXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var NUM = Blockly.Arduino.valueToCode(this, 'NUM', Blockly.Arduino.ORDER_ATOMIC);
  Blockly.Arduino.definitions_['include_GD5800'] = '#include <GD5800_Serial.h>';
  Blockly.Arduino.definitions_['var_declare_GD5800_ mp3' + rxpin + txpin] = 'GD5800_Serial mp3' + rxpin + txpin + '(' + rxpin + ', ' + txpin + ');';
  Blockly.Arduino.setups_['setup_ mp3' + rxpin + txpin] = ' mp3' + rxpin + txpin + '.begin(9600);';
  var code = 'mp3' + rxpin + txpin + '.playFileByIndexNumber(' + NUM + ');\n';
  return code;
};
//YX5300 串口MP3模块 控制播放
Blockly.Arduino.ruilong_YX5300_UART_MP3_CONTROL = function () {
  var rxpin = Blockly.Arduino.valueToCode(this, 'RXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var txpin = Blockly.Arduino.valueToCode(this, 'TXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var CONTROL_TYPE = this.getFieldValue('CONTROL_TYPE');
  Blockly.Arduino.definitions_['defineYX5300'] ='#include <RL_YX5300_Serial.h>';
  Blockly.Arduino.definitions_['defineYX5300_ mp3'+rxpin+txpin] ='YX5300_Serial mp3_'+rxpin+txpin+'('+rxpin+', '+txpin+');';
  Blockly.Arduino.setups_['setup_ mp3'+rxpin+txpin] = 'mp3_'+rxpin+txpin+'.begin(9600);';
    var code =  'mp3_'+rxpin+txpin+'.'+CONTROL_TYPE+'\n';
        code += 'delay(100);\n';
return code;
};
//YX5300 串口MP3模块 设置音量
Blockly.Arduino.ruilong_YX5300_MP3_VOL = function () {
  var rxpin = Blockly.Arduino.valueToCode(this, 'RXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var txpin = Blockly.Arduino.valueToCode(this, 'TXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var vol = Blockly.Arduino.valueToCode(this, 'vol', Blockly.Arduino.ORDER_ATOMIC);
  Blockly.Arduino.definitions_['include_YX5300_Serial'] = '#include <RL_YX5300_Serial.h>';
  Blockly.Arduino.definitions_['var_declare_YX5300_Serial_ mp3' + rxpin + txpin] = 'YX5300_Serial mp3' + rxpin + txpin + '(' + rxpin + ', ' + txpin + ');';
  Blockly.Arduino.setups_['setup_ mp3' + rxpin + txpin] = ' mp3' + rxpin + txpin + '.begin(9600);';
  var code = 'mp3' + rxpin + txpin + '.setVol(' + vol + ');\n';
  return code;
};

//YX5300 串口MP3模块 播放第N首
Blockly.Arduino.ruilong_YX5300_MP3_PLAY_NUM = function () {
  var rxpin = Blockly.Arduino.valueToCode(this, 'RXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var txpin = Blockly.Arduino.valueToCode(this, 'TXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var NUM = Blockly.Arduino.valueToCode(this, 'NUM', Blockly.Arduino.ORDER_ATOMIC);
  Blockly.Arduino.definitions_['include_YX5300_Serial'] = '#include <RL_YX5300_Serial.h>';
  Blockly.Arduino.definitions_['var_declare_YX5300_Serial_ mp3' + rxpin + txpin] = 'YX5300_Serial mp3' + rxpin + txpin + '(' + rxpin + ', ' + txpin + ');';
  Blockly.Arduino.setups_['setup_ mp3' + rxpin + txpin] = ' mp3' + rxpin + txpin + '.begin(9600);';
  var code = 'mp3' + rxpin + txpin + '.play(' + NUM + ');\n';
  return code;
};

//YX5300 串口MP3模块 循环播放第N首
Blockly.Arduino.ruilong_YX5300_MP3_PLAYSL = function () {
  var rxpin = Blockly.Arduino.valueToCode(this, 'RXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var txpin = Blockly.Arduino.valueToCode(this, 'TXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var NUM = Blockly.Arduino.valueToCode(this, 'NUM', Blockly.Arduino.ORDER_ATOMIC);
  Blockly.Arduino.definitions_['include_YX5300_Serial'] = '#include <RL_YX5300_Serial.h>';
  Blockly.Arduino.definitions_['var_declare_YX5300_Serial_ mp3' + rxpin + txpin] = 'YX5300_Serial mp3' + rxpin + txpin + '(' + rxpin + ', ' + txpin + ');';
  Blockly.Arduino.setups_['setup_ mp3' + rxpin + txpin] = ' mp3' + rxpin + txpin + '.begin(9600);';
  var code = 'mp3' + rxpin + txpin + '.playSL(' + NUM + ');\n';
  return code;
};
//YX5300 串口MP3模块 循环播放文件夹
Blockly.Arduino.ruilong_YX5300_MP3_PLAYF = function () {
  var rxpin = Blockly.Arduino.valueToCode(this, 'RXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var txpin = Blockly.Arduino.valueToCode(this, 'TXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var FOLDER = Blockly.Arduino.valueToCode(this, 'FOLDER', Blockly.Arduino.ORDER_ATOMIC);
  Blockly.Arduino.definitions_['include_YX5300_Serial'] = '#include <RL_YX5300_Serial.h>';
  Blockly.Arduino.definitions_['var_declare_YX5300_Serial_ mp3' + rxpin + txpin] = 'YX5300_Serial mp3' + rxpin + txpin + '(' + rxpin + ', ' + txpin + ');';
  Blockly.Arduino.setups_['setup_ mp3' + rxpin + txpin] = ' mp3' + rxpin + txpin + '.begin(9600);';
  var code = 'mp3' + rxpin + txpin + '.playF(' + FOLDER + ');\n';
  return code;
};
//YX5300 串口MP3模块 循环播放在F文件夹 第N首
Blockly.Arduino.ruilong_YX5300_MP3_PLAYFSL = function () {
  var rxpin = Blockly.Arduino.valueToCode(this, 'RXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var txpin = Blockly.Arduino.valueToCode(this, 'TXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var FOLDER = Blockly.Arduino.valueToCode(this, 'FOLDER', Blockly.Arduino.ORDER_ATOMIC);
  var NUM = Blockly.Arduino.valueToCode(this, 'NUM', Blockly.Arduino.ORDER_ATOMIC);
  Blockly.Arduino.definitions_['include_YX5300_Serial'] = '#include <RL_YX5300_Serial.h>';
  Blockly.Arduino.definitions_['var_declare_YX5300_Serial_ mp3' + rxpin + txpin] = 'YX5300_Serial mp3' + rxpin + txpin + '(' + rxpin + ', ' + txpin + ');';
  Blockly.Arduino.setups_['setup_ mp3' + rxpin + txpin] = ' mp3' + rxpin + txpin + '.begin(9600);';
  var code = 'mp3' + rxpin + txpin + '.playSL(' + FOLDER + ','+ NUM +');\n';
  return code;
};


//M9101X mp3 单线控制播放
Blockly.Arduino.ruilong_M9101X_S_MP3_CONTROL = function () {
  var dropdown_pin = Blockly.Arduino.valueToCode(this, 'PIN', Blockly.Arduino.ORDER_ATOMIC);
  var CONTROL_TYPE = this.getFieldValue('CONTROL_TYPE');
  Blockly.Arduino.definitions_['defineN910X'] ='#include <RL_N910X.h>';
  Blockly.Arduino.definitions_['defineN910X_ mp3'+dropdown_pin] ='N910X mp3_'+dropdown_pin+'('+dropdown_pin+');';
  Blockly.Arduino.setups_['setup_ mp3'+dropdown_pin] = 'mp3_'+dropdown_pin+'.begin();';
    var code =  'mp3_'+dropdown_pin+'.'+CONTROL_TYPE+'\n';
    
return code;
};

//M9101X mp3 单线音量控制
Blockly.Arduino.ruilong_M9101X_S_MP3_VOL_CONTROL = function () {
  var dropdown_pin = Blockly.Arduino.valueToCode(this, 'PIN', Blockly.Arduino.ORDER_ATOMIC);
    var vol = Blockly.Arduino.valueToCode(this, 'NUM', Blockly.Arduino.ORDER_ATOMIC);
  Blockly.Arduino.definitions_['defineN910X'] ='#include <RL_N910X.h>';
  Blockly.Arduino.definitions_['defineN910X_ mp3'+dropdown_pin] ='N910X mp3_'+dropdown_pin+'('+dropdown_pin+');';
  Blockly.Arduino.setups_['setup_ mp3'+dropdown_pin] = ' mp3_'+dropdown_pin+'.begin();';
    var code =  'mp3_'+dropdown_pin+'.set_volume('+vol+');\n';
    
return code;
};
//M9101X mp3 单线播放第N首
Blockly.Arduino.ruilong_M9101X_S_MP3_PLAY_NUM = function () {
  var dropdown_pin = Blockly.Arduino.valueToCode(this, 'PIN', Blockly.Arduino.ORDER_ATOMIC);
    var num = Blockly.Arduino.valueToCode(this, 'NUM', Blockly.Arduino.ORDER_ATOMIC);
  Blockly.Arduino.definitions_['defineN910X'] ='#include <RL_N910X.h>';
  Blockly.Arduino.definitions_['defineN910X_ mp3'+dropdown_pin] ='N910X mp3_'+dropdown_pin+'('+dropdown_pin+');';
  Blockly.Arduino.setups_['setup_ mp3'+dropdown_pin] = ' mp3_'+dropdown_pin+'.begin();';
    var code =  'mp3_'+dropdown_pin+'.set_play_number('+num+');\n';
    
return code;
};
//SYN6288 机器人语音模块
Blockly.Arduino.ruilong_SYN6288_VOICE_TEXT = function () {
  var rxpin = Blockly.Arduino.valueToCode(this, 'RXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var txpin = Blockly.Arduino.valueToCode(this, 'TXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var num = Blockly.Arduino.valueToCode(this, 'NUM', Blockly.Arduino.ORDER_ATOMIC);
  var VOICE_TXT = Blockly.Arduino.valueToCode(this, 'TEXT', Blockly.Arduino.ORDER_ASSIGNMENT);
    
  Blockly.Arduino.definitions_['defineSYN6288'] ='#include<RL_SYN6288.h>';
  if(!Blockly.Arduino.definitions_['defineSYN6288_ Voice'+rxpin+txpin]){
  Blockly.Arduino.definitions_['defineSYN6288_ Voice'+rxpin+txpin] ='SYN6288_Serial Voice_'+rxpin+txpin+'('+rxpin+', '+txpin+');';
  Blockly.Arduino.setups_['setup_ Voice'+rxpin+txpin] = 'Voice_'+rxpin+txpin+'.begin(9600);';
  }

  Blockly.Arduino.definitions_['size_t_ Voice'+rxpin+txpin+num]='size_t unicode_number_'+num+' = 0;'  
  Blockly.Arduino.definitions_['char*_ Voice'+rxpin+txpin+num]='char* item_'+num+' = '+VOICE_TXT+';'    

    var code='Voice_'+rxpin+txpin+'.Output((uint8_t*)utf82unicode(item_'+num+',&unicode_number_'+num+'),length_of_unicode(item_'+num+'));\n';
    
return code;
};

Blockly.Arduino.ruilong_SYN6288_VOICE_NUM = function () {
  var rxpin = Blockly.Arduino.valueToCode(this, 'RXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var txpin = Blockly.Arduino.valueToCode(this, 'TXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var num = Blockly.Arduino.valueToCode(this, 'NUM', Blockly.Arduino.ORDER_ATOMIC);
  var value = Blockly.Arduino.valueToCode(this, 'VALUE', Blockly.Arduino.ORDER_ATOMIC);
    
  Blockly.Arduino.definitions_['defineSYN6288'] ='#include<RL_SYN6288.h>';
  if(!Blockly.Arduino.definitions_['defineSYN6288_ Voice'+rxpin+txpin]){
  Blockly.Arduino.definitions_['defineSYN6288_ Voice'+rxpin+txpin] ='SYN6288_Serial Voice_'+rxpin+txpin+'('+rxpin+', '+txpin+');';
  Blockly.Arduino.setups_['setup_ Voice'+rxpin+txpin] = 'Voice_'+rxpin+txpin+'.begin(9600);';
  }

  Blockly.Arduino.definitions_['size_t_ Voice'+rxpin+txpin+num]='size_t unicode_number_'+num+' = 0;'  
  Blockly.Arduino.definitions_['char*_ Voice'+rxpin+txpin+num]='char* item_'+num+' = "0";'    

    var code='sprintf(item_'+num+', "%d", '+value+');\n'
          +'Voice_'+rxpin+txpin+'.Output((uint8_t*)utf82unicode(item_'+num+',&unicode_number_'+num+'),length_of_unicode(item_'+num+'));\n';
    
return code;
};
Blockly.Arduino.ruilong_SYN6288_VOICE_VOL = function () {
  var rxpin = Blockly.Arduino.valueToCode(this, 'RXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var txpin = Blockly.Arduino.valueToCode(this, 'TXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var vol = this.getFieldValue('CONTROL_TYPE');
    
  Blockly.Arduino.definitions_['defineSYN6288'] ='#include<RL_SYN6288.h>';
  if(!Blockly.Arduino.definitions_['defineSYN6288_ Voice'+rxpin+txpin]){
  Blockly.Arduino.definitions_['defineSYN6288_ Voice'+rxpin+txpin] ='SYN6288_Serial Voice_'+rxpin+txpin+'('+rxpin+', '+txpin+');';
  Blockly.Arduino.setups_['setup_ Voice'+rxpin+txpin] = 'Voice_'+rxpin+txpin+'.begin(9600);';
  }

  Blockly.Arduino.definitions_['size_t_ Voice_vol'+rxpin+txpin]='size_t unicode_number_vol = 0;';
  Blockly.Arduino.definitions_['char*_ Voice_vol'+rxpin+txpin]='char* item_vol = "'+vol+'";';   

    var code='Voice_'+rxpin+txpin+'.Output((uint8_t*)utf82unicode(item_vol,&unicode_number_vol),length_of_unicode(item_vol));\n';
    
return code;
};

Blockly.Arduino.ruilong_SYN6288_VOICE_BKVOL = function () {
  var rxpin = Blockly.Arduino.valueToCode(this, 'RXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var txpin = Blockly.Arduino.valueToCode(this, 'TXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var bkvol = this.getFieldValue('CONTROL_TYPE');
    
  Blockly.Arduino.definitions_['defineSYN6288'] ='#include<RL_SYN6288.h>';
  if(!Blockly.Arduino.definitions_['defineSYN6288_ Voice'+rxpin+txpin]){
  Blockly.Arduino.definitions_['defineSYN6288_ Voice'+rxpin+txpin] ='SYN6288_Serial Voice_'+rxpin+txpin+'('+rxpin+', '+txpin+');';
  Blockly.Arduino.setups_['setup_ Voice'+rxpin+txpin] = 'Voice_'+rxpin+txpin+'.begin(9600);';
  }

  Blockly.Arduino.definitions_['size_t_ Voice_kbvol'+rxpin+txpin]='size_t unicode_number_kbvol = 0;';
  Blockly.Arduino.definitions_['char*_ Voice_kbvol'+rxpin+txpin]='char* item_kbvol = "'+bkvol+'";';   

    var code='Voice_'+rxpin+txpin+'.Output((uint8_t*)utf82unicode(item_kbvol,&unicode_number_kbvol),length_of_unicode(item_kbvol));\n';
    
return code;
};

Blockly.Arduino.ruilong_SYN6288_VOICE_SPEED = function () {
  var rxpin = Blockly.Arduino.valueToCode(this, 'RXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var txpin = Blockly.Arduino.valueToCode(this, 'TXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var speed = this.getFieldValue('CONTROL_TYPE');
    
  Blockly.Arduino.definitions_['defineSYN6288'] ='#include<RL_SYN6288.h>';
  if(!Blockly.Arduino.definitions_['defineSYN6288_ Voice'+rxpin+txpin]){
  Blockly.Arduino.definitions_['defineSYN6288_ Voice'+rxpin+txpin] ='SYN6288_Serial Voice_'+rxpin+txpin+'('+rxpin+', '+txpin+');';
  Blockly.Arduino.setups_['setup_ Voice'+rxpin+txpin] = 'Voice_'+rxpin+txpin+'.begin(9600);';
  }

  Blockly.Arduino.definitions_['size_t_ Voice_speed'+rxpin+txpin]='size_t unicode_number_speed = 0;';
  Blockly.Arduino.definitions_['char*_ Voice_speed'+rxpin+txpin]='char* item_speed = "'+speed+'";';   

    var code='Voice_'+rxpin+txpin+'.Output((uint8_t*)utf82unicode(item_speed,&unicode_number_speed),length_of_unicode(item_speed));\n';
    
return code;
};

Blockly.Arduino.ruilong_SYN6288_VOICE_CONTROL = function () {
  var rxpin = Blockly.Arduino.valueToCode(this, 'RXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var txpin = Blockly.Arduino.valueToCode(this, 'TXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var CONTROL_TYPE = this.getFieldValue('CONTROL_TYPE');
  
  Blockly.Arduino.definitions_['defineSYN6288'] ='#include<RL_SYN6288.h>';
  if(!Blockly.Arduino.definitions_['defineGD5800_ Voice'+rxpin+txpin]){
  Blockly.Arduino.definitions_['defineGD5800_ Voice'+rxpin+txpin] ='SYN6288_Serial Voice_'+rxpin+txpin+'('+rxpin+', '+txpin+');';
  Blockly.Arduino.setups_['setup_ Voice'+rxpin+txpin] = ' Voice_'+rxpin+txpin+'.begin(9600);';
  }
    var code =  'Voice_'+rxpin+txpin+'.'+CONTROL_TYPE+'\n';
        code += 'delay(100);\n';
return code;
};
Blockly.Arduino.ruilong_vs1053_midi_GM1 = function () {

  var GM1 = this.getFieldValue("VS1053_GM1");
  
  return [GM1, Blockly.Arduino.ORDER_ATOMIC];
}

Blockly.Arduino.ruilong_vs1053_midi_Instrument = function () {

  var txpin = Blockly.Arduino.valueToCode(this, 'TXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var ch = this.getFieldValue('CH');
  var type = this.getFieldValue('TYPE');
  var instrument = Blockly.Arduino.valueToCode(this, 'INSTRUMENT', Blockly.Arduino.ORDER_ATOMIC);
  var volume = Blockly.Arduino.valueToCode(this, 'MIDIVolume', Blockly.Arduino.ORDER_ATOMIC);
    
  Blockly.Arduino.definitions_['defineRL_VS1053_MIDI'] ='#include <RL_VS1053_MIDI.h>';
  if(!Blockly.Arduino.definitions_['defineRL_VS1053_MIDI'+txpin]){
  Blockly.Arduino.definitions_['defineRL_VS1053_MIDI  midi_'+txpin] ='RL_VS1053_MIDI  midi_'+txpin+'(-1, '+txpin+');';
  Blockly.Arduino.setups_['setup_  midi_'+txpin] = ' midi_'+txpin+'.begin(31250);';
  Blockly.Arduino.setups_['setup_  midi_Control_Change'+txpin] = ' midi_'+txpin+'.Control_Change('+ch+', 0x07, '+volume +');';
  }

    var code='midi_'+txpin+'.Control_Change('+ch+',0,'+ type+');\n '
            +'midi_'+txpin+'.Program_Change('+ch+','+instrument+');\n';
   
return code;
};

Blockly.Arduino.ruilong_vs1053_midi_GM1_GM2 = function () {

  var GM1_GM2 = this.getFieldValue("VS1053_GM1_GM2");
  
  return [GM1_GM2, Blockly.Arduino.ORDER_ATOMIC];
}

Blockly.Arduino.ruilong_midiPitch = function() {

  var highlist = this.getFieldValue("highlist");
  var midipitch = this.getFieldValue("midipitch");
  var code = parseInt(highlist) + parseInt(midipitch)
  //code = highlist+midipitch;
  return [code, Blockly.Arduino.ORDER_ATOMIC];  
};

Blockly.Arduino.ruilong_vs1053_midi_note = function () {

  var txpin = Blockly.Arduino.valueToCode(this, 'TXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var ch = this.getFieldValue('CH');
  var note_on_off = this.getFieldValue('NOTE_ON_OFF');
  var note = Blockly.Arduino.valueToCode(this, 'NOTE', Blockly.Arduino.ORDER_ATOMIC);
  var velocity = Blockly.Arduino.valueToCode(this, 'VELOCITY', Blockly.Arduino.ORDER_ATOMIC);
    
  Blockly.Arduino.definitions_['defineRL_VS1053_MIDI'] ='#include <RL_VS1053_MIDI.h>';
  if(!Blockly.Arduino.definitions_['defineRL_VS1053_MIDI'+txpin]){
  Blockly.Arduino.definitions_['defineRL_VS1053_MIDI  midi_'+txpin] ='RL_VS1053_MIDI  midi_'+txpin+'(-1, '+txpin+');';
  Blockly.Arduino.setups_['setup_  midi_'+txpin] = ' midi_'+txpin+'.begin(31250);';
  Blockly.Arduino.setups_['setup_  midi_Control_Change'+txpin] = ' midi_'+txpin+'.Control_Change('+ch+', 0x07, 127);';
  }


  if(note_on_off=="1"){
    var code ='midi_'+txpin+'.noteOn('+ch+','+note+','+ velocity+');\n ';
  }else{
    var code ='midi_'+txpin+'.noteOff('+ch+','+note+','+ velocity+');\n ';
  }
   
return code;
};


Blockly.Arduino.ruilong_ch9329_mouse_keyboard = function () {

  var txpin = Blockly.Arduino.valueToCode(this, 'TXPIN', Blockly.Arduino.ORDER_ATOMIC);
  var press_release = this.getFieldValue('PRESS_RELEASE');
  var key = this.getFieldValue('MOUSE_KEYBOARD');//Blockly.Arduino.valueToCode(this, 'MOUSE_KEYBOARD', Blockly.Arduino.ORDER_ATOMIC);
 
    
  Blockly.Arduino.definitions_['defineRL_CH9329_Serial'] ='#include"RL_CH9329_Serial.h"';
  Blockly.Arduino.definitions_['definehid_keys'] ='#include"hid_keys.h"';
  if(!Blockly.Arduino.definitions_['defineRL_CH9329_Serial'+txpin]){
  Blockly.Arduino.definitions_['defineRL_CH9329_Serial  ch_'+txpin] ='RL_CH9329_Serial  ch_'+txpin+'(-1, '+txpin+');';
  Blockly.Arduino.setups_['setup_  ch_'+txpin] = ' ch_'+txpin+'.begin(9600);';
 
  }


  if(press_release=="KEYBOARD_PRESS"){
    var code ='ch_'+txpin+'.Keyboard_press('+key+');\n ';
  }else if(press_release=="KEYBOARD_RELEASE"){
    var code ='ch_'+txpin+'.Keyboard_release('+key+');\n ';
  }else if(press_release=="KEYBOARD_RELEASE_ALL"){
    var code ='ch_'+txpin+'.Keyboard_release_all();\n ';
  }else if(press_release=="MOUSE_PRESS"){
    var code ='ch_'+txpin+'.Mouse_press('+key+');\n ';
  }else if(press_release=="MOUSE_RELEASE"){
    var code ='ch_'+txpin+'.Mouse_release('+key+');\n ';
  }else if(press_release=="MOUSE_RELEASE_ALL"){
    var code ='ch_'+txpin+'.Mouse_release_all();\n ';
  }
   
return code;
};
//交通灯模块
Blockly.Arduino.ruilong_traffic_light=function(){
  var dropdown_rgbpin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var R_rgb_led_color = this.getFieldValue('RGB_LED_COLOR0');
  var Y_rgb_led_color = this.getFieldValue('RGB_LED_COLOR1');
  var G_rgb_led_color = this.getFieldValue('RGB_LED_COLOR2');
  var R_color = goog.color.hexToRgb(R_rgb_led_color);
  var Y_color = goog.color.hexToRgb(Y_rgb_led_color);
  var G_color = goog.color.hexToRgb(G_rgb_led_color);
    Blockly.Arduino.definitions_['include_Adafruit_NeoPixel'] = '#include <Adafruit_NeoPixel.h>';
   if (!Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin]) {
      Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin] = 'Adafruit_NeoPixel  rgb_display_' + dropdown_rgbpin + '' + '(3);';
      Blockly.Arduino.setups_['setup_rgb_display_begin_' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.begin();';
      Blockly.Arduino.setups_['setup_rgb_display_setpin' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.setPin(' + dropdown_rgbpin + ');';
  }
  var code = 'rgb_display_'+dropdown_rgbpin+'.setPixelColor(2, '+R_color+');\n';
      code +='rgb_display_'+dropdown_rgbpin+'.setPixelColor(1, '+Y_color+');\n';
    code +='rgb_display_'+dropdown_rgbpin+'.setPixelColor(0, '+G_color+');\n';
      code +='rgb_display_'+dropdown_rgbpin+'.show();\n';
    code +='delay(100);\n';
  return code;
};

Blockly.Arduino.ruilong_resistor_scratch = function() {
  var dropdown_pin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var code = 'analogRead('+dropdown_pin+')';
  return [code, Blockly.Arduino.ORDER_ATOMIC];
};

Blockly.Arduino.ruilong_temp = function() {
  var dropdown_pin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var code = 'analogRead('+dropdown_pin+')*0.488';
  return [code, Blockly.Arduino.ORDER_ATOMIC];
};

Blockly.Arduino.ruilong_fire = Blockly.Arduino.ruilong_resistor_scratch;
Blockly.Arduino.ruilong_sound = Blockly.Arduino.ruilong_resistor_scratch;
Blockly.Arduino.ruilong_moisture = Blockly.Arduino.ruilong_resistor_scratch;
Blockly.Arduino.ruilong_steam = Blockly.Arduino.ruilong_resistor_scratch;
Blockly.Arduino.ruilong_linefinder = Blockly.Arduino.ruilong_resistor_scratch;
Blockly.Arduino.ruilong_knob = Blockly.Arduino.ruilong_resistor_scratch;
Blockly.Arduino.ruilong_slider = Blockly.Arduino.ruilong_resistor_scratch;
Blockly.Arduino.ruilong_joystick_x = Blockly.Arduino.ruilong_resistor_scratch;
Blockly.Arduino.ruilong_joystick_y = Blockly.Arduino.ruilong_resistor_scratch;
Blockly.Arduino.ruilong_turbidity = Blockly.Arduino.ruilong_resistor_scratch;
Blockly.Arduino.ruilong_light = Blockly.Arduino.ruilong_resistor_scratch;
Blockly.Arduino.ruilong_mqx = Blockly.Arduino.ruilong_resistor_scratch;


Blockly.Arduino.ruilong_5button = function () {
    var dropdown_pin = Blockly.Arduino.valueToCode(this, 'PIN', Blockly.Arduino.ORDER_ATOMIC);
    //Blockly.Arduino.setups_['setup_input_'+dropdown_pin] = 'pinMode('+dropdown_pin+', INPUT);';
    var code ='int Abutton(){\n'
           +'int s;\n'
         +'int a=analogRead(' + dropdown_pin + ');\n'
           +'if(a<50) s=1;\n'
           +'else if(a>100&&a<200) s=2;\n'
             +'else if(a>200&&a<350) s=3;\n'
             +'else if(a>350&&a<550) s=4;\n'
       +'else if(a>550&&a<850) s=5;\n'
       +'else  s=0;\n'
       +'return s;'
             +'}\n';

  Blockly.Arduino.definitions_['Abutton'] = code;
    
  var code2 = 'Abutton()';
  
    return [code2, Blockly.Arduino.ORDER_ATOMIC];
};
Blockly.Arduino.ruilong_minijoystick = Blockly.Arduino.ruilong_5button;
Blockly.Arduino.ruilong_magnetic = function() {
  var dropdown_pin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var code = "";
  if(window.isNaN(dropdown_pin)){
  var funcName='mixly_digitalRead';
  var code2='int'+ ' ' + funcName + '(uint8_t pin) {\n' 
  + '  pinMode(pin, INPUT);\n'
  + '  return digitalRead(pin);\n'
  + '}\n';
    Blockly.Arduino.definitions_[funcName] = code2;
  code = 'mixly_digitalRead('+dropdown_pin+')';
  }else{
    if(Blockly.Arduino.setups_['setup_output_'+dropdown_pin]){
     //存在pinMode已设为output则不再设为input
  }else{
       Blockly.Arduino.setups_['setup_input_'+dropdown_pin] = 'pinMode('+dropdown_pin+', INPUT);';
  }
  code = 'digitalRead('+dropdown_pin+')';
  }
  return [code, Blockly.Arduino.ORDER_ATOMIC];
};

//ADS1015模数转换模块 设置范围以及精度
Blockly.Arduino.ruilong_ADS1015_setGain = function() {
  var GAIN = this.getFieldValue('ADS1015_setGain');
  Blockly.Arduino.definitions_['include_Wire'] = '#include <Wire.h>';
  Blockly.Arduino.definitions_['include_Adafruit_ADS1015'] = '#include <Adafruit_ADS1015.h>';
  Blockly.Arduino.definitions_['Adafruit_ADS1015_ads'] = 'Adafruit_ADS1015 ads;\n';

  Blockly.Arduino.setups_['setup_ads.setGain'] = 'ads.setGain('+GAIN+');';
  Blockly.Arduino.setups_['setup_ads.begin()'] = 'ads.begin(); \n';
};

//ADS1015模数转换模块 采集数值
Blockly.Arduino.ruilong_ADS1015 = function() {
  Blockly.Arduino.definitions_['include_Wire'] = '#include <Wire.h>';
  Blockly.Arduino.definitions_['include_Adafruit_ADS1015'] = '#include <Adafruit_ADS1015.h>';
  Blockly.Arduino.definitions_['Adafruit_ADS1015_ads'] = 'Adafruit_ADS1015 ads;\n';

  Blockly.Arduino.setups_['setup_ads.begin()'] = 'ads.begin(); \n';
  
  var dropdown_type = this.getFieldValue('ADS1015_AIN');
  var code = dropdown_type;
  return [code, Blockly.Arduino.ORDER_ATOMIC];
};




Blockly.Arduino.ruilong_pir = Blockly.Arduino.ruilong_magnetic;
Blockly.Arduino.ruilong_vibration = Blockly.Arduino.ruilong_magnetic;
Blockly.Arduino.ruilong_tilt = Blockly.Arduino.ruilong_magnetic;
Blockly.Arduino.ruilong_touch = Blockly.Arduino.ruilong_magnetic;
Blockly.Arduino.ruilong_collision = Blockly.Arduino.ruilong_magnetic;
Blockly.Arduino.ruilong_button = Blockly.Arduino.ruilong_magnetic;
Blockly.Arduino.ruilong_obstacle = Blockly.Arduino.ruilong_magnetic;
Blockly.Arduino.ruilong_switch = Blockly.Arduino.ruilong_magnetic;
Blockly.Arduino.ruilong_robot_button = Blockly.Arduino.ruilong_magnetic;
Blockly.Arduino.ruilong_robot_blink_read = Blockly.Arduino.ruilong_magnetic;

Blockly.Arduino.ruilong_hc_sr04 = function() {
    var dropdown_pin1 = Blockly.Arduino.valueToCode(this, 'PIN1', Blockly.Arduino.ORDER_ATOMIC);
    var dropdown_pin2 = Blockly.Arduino.valueToCode(this, 'PIN2', Blockly.Arduino.ORDER_ATOMIC);
    Blockly.Arduino.setups_['setup_output_' + dropdown_pin1] = 'pinMode(' + dropdown_pin1 + ', OUTPUT);';
    Blockly.Arduino.setups_['setup_output_' + dropdown_pin2] = 'pinMode(' + dropdown_pin2 + ', INPUT);\n';
    var funcName = 'checkdistance_' + dropdown_pin1 + '_' + dropdown_pin2;
    var code = 'float' + ' ' + funcName + '() {\n'
  + '  digitalWrite(' + dropdown_pin1 + ', LOW);\n' + '  delayMicroseconds(2);\n'
  + '  digitalWrite(' + dropdown_pin1 + ', HIGH);\n' + '  delayMicroseconds(10);\n'
  + '  digitalWrite(' + dropdown_pin1 + ', LOW);\n'
  + '  float distance = pulseIn(' + dropdown_pin2 + ', HIGH) / 58.00;\n'
  + '  delay(10);\n' +'  return distance;\n'
  + '}\n';
    Blockly.Arduino.definitions_[funcName] = code;
    return [funcName + '()', Blockly.Arduino.ORDER_ATOMIC];
}
Blockly.Arduino.ruilong_dht11 = function() {
  var dropdown_pin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var what = this.getFieldValue('WHAT');
  Blockly.Arduino.definitions_['define_dht11'] = '#include <dht11.h>';
  Blockly.Arduino.definitions_['var_dht11'+dropdown_pin] = 'dht11 myDHT_'+dropdown_pin+';';
  var funcName='dht_'+dropdown_pin+'_get'+what;
  var code='int'+ ' ' + funcName + '() {\n' 
  + '  int chk = myDHT_'+dropdown_pin+'.read('+dropdown_pin+');\n'
  + '  int value = myDHT_'+dropdown_pin+'.'+what+';\n'
  + '  return value;\n'
  + '}\n';
    Blockly.Arduino.definitions_[funcName] = code;
  return [funcName+'()', Blockly.Arduino.ORDER_ATOMIC];
};

Blockly.Arduino.ruilong_MRP121 = function () {

  var touch = this.getFieldValue('MRP121_TOUCH');
  var touch_state = this.getFieldValue('MRP121_TOUCH_STATE');
    var branch = Blockly.Arduino.statementToCode(this, 'DO');
    Blockly.Arduino.definitions_['define_mpr121_1'] ='#include <Wire.h>\n#include "Adafruit_MPR121.h"\n';
  Blockly.Arduino.definitions_['define_mpr121_2'] ='#ifndef _BV\n#define _BV(bit) (1 << (bit)) \n#endif\n';
  Blockly.Arduino.definitions_['define_mpr121_3'] ='Adafruit_MPR121 cap = Adafruit_MPR121();';
    
  Blockly.Arduino.setups_['setup_mpr121'] = ' cap.begin(0x5A);';

    var code;
    if(touch_state==0){
        code= 'if(!(cap.touched()&_BV('+ touch +')))\n';
      code += '{\n' + branch + '\n}'; 
    }else if(touch_state==1){
        code= 'if(cap.touched()&_BV('+ touch +'))\n';
      code += '{\n' + branch + '\n}'; 
    } 
    
return code;
};

Blockly.Arduino.ruilong_ds18B20 = function () {
    var dropdown_pin = Blockly.Arduino.valueToCode(this, 'PIN', Blockly.Arduino.ORDER_ATOMIC);
    var unit = this.getFieldValue('UNIT');
    Blockly.Arduino.definitions_['include_OneWire'] = '#include <OneWire.h>';
    Blockly.Arduino.definitions_['include_DallasTemperature'] = '#include <DallasTemperature.h>';
    Blockly.Arduino.definitions_['var_OneWire_oneWire_' + dropdown_pin] = 'OneWire oneWire_' + dropdown_pin + '(' + dropdown_pin + ');';
    Blockly.Arduino.definitions_['var_DallasTemperature_sensors_' + dropdown_pin] = 'DallasTemperature sensors_' + dropdown_pin + '(&oneWire_' + dropdown_pin + ');';
    Blockly.Arduino.definitions_['var_DeviceAddress_insideThermometer'] = 'DeviceAddress insideThermometer;';
    Blockly.Arduino.setups_['setup_sensors_' + dropdown_pin + '_getAddress'] = 'sensors_' + dropdown_pin + '.getAddress(insideThermometer, 0);';
    Blockly.Arduino.setups_['setup_sensors_' + dropdown_pin + '_setResolution'] = 'sensors_' + dropdown_pin + '.setResolution(insideThermometer, 9);';
    var funcName = 'ds18b20_' + dropdown_pin + '_getTemp';
    var code = 'float' + ' ' + funcName + '(int w) {\n'
  + '  sensors_' + dropdown_pin + '.requestTemperatures();\n'
  + '  if(w==0) {\nreturn sensors_' + dropdown_pin + '.getTempC(insideThermometer);\n}\n'
  + '  else {\nreturn sensors_' + dropdown_pin + '.getTempF(insideThermometer);\n}\n'
  + '}\n';
    Blockly.Arduino.definitions_[funcName] = code;
    return ['ds18b20_' + dropdown_pin + '_getTemp(' + unit + ')', Blockly.Arduino.ORDER_ATOMIC];
};
/*
Blockly.Arduino.ruilong_GP2Y1026 = function () {
  var variable = Blockly.Arduino.variableDB_.getName(this.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  var dropdown_pin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
    var branch = Blockly.Arduino.statementToCode(this, 'DO');
  Blockly.Arduino.definitions_['include_SoftwareSerial'] = '#include <SoftwareSerial.h>';
  Blockly.Arduino.definitions_['mySerial'] = 'SoftwareSerial mySerial('+dropdown_pin'+, 11);';
  Blockly.Arduino.definitions_['rx_data'] = 'unsigned char RX_Data;//接收数据\n'
                                            += 'unsigned char flag_start,flag_stop,flag_analysis; //接收标志位\n'
                                            += 'unsigned char BUF[7];//接收缓存\n'
                                            += 'unsigned char index;//接收计数\n';

    Blockly.Arduino.setups_['setup_mySerial'] = ' mySerial.begin(2400);\n delay(1000);\n';
  
  

  var code='';

  return code;
    
};*/
//SHT20温湿度传感器
Blockly.Arduino.ruilong_SHT20 = function() {
  Blockly.Arduino.definitions_['include_Wire'] = '#include <Wire.h>';
  Blockly.Arduino.definitions_['include_DFRobot_SHT20'] = '#include <DFRobot_SHT20.h>';
  Blockly.Arduino.definitions_['var_declare_DFRobot_SHT20'] = 'DFRobot_SHT20 sht20;\n';
  Blockly.Arduino.setups_['setup_sht20initSHT20'] = 'sht20.initSHT20();';
  Blockly.Arduino.setups_['setup_sht20.checkSHT20'] = 'sht20.checkSHT20(); \n';
  var dropdown_type = this.getFieldValue('SHT20_TYPE');
  var code = dropdown_type;
  return [code, Blockly.Arduino.ORDER_ATOMIC];
};
//BMP280温度气压传感器
Blockly.Arduino.ruilong_BMP280 = function() {
  Blockly.Arduino.definitions_['include_Wire'] = '#include <Wire.h>';
  Blockly.Arduino.definitions_['include_BMP280'] = '#include "BMP280.h"';
  Blockly.Arduino.definitions_['var_declare_BMP280'] = 'BMP280 bmp;\n';
  Blockly.Arduino.setups_['setup_BMP280'] = 'bmp.begin();';

  var dropdown_type = this.getFieldValue('BMP280_TYPE');
  var code = dropdown_type;
  return [code, Blockly.Arduino.ORDER_ATOMIC];
};
//传感器_重力感应块
Blockly.Arduino.ruilong_ADXL345 = function() {
  Blockly.Arduino.definitions_['include_Wire'] = '#include <Wire.h>';
  Blockly.Arduino.definitions_['include_I2Cdev'] = '#include <I2Cdev.h>';
  Blockly.Arduino.definitions_['include_ADXL345'] = '#include <ADXL345.h>';
  Blockly.Arduino.definitions_['var_declare_ADXL345'] = 'ADXL345 accel;\n';
  Blockly.Arduino.setups_['setup_Wire.begin'] = 'Wire.begin();';
  Blockly.Arduino.setups_['setup_accel.begin'] = 'accel.initialize(); \n';
  var dropdown_type = this.getFieldValue('ADXL345_PIN');
  var code = dropdown_type;
  return [code, Blockly.Arduino.ORDER_ATOMIC];
};

//传感器_重力感应块
Blockly.Arduino.ruilong_ADXL345_setOffset = function() {
  Blockly.Arduino.definitions_['include_Wire'] = '#include <Wire.h>';
  Blockly.Arduino.definitions_['include_I2Cdev'] = '#include <I2Cdev.h>';
  Blockly.Arduino.definitions_['include_ADXL345'] = '#include <ADXL345.h>';
  Blockly.Arduino.definitions_['var_declare_ADXL345'] = 'ADXL345 accel;\n';
  Blockly.Arduino.setups_['setup_Wire.begin'] = 'Wire.begin();';
  Blockly.Arduino.setups_['setup_accel.begin'] = 'accel.initialize(); \n';

  var dropdown_type = this.getFieldValue('MIXEPI_ADXL345_OFFSET');
  var offset_value = Blockly.Arduino.valueToCode(this, 'OFFSET', Blockly.Arduino.ORDER_ATOMIC);
  var code;

  if(dropdown_type=="setOffsetX"){
   code = 'accel.setOffsetX(round('+offset_value+'*4/15.9));\n';
 }else  if(dropdown_type=="setOffsetY"){
   code = 'accel.setOffsetY(round('+offset_value+'*4/15.9));\n';
 }else if(dropdown_type=="setOffsetZ"){
   code = 'accel.setOffsetZ(round('+offset_value+'*4/15.9));\n';
 }
 
 return code;
};
//TCS34725颜色识别-获取数据
Blockly.Arduino.ruilong_TCS34725_Get_RGB = function() {
 Blockly.Arduino.definitions_['include_Wire'] = '#include <Wire.h>';
 Blockly.Arduino.definitions_['include_Adafruit_TCS34725'] = '#include <Adafruit_TCS34725.h>';
 Blockly.Arduino.definitions_['var_Adafruit_TCS34725'] = 'Adafruit_TCS34725 tcs = Adafruit_TCS34725(TCS34725_INTEGRATIONTIME_50MS, TCS34725_GAIN_4X);';
 Blockly.Arduino.definitions_['var_declare_RGB'] = 'float red, green, blue;';
 Blockly.Arduino.setups_['setup_Adafruit_TCS34725' ] = 'if (tcs.begin()) {\nSerial.println("Found sensor");\n} \nelse { \nSerial.println("No TCS34725 found ... check your connections");\nwhile (1);\n}';
 var code = "delay(60);\ntcs.getRGB(&red, &green, &blue);\n";  
 var RGB = this.getFieldValue('TCS34725_GETRGB');
 return [RGB, Blockly.Arduino.ORDER_ATOMIC];
};

//MAX30105心率血氧传感器
Blockly.Arduino.ruilong_MAX3010X_Value = function() {
 Blockly.Arduino.definitions_['include_Wire'] = '#include <Wire.h>';
 Blockly.Arduino.definitions_['include_MAX30105'] = '#include "MAX30105.h"';
 Blockly.Arduino.definitions_['MAX30105_particleSensor'] = 'MAX30105 particleSensor;';


 Blockly.Arduino.setups_['setup_particleSensor_begin' ] = 'particleSensor.begin();';
 Blockly.Arduino.setups_['setup_particleSensor_setup' ] = 'particleSensor.setup();';

 var dropdown_type = this.getFieldValue('MAX3010X_TYPE');
 var code = dropdown_type ;  

 return [code, Blockly.Arduino.ORDER_ATOMIC];
};

Blockly.Arduino.ruilong_MAX3010X_HR = function () {
    var variable = Blockly.Arduino.variableDB_.getName(this.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
    var branch = Blockly.Arduino.statementToCode(this, 'DO');

  Blockly.Arduino.definitions_['include_Wire'] = '#include <Wire.h>';
  Blockly.Arduino.definitions_['include_MAX30105'] = '#include "MAX30105.h"'
  Blockly.Arduino.definitions_['include_heartRate'] =  '#include "heartRate.h"'

  Blockly.Arduino.definitions_['MAX30105_particleSensor'] = 'MAX30105 particleSensor;';
  Blockly.Arduino.definitions_['MAX30105_var'] = 'const byte RATE_SIZE = 4; //Increase this for more averaging. 4 is good.\n'
                                               + ' byte rates[RATE_SIZE]; //Array of heart rates\n'
                                               + ' byte rateSpot = 0;\n'
                                               + ' long lastBeat = 0; //Time at which the last beat occurred\n'
                                               + ' float beatsPerMinute;\n'
                                               + ' int '+ variable+';\n';

  Blockly.Arduino.setups_['setup_MAX30105'] = 'particleSensor.begin(Wire, I2C_SPEED_FAST);\n'
                                            + '  particleSensor.setup(); //Configure sensor with default settings\n'
                                            + '  particleSensor.setPulseAmplitudeRed(0x0A); //Turn Red LED to low to indicate sensor is running\n'
                                            + '  particleSensor.setPulseAmplitudeGreen(0); //Turn off Green LED\n';
    var code = 'long irValue = particleSensor.getIR();\n'
             + 'if (checkForBeat(irValue) == true)\n'
             + '  {\n'
             + '    //We sensed a beat!\n'
             + '    long delta = millis() - lastBeat;\n'
             + '    lastBeat = millis();\n'

             + '    beatsPerMinute = 60 / (delta / 1000.0);\n'

             + '    if (beatsPerMinute < 255 && beatsPerMinute > 20)\n'
             + '    {\n'
             + '      rates[rateSpot++] = (byte)beatsPerMinute; //Store this reading in the array\n'
             + '      rateSpot %= RATE_SIZE; //Wrap variable\n'

             + '      //Take average of readings\n'
             +        variable + ' = 0;\n'
             + '      for (byte x = 0 ; x < RATE_SIZE ; x++)\n'
             +        variable + ' += rates[x];\n'
             +        variable + ' /= RATE_SIZE;\n'
             + '    }\n'
             + '  }\n'
             +branch ;
  
    return code;
};


Blockly.Arduino.ruilong_GP2Y1026 = function () {
    var variable = Blockly.Arduino.variableDB_.getName(this.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
    //Blockly.Arduino.definitions_['var_declare' + variable] = 'long ' + variable + ';';
    var dropdown_pin = Blockly.Arduino.valueToCode(this, 'PIN', Blockly.Arduino.ORDER_ATOMIC);
    var branch = Blockly.Arduino.statementToCode(this, 'DO');
   // var branch2 = Blockly.Arduino.statementToCode(this, 'DO2');
    //var varName = Blockly.Arduino.variableDB_.getName(this.getFieldValue('VAR'),Blockly.Variables.NAME_TYPE);

  Blockly.Arduino.definitions_['include_SoftwareSerial'] = '#if defined __AVR__ || defined(ESP8266)\n '
                                                         +'#include <SoftwareSerial.h>\n'
                                                         +'#elif defined (ESP32)\n'
                                                         +'#include <ESP32SoftwareSerial.h>\n'
                                                         +'#endif\n';
  Blockly.Arduino.definitions_['GP2Y1026_mySerial'] = '#if defined __AVR__ || defined(ESP8266) \n'
                                                      +'SoftwareSerial mySerial('+dropdown_pin+', 50);\n'
                                                      +'#elif defined (ESP32)\n'
                                                      +'ESP32SoftwareSerial mySerial('+dropdown_pin+', 50);\n'
                                                      +'#endif\n';

  Blockly.Arduino.definitions_['rx_data'] = 'unsigned char RX_Data;//接收数据\n'
                                            + 'unsigned char flag_start,flag_stop,flag_analysis; //接收标志位\n'
                                            + 'unsigned char BUF[7];//接收缓存\n'
                                            + 'unsigned char index_;//接收计数\n'
                                            + 'unsigned int '+variable+';\n';
    Blockly.Arduino.setups_['setup_mySerial'] = 'mySerial.begin(2400);\n'
                                              + '  delay(1000);\n';
  
    var code = 'if ( mySerial.available()>0){  \n'
             + ' RX_Data=mySerial.read();\n'
             + 'if(RX_Data==0xAA) //判断帧头\n'
             + '  flag_start=1; //帧头1标志位置位\n'
             + ' if(flag_start) //当帧头1标志位置位后\n'
             + '  {\n'
             + '    if(flag_analysis==0) //判断帧头2 且数据分析开始\n'
             + '    {\n'
             + '     flag_start=1; //帧头2标志位置位\n'
             + '    flag_stop=0;//停止位标志位清零 \n'  
             + '    }\n'
             + '   if(flag_start) //当帧头2标志位置位后\n'
             + '   {\n'
             + '    BUF[index_++]=RX_Data;//依次传输数据\n'
             + '    if(RX_Data==0xff)//判断后\n'
             + '   {  \n'
             + '      flag_start=0;//帧头1标志位清零\n'
             + '      flag_stop=1;//停止位标志位置位\n'
             + '       flag_analysis=1; \n'
             + '       index_=0;\n'
             + '   }\n'
             + '   }\n'
             + ' }\n'
             + ' if(flag_analysis==1) //提取到每一帧数据，进行判断控制\n'
             + ' {\n'
             + '   if((BUF[1]+BUF[2]+BUF[3]+BUF[4])%256==BUF[5]){\n'
             + '   unsigned int Vout=BUF[1]<<8|BUF[2];\n'
             + '   unsigned int Vref=BUF[3]<<8|BUF[4];\n'
             + '   //float Vout_mv=Vout / 1024.0 * 5000.0;\n'
             + '   float a=Vout*1.395; /// 1024.0 * 5.0*100.0 / 0.35;\n'
             +    variable+'=(int)a;\n'
             + branch            
             +'    }\n'
             +'    flag_analysis=0; //分析处理结束\n'
             +' }\n'
             +' } '
  
    return code;
};




//LCD1602显示模块 
Blockly.Arduino.ruilong_LCD1602_Print = function() {
  var varName = this.getFieldValue('VAR');
  var str1 = Blockly.Arduino.valueToCode(this, 'TEXT', Blockly.Arduino.ORDER_ATOMIC) || '\"\"';
  var str2 = Blockly.Arduino.valueToCode(this, 'TEXT2', Blockly.Arduino.ORDER_ATOMIC) || '\"\"';
  var device = Blockly.Arduino.valueToCode(this, 'device', Blockly.Arduino.ORDER_ATOMIC) || '0x27';
  Blockly.Arduino.definitions_['include_Wire'] = '#include <Wire.h>';
  Blockly.Arduino.definitions_['include_LiquidCrystal_I2C'] = '#include <LiquidCrystal_I2C.h>';
  Blockly.Arduino.definitions_['var_LiquidCrystal_I2C_'+varName] = 'LiquidCrystal_I2C '+varName+'('+device+',16,2);';
  if (Blockly.Arduino.definitions_['var_LiquidCrystal_SoftI2C_' + varName] || Blockly.Arduino.definitions_['var_LiquidCrystal_I2C_' + varName]) {
      Blockly.Arduino.setups_['setup_lcd_init_' + varName] = varName + '.init();';
      Blockly.Arduino.setups_['setup_lcd_backlight_' + varName] = varName + '.backlight();';
  }
  var code = varName+'.setCursor(0, 0);\n'
  code+=varName+'.print('+str1+');\n';
  code+=varName+'.setCursor(0, 1);\n';
  code+=varName+'.print('+str2+');\n';  
  return code;
};
Blockly.Arduino.ruilong_LCD1602_Print2 = function() {
  var varName = this.getFieldValue('VAR');
  var str = Blockly.Arduino.valueToCode(this, 'TEXT', Blockly.Arduino.ORDER_ATOMIC) || 'String(\"\")';
  var row = Blockly.Arduino.valueToCode(this, 'row', Blockly.Arduino.ORDER_ATOMIC) || '1';
  var column = Blockly.Arduino.valueToCode(this, 'column', Blockly.Arduino.ORDER_ATOMIC) || '1';
  if (Blockly.Arduino.definitions_['var_LiquidCrystal_SoftI2C_' + varName] || Blockly.Arduino.definitions_['var_LiquidCrystal_I2C_' + varName]) {
      Blockly.Arduino.setups_['setup_lcd_init_' + varName] = varName + '.init();';
      Blockly.Arduino.setups_['setup_lcd_backlight_' + varName] = varName + '.backlight();';
  }
  var code = varName+'.setCursor('+column+'-1, '+row+'-1);\n'
  code+=varName+'.print('+str+');\n';
  return code;
};
Blockly.Arduino.ruilong_LCD1602_Power = function() {
  var varName = this.getFieldValue('VAR');
  var dropdown_stat = this.getFieldValue('STAT');
  if (Blockly.Arduino.definitions_['var_LiquidCrystal_SoftI2C_' + varName] || Blockly.Arduino.definitions_['var_LiquidCrystal_I2C_' + varName]) {
      Blockly.Arduino.setups_['setup_lcd_init_' + varName] = varName + '.init();';
      Blockly.Arduino.setups_['setup_lcd_backlight_' + varName] = varName + '.backlight();';
  }
  var code = varName+'.'+dropdown_stat+'();\n'
  return code;
};
//RGB彩灯模块（含灯带，点阵，环形灯等）
Blockly.Arduino.ruilong_rgb_init=function(){
    var dropdown_rgbpin = Blockly.Arduino.valueToCode(this, 'PIN', Blockly.Arduino.ORDER_ATOMIC);
    var value_ledcount = Blockly.Arduino.valueToCode(this, 'LEDCOUNT', Blockly.Arduino.ORDER_ATOMIC);

    Blockly.Arduino.definitions_['include_Adafruit_NeoPixel'] = '#include <Adafruit_NeoPixel.h>';
    Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin] = 'Adafruit_NeoPixel  rgb_display_' + dropdown_rgbpin + '('+ value_ledcount +','+ dropdown_rgbpin +', NEO_GRB + NEO_KHZ800);';
    Blockly.Arduino.setups_['setup_rgb_display_begin_' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.begin();';
    //Blockly.Arduino.setups_['setup_rgb_display_setpin' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.setPin(' + dropdown_rgbpin + ');';
    return '';
};
Blockly.Arduino.ruilong_rgb_brightness = function(){
    var dropdown_rgbpin = Blockly.Arduino.valueToCode(this, 'PIN', Blockly.Arduino.ORDER_ATOMIC);
    var value_brightness = Blockly.Arduino.valueToCode(this, 'NUM', Blockly.Arduino.ORDER_ATOMIC);  
  var code = 'rgb_display_'+dropdown_rgbpin+'.setBrightness('+value_brightness+');';
    return code;
};

Blockly.Arduino.ruilong_rgb=function(){
  var dropdown_rgbpin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var value__led_ = Blockly.Arduino.valueToCode(this, '_LED_', Blockly.Arduino.ORDER_ATOMIC);
  var value_rvalue = Blockly.Arduino.valueToCode(this, 'RVALUE', Blockly.Arduino.ORDER_ATOMIC);
  var value_gvalue = Blockly.Arduino.valueToCode(this, 'GVALUE', Blockly.Arduino.ORDER_ATOMIC);
  var value_bvalue = Blockly.Arduino.valueToCode(this, 'BVALUE', Blockly.Arduino.ORDER_ATOMIC);
  Blockly.Arduino.definitions_['include_Adafruit_NeoPixel'] = '#include <Adafruit_NeoPixel.h>';
  Blockly.Arduino.definitions_['var_rgb_ruilong'+dropdown_rgbpin] = 'Adafruit_NeoPixel  rgb_ruilong_'+dropdown_rgbpin+'(4,'+ dropdown_rgbpin +', NEO_GRB + NEO_KHZ800);';
  Blockly.Arduino.setups_['setup_rgb_ruilong_begin_'+dropdown_rgbpin] ='rgb_ruilong_'+dropdown_rgbpin+'.begin();';
  //Blockly.Arduino.setups_['setup_rgb_ruilong_setpin'+dropdown_rgbpin] ='rgb_ruilong_'+dropdown_rgbpin+'.setPin('+dropdown_rgbpin+');';
  
  var code = 'rgb_ruilong_'+dropdown_rgbpin+'.setPixelColor('+value__led_+'-1, '+value_rvalue+','+value_gvalue+','+value_bvalue+');\n';
  code+='rgb_ruilong_'+dropdown_rgbpin+'.show();\n';
  return code;
};

Blockly.Arduino.ruilong_rgb2=function(){
  var dropdown_rgbpin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var value_led = Blockly.Arduino.valueToCode(this, '_LED_', Blockly.Arduino.ORDER_ATOMIC);
  var color = goog.color.hexToRgb(this.getFieldValue('RGB_LED_COLOR'));
    //Blockly.Arduino.definitions_['include_Wire'] = '#include <Wire.h>';
    Blockly.Arduino.definitions_['include_Adafruit_NeoPixel'] = '#include <Adafruit_NeoPixel.h>';
   if (!Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin]) {
      Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin] = 'Adafruit_NeoPixel  rgb_display_' + dropdown_rgbpin + '(4,'+ dropdown_rgbpin +', NEO_GRB + NEO_KHZ800);';
      Blockly.Arduino.setups_['setup_rgb_display_begin_' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.begin();';

  }
  var code = 'rgb_display_'+dropdown_rgbpin+'.setPixelColor('+value_led+'-1, '+color+');\n';
  code+='rgb_display_'+dropdown_rgbpin+'.show();\n';
  return code;
};

Blockly.Arduino.ruilong_rgb3=function(){
  var dropdown_rgbpin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var wait_time = Blockly.Arduino.valueToCode(this, 'WAIT',Blockly.Arduino.ORDER_ATOMIC);
  var value_brightness = Blockly.Arduino.valueToCode(this, 'NUM', Blockly.Arduino.ORDER_ATOMIC);
    Blockly.Arduino.definitions_['include_Adafruit_NeoPixel'] = '#include <Adafruit_NeoPixel.h>';
   if (!Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin]) {
      Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin] = 'Adafruit_NeoPixel  rgb_display_' + dropdown_rgbpin + '(25,'+ dropdown_rgbpin +', NEO_GRB + NEO_KHZ800);';
      Blockly.Arduino.setups_['setup_rgb_display_begin_' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.begin();';
     '(25,'+ dropdown_rgbpin +', NEO_GRB + NEO_KHZ800);';
    Blockly.Arduino.setups_['setup_rgb_display_setBrightness' + dropdown_rgbpin]  = 'rgb_display_'+dropdown_rgbpin+'.setBrightness('+value_brightness+');';
  }
  var funcName2 = 'Wheel';
  var code2  = 'uint32_t Wheel(byte WheelPos) {\n';
      code2 += 'if(WheelPos < 85) {return rgb_display_'+dropdown_rgbpin+'.Color(WheelPos * 3, 255 - WheelPos * 3, 0);} \n';
      code2 += 'else if(WheelPos < 170) {WheelPos -= 85; return rgb_display_'+dropdown_rgbpin+'.Color(255 - WheelPos * 3, 0, WheelPos * 3);}\n ';
    code2 += 'else {WheelPos -= 170;return rgb_display_'+dropdown_rgbpin+'.Color(0, WheelPos * 3, 255 - WheelPos * 3);}\n';
      code2 += '}\n';
  Blockly.Arduino.definitions_[funcName2] = code2;
  
  var funcName3 = 'rainbow';
  var code3  = 'void rainbow(uint8_t wait) { uint16_t i, j;\n';
      code3 += '      for(j=0; j<256; j++) {               \n';
      code3 += '        for(i=0; i<rgb_display_'+dropdown_rgbpin+'.numPixels(); i++) {\n';
      code3 += '         rgb_display_'+dropdown_rgbpin+'.setPixelColor(i, Wheel((i+j) & 255));}\n';                    
      code3 += '      rgb_display_'+dropdown_rgbpin+'.show();\n';
      code3 += '      delay(wait);}}\n';
  
  Blockly.Arduino.definitions_[funcName3] = code3;
  
  var code = 'rainbow('+ wait_time+');\n'
  return code;
};

Blockly.Arduino.ruilong_rgb4=function(){
  var dropdown_rgbpin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var wait_time = Blockly.Arduino.valueToCode(this, 'WAIT',Blockly.Arduino.ORDER_ATOMIC);
  var value_brightness = Blockly.Arduino.valueToCode(this, 'NUM', Blockly.Arduino.ORDER_ATOMIC);
    Blockly.Arduino.definitions_['include_Adafruit_NeoPixel'] = '#include <Adafruit_NeoPixel.h>';
   if (!Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin]) {
      Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin] = 'Adafruit_NeoPixel  rgb_display_' + dropdown_rgbpin + '(25,'+ dropdown_rgbpin +', NEO_GRB + NEO_KHZ800);';
      Blockly.Arduino.setups_['setup_rgb_display_begin_' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.begin();';
      
    Blockly.Arduino.setups_['setup_rgb_display_setBrightness' + dropdown_rgbpin]  = 'rgb_display_'+dropdown_rgbpin+'.setBrightness('+value_brightness+');';
  }
  var funcName2 = 'Wheel';
  var code2  = 'uint32_t Wheel(byte WheelPos) {\n';
      code2 += 'if(WheelPos < 85) {return rgb_display_'+dropdown_rgbpin+'.Color(WheelPos * 3, 255 - WheelPos * 3, 0);} \n';
      code2 += 'else if(WheelPos < 170) {WheelPos -= 85; return rgb_display_'+dropdown_rgbpin+'.Color(255 - WheelPos * 3, 0, WheelPos * 3);}\n ';
    code2 += 'else {WheelPos -= 170;return rgb_display_'+dropdown_rgbpin+'.Color(0, WheelPos * 3, 255 - WheelPos * 3);}\n';
      code2 += '}\n';
  Blockly.Arduino.definitions_[funcName2] = code2;
  
  var funcName3 = 'rainbow';
  var code3  = 'void rainbow(uint8_t wait) { uint16_t i, j;\n';
      code3 += '      for(j=0; j<256; j++) {               \n';
      code3 += '        for(i=0; i<rgb_display_'+dropdown_rgbpin+'.numPixels(); i++) {\n';
      code3 += '         rgb_display_'+dropdown_rgbpin+'.setPixelColor(i, Wheel((i+j) & 255));}\n';                    
      code3 += '      rgb_display_'+dropdown_rgbpin+'.show();\n';
      code3 += '      delay(wait);}}\n';
  
  Blockly.Arduino.definitions_[funcName3] = code3;
  
   var funcName4 = 'rainbowCycle';
   var code4  = 'void rainbowCycle(uint8_t wait) {uint16_t i, j;\n';
       code4 += '    for(j=0; j<256*5; j++) { // 5 cycles of all colors on wheel\n';
       code4 += '      for(i=0; i< rgb_display_'+dropdown_rgbpin+'.numPixels(); i++) {\n';
       code4 += '        rgb_display_'+dropdown_rgbpin+'.setPixelColor(i, Wheel(((i * 256 / rgb_display_'+dropdown_rgbpin+'.numPixels()) + j) & 255));}\n';
       code4 += '     rgb_display_'+dropdown_rgbpin+'.show();\n';
       code4 += '     delay(wait);}}\n';
  
   Blockly.Arduino.definitions_[funcName4] = code4;

  var code = 'rainbowCycle('+ wait_time+');\n'
  return code;
};






Blockly.Arduino.ruilong_tm1650_power=function(){
  var stat=this.getFieldValue("STAT");
   Blockly.Arduino.definitions_['dinclude_Wire'] = '#include <Wire.h>';
  Blockly.Arduino.definitions_['include_TM1650'] = '#include <TM1650.h>';
  Blockly.Arduino.definitions_['var_ruilong_4display'] = 'TM1650 ruilong_4display;';
  Blockly.Arduino.setups_['setup_wire_begin'] ='Wire.begin();';
  Blockly.Arduino.setups_['setup_ruilong_4display_init'] ='ruilong_4display.init();';
  return 'ruilong_4display.'+stat+'();\n';
};
Blockly.Arduino.ruilong_tm1650_displayString=function(){
  var value = Blockly.Arduino.valueToCode(this, 'VALUE', Blockly.Arduino.ORDER_ATOMIC);
   Blockly.Arduino.definitions_['dinclude_Wire'] = '#include <Wire.h>';
  Blockly.Arduino.definitions_['include_TM1650'] = '#include <TM1650.h>';
  Blockly.Arduino.definitions_['var_ruilong_4display'] = 'TM1650 ruilong_4display;';
  Blockly.Arduino.setups_['setup_wire_begin'] ='Wire.begin();';
  Blockly.Arduino.setups_['setup_ruilong_4display_init'] ='ruilong_4display.init();';
  return 'ruilong_4display.displayString('+value+');\n';
};
Blockly.Arduino.ruilong_tm1650_showDot=function(){
  var no=this.getFieldValue("NO");
  var stat=this.getFieldValue("STAT");
   Blockly.Arduino.definitions_['dinclude_Wire'] = '#include <Wire.h>';
    Blockly.Arduino.definitions_['include_TM1650'] = '#include <TM1650.h>';
  Blockly.Arduino.definitions_['var_ruilong_4display'] = 'TM1650 ruilong_4display;';
  Blockly.Arduino.setups_['setup_wire_begin'] ='Wire.begin();';
  Blockly.Arduino.setups_['setup_ruilong_4display_init'] ='ruilong_4display.init();';
  return 'ruilong_4display.setDot('+no+','+stat+');\n';
};
//显示-TM1637-初始化
Blockly.Arduino.ruilong_tm1637_init = function() {
  var CLK = Blockly.Arduino.valueToCode(this, 'PIN1', Blockly.Arduino.ORDER_ATOMIC);
  var DIO = Blockly.Arduino.valueToCode(this, 'PIN2', Blockly.Arduino.ORDER_ATOMIC);
  Blockly.Arduino.definitions_['include_tm1637'] = '#include <SevenSegmentTM1637.h>';
  Blockly.Arduino.definitions_['var_tm1637'] = 'SevenSegmentTM1637 display(' + CLK + ',' + DIO + ');';
  Blockly.Arduino.setups_['setup_tm1637_init'] = '  display.begin();\ndelay(1000); ';
  return '';
};

//显示-TM1637-显示字符串（字符，数值、变量）
Blockly.Arduino.ruilong_tm1637_displayString = function() {

  var value = Blockly.Arduino.valueToCode(this, 'VALUE', Blockly.Arduino.ORDER_ATOMIC);
  var code = 'display.clear();\n display.print('+value+');\n ';
  return code;
};

//显示-TM1637-显示时间
Blockly.Arduino.ruilong_tm1637_displayTime = function() {
  var CLK = Blockly.Arduino.valueToCode(this, 'PIN1', Blockly.Arduino.ORDER_ATOMIC);
  var DIO = Blockly.Arduino.valueToCode(this, 'PIN2', Blockly.Arduino.ORDER_ATOMIC);
  var value = Blockly.Arduino.valueToCode(this, 'VALUE', Blockly.Arduino.ORDER_ATOMIC);
  var hour = Blockly.Arduino.valueToCode(this, 'hour', Blockly.Arduino.ORDER_ATOMIC);
  var minute = Blockly.Arduino.valueToCode(this, 'minute', Blockly.Arduino.ORDER_ATOMIC);

//  Blockly.Arduino.definitions_['var_tm1637'] = 'SevenSegmentExtended display(' + CLK + ',' + DIO + ');';
var code = '  byte hours ='+hour+';\n';
code+='  byte minutes  = '+ minute+';\n';
code+='  byte second  = 0;\n';
code+='for (; hours < 24; hours++)\n{\nfor ( ; minutes < 60; minutes++)\n{\nfor ( ; second < 60; second++)\n{\ndisplay.printTime(hours, minutes, true);\n}\nsecond=0;\n}\nminutes = 0;\n}\n';
return code;
};

//显示-TM1637-设置亮度
Blockly.Arduino.ruilong_tm1637_Brightness = function() {
  var BRIGHTNESS = Blockly.Arduino.valueToCode(this, 'BRIGHTNESS', Blockly.Arduino.ORDER_ASSIGNMENT) || '0';
// var BRIGHTNESS = this.getFieldValue('BRIGHTNESS');
var code = '  display.setBacklight(' + BRIGHTNESS + ');\n';
return code;
};
Blockly.Arduino.ruilong_display_Matrix_DisplayChar = function() {

  var dropdown_rgbpin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var dotMatrixArray = Blockly.Arduino.valueToCode(this, 'RGBArray', Blockly.Arduino.ORDER_ASSIGNMENT);
  var value_brightness = Blockly.Arduino.valueToCode(this, 'NUM', Blockly.Arduino.ORDER_ATOMIC);
  Blockly.Arduino.definitions_['include_Adafruit_NeoPixel'] = '#include <Adafruit_NeoPixel.h>';
  //Blockly.Arduino.definitions_['RGBArray'] = 'uint8_t  RGBArray[16][3];';
  if (!Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin]) {
      Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin] = 'Adafruit_NeoPixel  rgb_display_' + dropdown_rgbpin +'(25,'+ dropdown_rgbpin +', NEO_GRB + NEO_KHZ800);';
      Blockly.Arduino.setups_['setup_rgb_display_begin_' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.begin();';
      Blockly.Arduino.setups_['setup_rgb_display_setpin' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.setPin(' + dropdown_rgbpin + ');';
      Blockly.Arduino.setups_['setup_rgb_display_setBrightness' + dropdown_rgbpin]  = 'rgb_display_'+dropdown_rgbpin+'.setBrightness('+value_brightness+');';
  }
  var code='rgb_display_'+dropdown_rgbpin+'.setBrightness('+value_brightness+');\n';
  code+='for(int i=0; i<25; i++)\n';
  code+='{\n'
  code+='rgb_display_'+dropdown_rgbpin+'.setPixelColor(i, '+dotMatrixArray+'[i][0],'+dotMatrixArray+'[i][1],'+dotMatrixArray+'[i][2]);\n';
  code+='}\n'
  code+='rgb_display_'+dropdown_rgbpin+'.show();\n';
  code+='delay(100);\n';
  return code;
};

Blockly.Arduino.ruilong_display_Matrix_LedArray = function() {
  var varName = this.getFieldValue('VAR');
  var code = '{';
  for (var i = 1; i < 6; i++) {    
    for (var j = 1; j < 6; j++) {
    code +='\n          {';
      code += goog.color.hexToRgb(this.getFieldValue('RGB_' + i + j));
    code +='}';
     if (i==5&&j==5) {} else code +=',' 
    }  
   }
    code += '};'; 
  Blockly.Arduino.definitions_[varName] = "uint8_t  " + varName + "[25][3]=" + code;
  return [varName, Blockly.Arduino.ORDER_ATOMIC]; 
}
Blockly.Arduino.ruilong_display_Matrix_DisplayLedBar = function() {

  var dropdown_rgbpin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var dotMatrixArray = Blockly.Arduino.valueToCode(this, 'RGBArray', Blockly.Arduino.ORDER_ASSIGNMENT);
  var value_brightness = Blockly.Arduino.valueToCode(this, 'NUM', Blockly.Arduino.ORDER_ATOMIC);
  Blockly.Arduino.definitions_['include_Adafruit_NeoPixel'] = '#include <Adafruit_NeoPixel.h>';
  //Blockly.Arduino.definitions_['RGBArray'] = 'uint8_t  RGBArray[16][3];';
  if (!Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin]) {
      Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin] = 'Adafruit_NeoPixel  rgb_display_' + dropdown_rgbpin + '(5,'+ dropdown_rgbpin +', NEO_GRB + NEO_KHZ800);';
      Blockly.Arduino.setups_['setup_rgb_display_begin_' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.begin();';
      Blockly.Arduino.setups_['setup_rgb_display_setpin' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.setPin(' + dropdown_rgbpin + ');';
      Blockly.Arduino.setups_['setup_rgb_display_setBrightness' + dropdown_rgbpin]  = 'rgb_display_'+dropdown_rgbpin+'.setBrightness('+value_brightness+');';
  }
  var code='rgb_display_'+dropdown_rgbpin+'.setBrightness('+value_brightness+');\n';
  code+='for(int i=0; i<5; i++)\n';
  code+='{\n'
  code+='rgb_display_'+dropdown_rgbpin+'.setPixelColor(i, '+dotMatrixArray+'[i][0],'+dotMatrixArray+'[i][1],'+dotMatrixArray+'[i][2]);\n';
  code+='}\n'
  code+='rgb_display_'+dropdown_rgbpin+'.show();\n';
  code+='delay(100);\n';
  return code;
};
Blockly.Arduino.ruilong_display_Matrix_LedBar = function() {
  var varName = this.getFieldValue('VAR');
  var code = '{';
    for (var j = 1; j < 6; j++) {
    code +='\n          {';
      code += goog.color.hexToRgb(this.getFieldValue('RGB_' + j));
    code +='}';
     if (j==5) {} else code +=',' 
    }  
    code += '};'; 
  Blockly.Arduino.definitions_[varName] = "uint8_t  " + varName + "[5][3]=" + code;
  return [varName, Blockly.Arduino.ORDER_ATOMIC]; 
}

Blockly.Arduino.ruilong_display_Matrix_DisplayChar2 = function() {

  var dropdown_rgbpin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var dotMatrixArray = Blockly.Arduino.valueToCode(this, 'RGBArray_dot', Blockly.Arduino.ORDER_ASSIGNMENT);
  var value_brightness = Blockly.Arduino.valueToCode(this, 'NUM', Blockly.Arduino.ORDER_ATOMIC);
  var color= goog.color.hexToRgb(this.getFieldValue('RGB_DOT_COLOR'));
  
 // Blockly.Arduino.definitions_['rgb_color'] = "uint8_t  rgb_color[3]={" + color+'}\n;';


  Blockly.Arduino.definitions_['include_Adafruit_NeoPixel'] = '#include <Adafruit_NeoPixel.h>';

  if (!Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin]) {
      Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin] = 'Adafruit_NeoPixel  rgb_display_' + dropdown_rgbpin  + '(25,'+ dropdown_rgbpin +', NEO_GRB + NEO_KHZ800);';
      Blockly.Arduino.setups_['setup_rgb_display_begin_' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.begin();';
      Blockly.Arduino.setups_['setup_rgb_display_setpin' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.setPin(' + dropdown_rgbpin + ');';
      Blockly.Arduino.setups_['setup_rgb_display_setBrightness' + dropdown_rgbpin]  = 'rgb_display_'+dropdown_rgbpin+'.setBrightness('+value_brightness+');';
  }
  var code='rgb_display_'+dropdown_rgbpin+'.setBrightness('+value_brightness+');\n';
  code+='for(int i=0; i<25; i++)\n';
  code+='{\n'
  code+='rgb_display_'+dropdown_rgbpin+'.setPixelColor(i, '+dotMatrixArray+'[i]*'+color[0]+','+dotMatrixArray+'[i]*'+color[1]+','+dotMatrixArray+'[i]*'+color[2]+');\n';
  code+='}\n'
  code+='rgb_display_'+dropdown_rgbpin+'.show();\n';
  code+='delay(100);\n';
  return code;
};

Blockly.Arduino.ruilong_display_Matrix_LedArray2 = function() {
  var varName = this.getFieldValue('VAR');
  //var RGB_ = new Array();
  var code = '{';
  for (var i = 1; i < 6; i++) {    
    for (var j = 1; j < 6; j++) {
    code +='';
      code += (this.getFieldValue('DOT_' + i + j) == "TRUE") ? 1 : 0;
    code +='';
     if (i==5&&j==5) {} else code +=',' 
    }  
   }
    code += '};';
  
  //Blockly.Arduino.definitions_[this.id] = "byte LedArray_"+clearString(this.id)+"[]="+code;
  Blockly.Arduino.definitions_[varName] = "uint8_t  " + varName + "[25]=" + code;
  //return ["LedArray_"+clearString(this.id), Blockly.Arduino.ORDER_ATOMIC];
  return [varName, Blockly.Arduino.ORDER_ATOMIC]; 
}
Blockly.Arduino.ruilong_display_Matrix_DisplayBar2 = function() {

  var dropdown_rgbpin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var dotMatrixArray = Blockly.Arduino.valueToCode(this, 'RGBArray_dot', Blockly.Arduino.ORDER_ASSIGNMENT);
  var value_brightness = Blockly.Arduino.valueToCode(this, 'NUM', Blockly.Arduino.ORDER_ATOMIC);
  var color= goog.color.hexToRgb(this.getFieldValue('RGB_DOT_COLOR'));
  
 // Blockly.Arduino.definitions_['rgb_color'] = "uint8_t  rgb_color[3]={" + color+'}\n;';


  Blockly.Arduino.definitions_['include_Adafruit_NeoPixel'] = '#include <Adafruit_NeoPixel.h>';

  if (!Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin]) {
      Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin] = 'Adafruit_NeoPixel  rgb_display_' + dropdown_rgbpin + '(5,'+ dropdown_rgbpin +', NEO_GRB + NEO_KHZ800);';
      Blockly.Arduino.setups_['setup_rgb_display_begin_' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.begin();';
      Blockly.Arduino.setups_['setup_rgb_display_setpin' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.setPin(' + dropdown_rgbpin + ');';
      Blockly.Arduino.setups_['setup_rgb_display_setBrightness' + dropdown_rgbpin]  = 'rgb_display_'+dropdown_rgbpin+'.setBrightness('+value_brightness+');';
  }
  var code='';
  code+='for(int i=0; i<5; i++)\n';
  code+='{\n'
  code+='rgb_display_'+dropdown_rgbpin+'.setPixelColor(i, '+dotMatrixArray+'[i]*'+color[0]+','+dotMatrixArray+'[i]*'+color[1]+','+dotMatrixArray+'[i]*'+color[2]+');\n';
  code+='}\n'
  code+='rgb_display_'+dropdown_rgbpin+'.show();\n';
  code+='delay(100);\n';
  return code;
};

Blockly.Arduino.ruilong_display_Matrix_LedBar2 = function() {
  var varName = this.getFieldValue('VAR');
  //var RGB_ = new Array();
  var code = '{';
 
    for (var j = 1; j < 6; j++) {
    code +='';
      code += (this.getFieldValue('DOT_'  + j) == "TRUE") ? 1 : 0;
    code +='';
     if (j==5) {} else code +=',' 
    }  
    code += '};';
  
  //Blockly.Arduino.definitions_[this.id] = "byte LedArray_"+clearString(this.id)+"[]="+code;
  Blockly.Arduino.definitions_[varName] = "uint8_t  " + varName + "[5]=" + code;
  //return ["LedArray_"+clearString(this.id), Blockly.Arduino.ORDER_ATOMIC];
  return [varName, Blockly.Arduino.ORDER_ATOMIC]; 
}

Blockly.Arduino.ruilong_display_Matrix_CLEAR = function() {

  var dropdown_rgbpin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var dotMatrixArray = Blockly.Arduino.valueToCode(this, 'RGBArray', Blockly.Arduino.ORDER_ASSIGNMENT);
  Blockly.Arduino.definitions_['include_Adafruit_NeoPixel'] = '#include <Adafruit_NeoPixel.h>';

  if (!Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin]) {
      Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin] = 'Adafruit_NeoPixel  rgb_display_' + dropdown_rgbpin + '(25,'+ dropdown_rgbpin +', NEO_GRB + NEO_KHZ800);';
      Blockly.Arduino.setups_['setup_rgb_display_begin_' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.begin();';
      Blockly.Arduino.setups_['setup_rgb_display_setpin' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.setPin(' + dropdown_rgbpin + ');';
  }
  var code='';
  code+='for(int i=0; i<25; i++)\n';
  code+='{\n'
  code+='rgb_display_'+dropdown_rgbpin+'.setPixelColor(i, 0,0,0);\n';
  code+='}\n'
  code+='rgb_display_'+dropdown_rgbpin+'.show();\n';
  code+='delay(100);\n';
  return code;
};


Blockly.Arduino.ruilong_88display_Matrix_blink_rate = function() {
  var matrixName = this.getFieldValue('matrixName');
  var BLINK_RATE = Blockly.Arduino.valueToCode(this, 'Blink_rate', Blockly.Arduino.ORDER_ATOMIC);
  Blockly.Arduino.definitions_['include_RL_HT16K33'] = '#include <RL_HT16K33.h>';                 
  Blockly.Arduino.definitions_[matrixName] =  'HT16K33  '+ matrixName +'; ';
  Blockly.Arduino.setups_['setup_' + matrixName] = matrixName + '.begin(0x70); \n';
  var code = '';
  code += matrixName +'.blinkRate('+BLINK_RATE+');\n';
  return code;
};
//辅助块_点阵屏_清除显示
Blockly.Arduino.ruilong_88display_Matrix_brightness = function() {
  var matrixName = this.getFieldValue('matrixName');
  var BRIGHTNESS = Blockly.Arduino.valueToCode(this, 'Brightness', Blockly.Arduino.ORDER_ATOMIC);
  Blockly.Arduino.definitions_['include_RL_HT16K33'] = '#include <RL_HT16K33.h>';                 
  Blockly.Arduino.definitions_[matrixName] =  'HT16K33  '+ matrixName +'; ';
  Blockly.Arduino.setups_['setup_' + matrixName] = matrixName + '.begin(0x70); \n';
  var code = '';
  code += matrixName +'.setBrightness('+BRIGHTNESS+');\n';
  return code;
};
Blockly.Arduino.ruilong_88display_Matrix_POS = function() {
  var pos_x = Blockly.Arduino.valueToCode(this, 'XVALUE', Blockly.Arduino.ORDER_ASSIGNMENT);
  var pos_y = Blockly.Arduino.valueToCode(this, 'YVALUE', Blockly.Arduino.ORDER_ASSIGNMENT);
  var matrixName = this.getFieldValue('matrixName');
  var dropdown_type = this.getFieldValue('DrawPixel_TYPE');
  
  Blockly.Arduino.definitions_['include_RL_HT16K33'] = '#include <RL_HT16K33.h>';                 
  Blockly.Arduino.definitions_[matrixName] =  'HT16K33  '+ matrixName +'; ';
  Blockly.Arduino.setups_['setup_' + matrixName] = matrixName + '.begin(0x70); \n';
  
  var code = matrixName + '.drawPixel('+pos_x+'-1,'+pos_y+'-1,'+dropdown_type+');\n'
      code+= matrixName + '.writeDisplay();\n';
  return code;
};

Blockly.Arduino.ruilong_88display_Matrix_Rotation = function() {
  var matrixName = this.getFieldValue('matrixName');
  var dropdown_type = this.getFieldValue('Rotation_TYPE');
  Blockly.Arduino.definitions_['include_RL_HT16K33'] = '#include <RL_HT16K33.h>';                 
  Blockly.Arduino.definitions_[matrixName] =  'HT16K33  '+ matrixName +'; ';
  Blockly.Arduino.setups_['setup_' + matrixName] = matrixName + '.begin(0x70); \n';
  
  var code = matrixName + '.setHf_flip('+dropdown_type+');\n'
  return code;
};
Blockly.Arduino.ruilong_88display_Matrix_TEXT = function() {
  var matrixName = this.getFieldValue('matrixName');
  var textString = Blockly.Arduino.valueToCode(this, 'TEXT', Blockly.Arduino.ORDER_ASSIGNMENT);
  Blockly.Arduino.definitions_['include_RL_HT16K33'] = '#include <RL_HT16K33.h>';                 
  Blockly.Arduino.definitions_[matrixName] =  'HT16K33  '+ matrixName +'; ';
  Blockly.Arduino.setups_['setup_' + matrixName] = matrixName + '.begin(0x70); \n';
  var code = matrixName + '.drawStr('+textString+');\n'
  return code;
};
//执行器_点阵屏显示_显示图案
Blockly.Arduino.ruilong_88display_Matrix_DisplayChar = function() {
  var matrixName = this.getFieldValue('matrixName');
  var dotMatrixArray = Blockly.Arduino.valueToCode(this, 'LEDArrayX', Blockly.Arduino.ORDER_ASSIGNMENT);
  Blockly.Arduino.definitions_['include_RL_HT16K33'] = '#include <RL_HT16K33.h>';                 
  Blockly.Arduino.definitions_[matrixName] =  'HT16K33  '+ matrixName +'; ';
  Blockly.Arduino.setups_['setup_' + matrixName] = matrixName + '.begin(0x70); \n';


  Blockly.Arduino.definitions_['LEDArray'] = 'uint8_t  LEDArray[8];';
  var code='';
  code+='for(int i=0; i<8; i++)\n';
  code+='{\n'
  code+='  LEDArray[i]='+dotMatrixArray+'[i];\n';
  code+='  for(int j=0; j<8; j++)\n'
  code+='  {\n'
  code+='    if((LEDArray[i]&0x01)>0)\n';
  code+='    '+ matrixName +'.drawPixel(j, i,1);\n';
  code+='    LEDArray[i] = LEDArray[i]>>1;\n';
  code+='  }  \n'
  code+='}\n'
  code+= matrixName+'.writeDisplay();\n'
  return code;
};

//执行器_点阵屏显示_显示图案
Blockly.Arduino.ruilong_816display_Matrix_DisplayChar = function() {
  var matrixName = this.getFieldValue('matrixName');
  var dotMatrixArray = Blockly.Arduino.valueToCode(this, 'LEDArrayX', Blockly.Arduino.ORDER_ASSIGNMENT);
  Blockly.Arduino.definitions_['include_RL_HT16K33'] = '#include <RL_HT16K33.h>';                 
  Blockly.Arduino.definitions_[matrixName] =  'HT16K33  '+ matrixName +'; ';
  Blockly.Arduino.setups_['setup_' + matrixName] = matrixName + '.begin(0x70); \n';

  Blockly.Arduino.definitions_['LEDArray'] = 'uint16_t  LEDArray[8];';
  var code='';
  code+='for(int i=0; i<8; i++)\n';
  code+='{\n'
  code+='  LEDArray[i]='+dotMatrixArray+'[i];\n';
  code+='  for(int j=15; j>=0; j--)\n'
  code+='  {\n'
  code+='    if((LEDArray[i]&0x01)>0){\n';
  code+='    '+ matrixName +'.drawPixel(j,i,1); }\n';
  code+='    LEDArray[i] = LEDArray[i]>>1;\n';
  code+='  }  \n'
  code+='}\n'
  code+= matrixName+'.writeDisplay();\n'
  return code;
};
//执行器_点阵屏显示_点阵数组
Blockly.Arduino.ruilong_88display_Matrix_LedArray = function() {
  var varName = this.getFieldValue('VAR');
  var a = new Array();
  for (var i = 1; i < 9; i++) {
    a[i] = new Array();
    for (var j = 1; j < 9; j++) {
      a[i][j] = (this.getFieldValue('a' + i + j) == "TRUE") ? 1 : 0;
    }
  }
  var code = '{';
  for (var i = 1; i < 9; i++) {
    var tmp = ""
    for (var j = 1; j < 9; j++) {
      tmp += a[i][j];
    }
    tmp = (parseInt(tmp, 2)).toString(16)
    if (tmp.length == 1) tmp = "0" + tmp;
    code += '0x' + tmp + ((i != 8) ? ',' : '');
  }
  code += '};';
  //Blockly.Arduino.definitions_[this.id] = "byte LedArray_"+clearString(this.id)+"[]="+code;
  Blockly.Arduino.definitions_[varName] = "uint8_t " + varName + "[8]=" + code;
  //return ["LedArray_"+clearString(this.id), Blockly.Arduino.ORDER_ATOMIC];
  return [varName, Blockly.Arduino.ORDER_ATOMIC];
};
//显示--选择预设8*8图案
Blockly.Arduino.ruilong_88display_Matrix_Ledimg = function() {
  var dropdown_img_ = this.getFieldValue('img_');
  var code = '"' + dropdown_img_ + '"';
  code = '{';
  for (var i = 0; i < 15; i += 2) {
    code += '0x' + dropdown_img_.substr(i, 2) + ((i != 14) ? ',' : '');
  }
  code += '};\n';
  Blockly.Arduino.definitions_['matrix_img_' + dropdown_img_] = "byte " + 'matrix_img_' + dropdown_img_ + "[]=" + code;
  return ['matrix_img_' + dropdown_img_, Blockly.Arduino.ORDER_ATOMIC];
};
//执行器_点阵屏显示_图案数组
Blockly.Arduino.ruilong_816display_Matrix_LedArray = function() {
  var varName = this.getFieldValue('VAR');
  var a = new Array();
  for (var i = 1; i < 9; i++) {
    a[i] = new Array();
    for (var j = 1; j < 17; j++) {
      a[i][j] = (this.getFieldValue('a' + i + j) == "TRUE") ? 1 : 0;
    }
  }
  var code = '{';
  for (var i = 1; i < 9; i++) {
    var tmp = ""
    for (var j = 1; j < 17; j++) {
      tmp += a[i][j];
    }
    tmp = (parseInt(tmp, 2)).toString(16)
  //  alert(tmp);
  if (tmp.length == 1) 
    tmp = "000" + tmp;
  else if (tmp.length == 2) 
   tmp = "00" + tmp;
 else if (tmp.length == 3) 
   tmp = "0" + tmp;
 code += '0x' + tmp + ((i != 8) ? ',' : '');
}
code += '};';
  //Blockly.Arduino.definitions_[this.id] = "byte LedArray_"+clearString(this.id)+"[]="+code;
  Blockly.Arduino.definitions_[varName] = "uint16_t " + varName + "[8]=" + code;
  //return ["LedArray_"+clearString(this.id), Blockly.Arduino.ORDER_ATOMIC];
  return [varName, Blockly.Arduino.ORDER_ATOMIC];
};
//显示--选择预设8*16图案
Blockly.Arduino.ruilong_816display_Matrix_Ledimg = function() {
  var dropdown_img_ = this.getFieldValue('img_');
  var code = '"' + dropdown_img_ + '"';
  code = '{';
  for (var i = 0; i < 29; i += 4) {
    code += '0x' + dropdown_img_.substr(i, 4) + ((i != 28) ? ',' : '');
  }
  code += '};\n';
  Blockly.Arduino.definitions_['matrix_img_' + dropdown_img_] = "uint16_t  " + 'matrix_img_' + dropdown_img_ + "[]=" + code;
  return ['matrix_img_' + dropdown_img_, Blockly.Arduino.ORDER_ATOMIC];
};
//清屏
Blockly.Arduino.ruilong_88display_Matrix_CLEAR = function() {
  var matrixName = this.getFieldValue('matrixName');
  var code = matrixName + '.clear();\n'
  code += matrixName +'.writeDisplay();\n';
  return code;
};
 //机器人-电机转动
 Blockly.Arduino.ruilong_293motor = function() {
   var id = Blockly.Arduino.valueToCode(this, 'ID', Blockly.Arduino.ORDER_ATOMIC);
   var speed = Blockly.Arduino.valueToCode(this, 'SPEED', Blockly.Arduino.ORDER_ASSIGNMENT) || '0';  
   var code = 'motor(' + id + ',' + speed + ');\n';
   Blockly.Arduino.setups_['setup_output_4'] = 'pinMode(4, OUTPUT);';
   Blockly.Arduino.setups_['setup_output_5'] = 'pinMode(5, OUTPUT);';
   Blockly.Arduino.setups_['setup_output_6'] = 'pinMode(6, OUTPUT);';
   Blockly.Arduino.setups_['setup_output_7'] = 'pinMode(7, OUTPUT);';
   

   var funcName = 'motor';
   var code2;
   code2 =  'void motor(int id,int speed){\n';
   code2 += 'int pin_s,pin_d;\n ';
   code2 += 'switch(id){\n';
   code2 += 'case 1:pin_d=4;pin_s=5;break;\n';
   code2 += 'case 2:pin_d=7;pin_s=6;break;\n';
   code2 += 'default:break;}\n';
   code2 += 'if(speed==0){digitalWrite(pin_d,0);digitalWrite(pin_s,0);}\n';
   code2 += 'if(speed>0){digitalWrite(pin_d,0);analogWrite(pin_s,speed);}\n';
   code2 += '       else{digitalWrite(pin_d,1);analogWrite(pin_s,speed);}\n';
   code2 += '}\n';
  
  Blockly.Arduino.definitions_[funcName] = code2;
  return code;
 };

 //机器人-电机转动
 Blockly.Arduino.ruilong_8833motor = function() {
   var id = Blockly.Arduino.valueToCode(this, 'ID', Blockly.Arduino.ORDER_ATOMIC);
   var speed = Blockly.Arduino.valueToCode(this, 'SPEED', Blockly.Arduino.ORDER_ASSIGNMENT) || '0';  
   var code = 'motor(' + id + ',' + speed + ');\n';
   Blockly.Arduino.setups_['setup_output_4'] = 'pinMode(4, OUTPUT);';
   Blockly.Arduino.setups_['setup_output_5'] = 'pinMode(5, OUTPUT);';
   Blockly.Arduino.setups_['setup_output_6'] = 'pinMode(6, OUTPUT);';
   Blockly.Arduino.setups_['setup_output_7'] = 'pinMode(7, OUTPUT);';
   

   var funcName = 'motor';
   var code2;
   code2 =  'void motor(int id,int speed){\n';
   code2 += 'int pin_s,pin_d;\n '
   code2 += 'switch(id){\n';
   code2 += 'case 1:pin_d=4;pin_s=5;break;\n';
   code2 += 'case 2:pin_d=7;pin_s=6;break;\n';
   code2 += 'default:break;}\n';
   code2 += 'if(speed==0){digitalWrite(pin_d,0);digitalWrite(pin_s,0);}\n';
   code2 += 'if(speed>0){digitalWrite(pin_d,0);analogWrite(pin_s,speed);}\n';
   code2 += '       else{digitalWrite(pin_d,1);analogWrite(pin_s,(255+speed));}\n';
   code2 += '}\n';
  
  Blockly.Arduino.definitions_[funcName] = code2;
  return code;
 };

//shadow块C代码
Blockly.Arduino.ruilong_robot_pins_digital = function() {
  var code = this.getFieldValue('PIN');
  return [code, Blockly.Arduino.ORDER_ATOMIC];
};
Blockly.Arduino.ruilong_robot_linefinder_pins_analog=Blockly.Arduino.ruilong_robot_pins_digital;
Blockly.Arduino.ruilong_robot_sound_pins_analog=Blockly.Arduino.ruilong_robot_pins_digital;
Blockly.Arduino.ruilong_robot_button_pins_digital=Blockly.Arduino.ruilong_robot_pins_digital;
Blockly.Arduino.ruilong_robot_pins_ir_recv=Blockly.Arduino.ruilong_robot_pins_digital;
Blockly.Arduino.ruilong_robot_pins_blink=Blockly.Arduino.ruilong_robot_pins_digital;
Blockly.Arduino.ruilong_robot_pins_buzzer=Blockly.Arduino.ruilong_robot_pins_digital;
Blockly.Arduino.ruilong_robot_pins_led=Blockly.Arduino.ruilong_robot_pins_digital;
Blockly.Arduino.ruilong_robot_inout_onoff=Blockly.Arduino.ruilong_robot_pins_digital;


Blockly.Arduino.ruilong_robot_hc_sr04_trig = function() {
  var code = this.getFieldValue('PIN1');
  return [code, Blockly.Arduino.ORDER_ATOMIC];
};

Blockly.Arduino.ruilong_robot_hc_sr04_echo = function() {
  var code = this.getFieldValue('PIN2');
  return [code, Blockly.Arduino.ORDER_ATOMIC];
};

Blockly.Arduino.ruilong_robot_pins_8833motor = function() {
  var code = this.getFieldValue('ID');
  return [code, Blockly.Arduino.ORDER_ATOMIC];
};

Blockly.Arduino.ruilong_robot_inout_onoff = function () {
  var code = this.getFieldValue('BL');
  return [code, Blockly.Arduino.ORDER_ATOMIC];
};

Blockly.Arduino.ruilong_robot_blink = function() {
  var dropdown_pin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var dropdown_stat = Blockly.Arduino.valueToCode(this, 'BL',Blockly.Arduino.ORDER_ATOMIC);
  var code = "";
  if(window.isNaN(dropdown_pin)){
    code = code+'pinMode('+dropdown_pin+', OUTPUT);\n';
  }else{
    Blockly.Arduino.setups_['setup_output_'+dropdown_pin] = 'pinMode('+dropdown_pin+', OUTPUT);';
  }
  code += 'digitalWrite('+dropdown_pin+','+dropdown_stat+');\n'
  return code;
};

// 

Blockly.Arduino.ruilong_robot_linefinder = function() {
  var dropdown_pin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var code = 'analogRead('+dropdown_pin+')';
  return [code, Blockly.Arduino.ORDER_ATOMIC];
};
Blockly.Arduino.ruilong_robot_sound = Blockly.Arduino.ruilong_robot_linefinder;

//超声波测距
Blockly.Arduino.ruilong_robot_hc_sr04 = function() {
    var dropdown_pin1 = Blockly.Arduino.valueToCode(this, 'PIN1', Blockly.Arduino.ORDER_ATOMIC);
    var dropdown_pin2 = Blockly.Arduino.valueToCode(this, 'PIN2', Blockly.Arduino.ORDER_ATOMIC);
    Blockly.Arduino.setups_['setup_output_' + dropdown_pin1] = 'pinMode(' + dropdown_pin1 + ', OUTPUT);';
    Blockly.Arduino.setups_['setup_output_' + dropdown_pin2] = 'pinMode(' + dropdown_pin2 + ', INPUT);\n';
    var funcName = 'checkdistance_' + dropdown_pin1 + '_' + dropdown_pin2;
    var code = 'float' + ' ' + funcName + '() {\n'
	+ '  digitalWrite(' + dropdown_pin1 + ', LOW);\n' + '  delayMicroseconds(2);\n'
	+ '  digitalWrite(' + dropdown_pin1 + ', HIGH);\n' + '  delayMicroseconds(10);\n'
	+ '  digitalWrite(' + dropdown_pin1 + ', LOW);\n'
	+ '  float distance = pulseIn(' + dropdown_pin2 + ', HIGH) / 58.00;\n'
	+ '  delay(10);\n' +'  return distance;\n'
	+ '}\n';
    Blockly.Arduino.definitions_[funcName] = code;
    return [funcName + '()', Blockly.Arduino.ORDER_ATOMIC];
}



//红外接收
Blockly.Arduino.ruilong_robot_ir_recv = function () {
    var variable = Blockly.Arduino.variableDB_.getName(this.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
    Blockly.Arduino.definitions_['var_declare' + variable] = 'long ' + variable + ';';
    var dropdown_pin = Blockly.Arduino.valueToCode(this, 'PIN', Blockly.Arduino.ORDER_ATOMIC);
    var branch = Blockly.Arduino.statementToCode(this, 'DO');
    var branch2 = Blockly.Arduino.statementToCode(this, 'DO2');
    var varName = Blockly.Arduino.variableDB_.getName(this.getFieldValue('VAR'),Blockly.Variables.NAME_TYPE);
    Blockly.Arduino.definitions_['include_IRremote'] = '#include <IRremote.h>\n';
    //Blockly.Arduino.definitions_['var_declare'+varName] = 'long '+varName+';\n';
    Blockly.Arduino.definitions_['var_ir_recv' + dropdown_pin] = 'IRrecv irrecv_' + dropdown_pin + '(' + dropdown_pin + ');\ndecode_results results_' + dropdown_pin + ';\n';
    Blockly.Arduino.setups_['setup_ir_recv_' + dropdown_pin] = 'irrecv_' + dropdown_pin + '.enableIRIn();';
    var code = "if (irrecv_" + dropdown_pin + ".decode(&results_" + dropdown_pin + ")) {\n"
    code += '  ' + variable + '=results_' + dropdown_pin + '.value;\n';
    code += '  String type="UNKNOWN";\n';
    ////////////////////////////////////////////////////////////////
    code += '  String typelist[14]={"UNKNOWN", "NEC", "SONY", "RC5", "RC6", "DISH", "SHARP", "PANASONIC", "JVC", "SANYO", "MITSUBISHI", "SAMSUNG", "LG", "WHYNTER"};\n';
    code += '  if(results_' + dropdown_pin + '.decode_type>=1&&results_' + dropdown_pin + '.decode_type<=13){\n';
    code += '    type=typelist[results_' + dropdown_pin + '.decode_type];\n'
    code += '  }\n';
    code += '  Serial.print("IR TYPE:"+type+"  ");\n';
    code += branch;
    code += '  irrecv_' + dropdown_pin + '.resume();\n'
    code += '} else {\n';
    code += branch2;
    code += '}\n';
    return code;
};
 //机器人-电机转动
 Blockly.Arduino.ruilong_robot_8833motor = function() {
   var id = Blockly.Arduino.valueToCode(this, 'ID', Blockly.Arduino.ORDER_ATOMIC);
   var speed = Blockly.Arduino.valueToCode(this, 'SPEED', Blockly.Arduino.ORDER_ASSIGNMENT) || '0';  
   var code = 'motor(' + id + ',' + speed + ');\n';
   Blockly.Arduino.setups_['setup_output_4'] = 'pinMode(4, OUTPUT);';
   Blockly.Arduino.setups_['setup_output_5'] = 'pinMode(5, OUTPUT);';
   Blockly.Arduino.setups_['setup_output_6'] = 'pinMode(6, OUTPUT);';
   Blockly.Arduino.setups_['setup_output_7'] = 'pinMode(7, OUTPUT);';
   

   var funcName = 'motor';
   var code2;
   code2 =  'void motor(int id,int speed){\n';
   code2 += 'int pin_s,pin_d;\n '
   code2 += 'switch(id){\n';
   code2 += 'case 1:pin_d=4;pin_s=5;break;\n';
   code2 += 'case 2:pin_d=7;pin_s=6;break;\n';
   code2 += 'default:break;}\n';
   code2 += 'if(speed==0){digitalWrite(pin_d,0);digitalWrite(pin_s,0);}\n';
   code2 += 'if(speed>0){digitalWrite(pin_d,0);analogWrite(pin_s,speed);}\n';
   code2 += '       else{digitalWrite(pin_d,1);analogWrite(pin_s,(255+speed));}\n';
   code2 += '}\n';
	
  Blockly.Arduino.definitions_[funcName] = code2;
  return code;
 };
  Blockly.Arduino.ruilong_robot_8833motor2 = function() {
   //var id = Blockly.Arduino.valueToCode(this, 'ID', Blockly.Arduino.ORDER_ATOMIC);
   var speed = Blockly.Arduino.valueToCode(this, 'SPEED', Blockly.Arduino.ORDER_ASSIGNMENT) || '0';  
   var code = 'motor2(' + speed + ');\n';
   Blockly.Arduino.setups_['setup_output_4'] = 'pinMode(4, OUTPUT);';
   Blockly.Arduino.setups_['setup_output_5'] = 'pinMode(5, OUTPUT);';
   Blockly.Arduino.setups_['setup_output_6'] = 'pinMode(6, OUTPUT);';
   Blockly.Arduino.setups_['setup_output_7'] = 'pinMode(7, OUTPUT);';
   

   var funcName = 'motor2';
   var code2;
   code2 =  'void motor2(int speed){\n';
   code2 += 'if(speed==0){digitalWrite(4,0);digitalWrite(5,0);digitalWrite(7,0);digitalWrite(6,0);}\n';
   code2 += 'if(speed>0){digitalWrite(4,0);analogWrite(5,speed);digitalWrite(7,0);analogWrite(6,speed);}\n';
   code2 += '       else{digitalWrite(4,1);analogWrite(5,(255+speed));digitalWrite(7,1);analogWrite(6,(255+speed));}\n';
   code2 += '}\n';
	
  Blockly.Arduino.definitions_[funcName] = code2;
  return code;
 };
 
//执行器-蜂鸣器频率选择列表
Blockly.Arduino.ruilong_robot_tone_notes = function() {
  var code = this.getFieldValue('STAT');
  return [code, Blockly.Arduino.ORDER_ATOMIC];
};

//执行器-蜂鸣器
Blockly.Arduino.ruilong_robot_tone = function() {
  var dropdown_pin = Blockly.Arduino.valueToCode(this, 'PIN', Blockly.Arduino.ORDER_ATOMIC);
  var fre = Blockly.Arduino.valueToCode(this, 'FREQUENCY', Blockly.Arduino.ORDER_ASSIGNMENT) || '0';
  var dur = Blockly.Arduino.valueToCode(this, 'DURATION', Blockly.Arduino.ORDER_ASSIGNMENT) || '0';
  Blockly.Arduino.setups_['setup_output_' + dropdown_pin] = 'pinMode(' + dropdown_pin + ', OUTPUT);';
  Blockly.Arduino.definitions_['newtone0'] = 'float period;\nfloat pulse;';
  Blockly.Arduino.definitions_['newtone1'] = 'void newtone(int tonePin, int frequency, int duration)';
  Blockly.Arduino.definitions_['newtone2'] = '{\nfloat period = 1000000.0 /frequency;';
  Blockly.Arduino.definitions_['newtone3'] = 'float pulse = period / 2.0;';
  Blockly.Arduino.definitions_['newtone4'] = 'for (int i=1; i<=((duration * 1000.0)/period);i=i+1)';
  Blockly.Arduino.definitions_['newtone5'] = ' {\npinMode(tonePin, OUTPUT);\n digitalWrite(tonePin,HIGH);';
  Blockly.Arduino.definitions_['newtone6'] = 'delayMicroseconds(pulse);';
  Blockly.Arduino.definitions_['newtone7'] = 'pinMode(tonePin, OUTPUT);\n digitalWrite(tonePin,LOW);';
  Blockly.Arduino.definitions_['newtone8'] = ' delayMicroseconds(pulse);\n}\n}\n';
  var code = "newtone(" + dropdown_pin + "," + fre + "," + dur + ");\n";
  return code;
};

//执行器-蜂鸣器结束声音
Blockly.Arduino.ruilong_robot_newNoTone = function() {
  var dropdown_pin = Blockly.Arduino.valueToCode(this, 'PIN', Blockly.Arduino.ORDER_ATOMIC);
  var Delay_time = Blockly.Arduino.valueToCode(this, 'DELAY_TIME', Blockly.Arduino.ORDER_ATOMIC);
  Blockly.Arduino.setups_['setup_output_' + dropdown_pin] = 'pinMode(' + dropdown_pin + ', OUTPUT);';
  var code = "digitalWrite(" + dropdown_pin + ", LOW);\n";
  code += 'delay(' + Delay_time + ');';
  return code;
};

Blockly.Arduino.ruilong_speaker_tone = Blockly.Arduino.ruilong_robot_tone;
Blockly.Arduino.ruilong_speaker_Notone = Blockly.Arduino.ruilong_robot_newNoTone;

Blockly.Arduino.ruilong_robot_rgb_init=function(){
    var dropdown_rgbpin = Blockly.Arduino.valueToCode(this, 'PIN', Blockly.Arduino.ORDER_ATOMIC);
    var value_ledcount = Blockly.Arduino.valueToCode(this, 'LEDCOUNT', Blockly.Arduino.ORDER_ATOMIC);
    Blockly.Arduino.definitions_['include_Wire'] = '#include <Wire.h>';
    Blockly.Arduino.definitions_['include_Adafruit_NeoPixel'] = '#include <Adafruit_NeoPixel.h>';
    Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin] = 'Adafruit_NeoPixel  rgb_display_' + dropdown_rgbpin +  '(' + value_ledcount + ');';
    Blockly.Arduino.setups_['setup_rgb_display_begin_' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.begin();';
    Blockly.Arduino.setups_['setup_rgb_display_setpin' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.setPin(' + dropdown_rgbpin + ');';
    return '';
};

Blockly.Arduino.ruilong_robot_rgb_brightness = function(){
    var dropdown_rgbpin = Blockly.Arduino.valueToCode(this, 'PIN', Blockly.Arduino.ORDER_ATOMIC);
    var value_brightness = Blockly.Arduino.valueToCode(this, 'NUM', Blockly.Arduino.ORDER_ATOMIC);	
	var code = 'rgb_display_'+dropdown_rgbpin+'.setBrightness('+value_brightness+');';
    return code;
};

Blockly.Arduino.ruilong_robot_rgb=function(){
  var dropdown_rgbpin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var value_led = Blockly.Arduino.valueToCode(this, '_LED_', Blockly.Arduino.ORDER_ATOMIC);
  var value_rvalue = Blockly.Arduino.valueToCode(this, 'RVALUE', Blockly.Arduino.ORDER_ATOMIC);
  var value_gvalue = Blockly.Arduino.valueToCode(this, 'GVALUE', Blockly.Arduino.ORDER_ATOMIC);
  var value_bvalue = Blockly.Arduino.valueToCode(this, 'BVALUE', Blockly.Arduino.ORDER_ATOMIC);
  //Blockly.Arduino.definitions_['include_Wire'] = '#include <Wire.h>';
   Blockly.Arduino.definitions_['include_Adafruit_NeoPixel'] = '#include <Adafruit_NeoPixel.h>';
   if (!Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin]) {
      Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin] = 'Adafruit_NeoPixel  rgb_display_' + dropdown_rgbpin + '' + '(12);';
      Blockly.Arduino.setups_['setup_rgb_display_begin_' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.begin();';
      Blockly.Arduino.setups_['setup_rgb_display_setpin' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.setPin(' + dropdown_rgbpin + ');';
  }
  
  var code = 'rgb_display_'+dropdown_rgbpin+'.setPixelColor('+value_led+', '+value_rvalue+','+value_gvalue+','+value_bvalue+');\n';
  code+='rgb_display_'+dropdown_rgbpin+'.show();\n';
  return code;
};

Blockly.Arduino.ruilong_robot_rgb2=function(){
  var dropdown_rgbpin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var value_led = Blockly.Arduino.valueToCode(this, '_LED_', Blockly.Arduino.ORDER_ATOMIC);
  var color = goog.color.hexToRgb(this.getFieldValue('RGB_LED_COLOR'));
    //Blockly.Arduino.definitions_['include_Wire'] = '#include <Wire.h>';
    Blockly.Arduino.definitions_['include_Adafruit_NeoPixel'] = '#include <Adafruit_NeoPixel.h>';
   if (!Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin]) {
      Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin] = 'Adafruit_NeoPixel  rgb_display_' + dropdown_rgbpin + '' + '(12);';
      Blockly.Arduino.setups_['setup_rgb_display_begin_' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.begin();';
      Blockly.Arduino.setups_['setup_rgb_display_setpin' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.setPin(' + dropdown_rgbpin + ');';
  }
  var code = 'rgb_display_'+dropdown_rgbpin+'.setPixelColor('+value_led+', '+color+');\n';
  code+='rgb_display_'+dropdown_rgbpin+'.show();\n';
  return code;
};

Blockly.Arduino.ruilong_robot_rgb3=function(){
  var dropdown_rgbpin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var wait_time = Blockly.Arduino.valueToCode(this, 'WAIT',Blockly.Arduino.ORDER_ATOMIC);
  var value_brightness = Blockly.Arduino.valueToCode(this, 'NUM', Blockly.Arduino.ORDER_ATOMIC);
    Blockly.Arduino.definitions_['include_Adafruit_NeoPixel'] = '#include <Adafruit_NeoPixel.h>';
   if (!Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin]) {
      Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin] = 'Adafruit_NeoPixel  rgb_display_' + dropdown_rgbpin + '' + '(12);';
      Blockly.Arduino.setups_['setup_rgb_display_begin_' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.begin();';
      Blockly.Arduino.setups_['setup_rgb_display_setpin' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.setPin(' + dropdown_rgbpin + ');';
	  Blockly.Arduino.setups_['setup_rgb_display_setBrightness' + dropdown_rgbpin]  = 'rgb_display_'+dropdown_rgbpin+'.setBrightness('+value_brightness+');';
  }
  var funcName2 = 'Wheel';
  var code2  = 'uint32_t Wheel(byte WheelPos) {\n';
      code2 += 'if(WheelPos < 85) {return rgb_display_'+dropdown_rgbpin+'.Color(WheelPos * 3, 255 - WheelPos * 3, 0);} \n';
      code2 += 'else if(WheelPos < 170) {WheelPos -= 85; return rgb_display_'+dropdown_rgbpin+'.Color(255 - WheelPos * 3, 0, WheelPos * 3);}\n ';
	  code2 += 'else {WheelPos -= 170;return rgb_display_'+dropdown_rgbpin+'.Color(0, WheelPos * 3, 255 - WheelPos * 3);}\n';
      code2 += '}\n';
  Blockly.Arduino.definitions_[funcName2] = code2;
  
  var funcName3 = 'rainbow';
  var code3  = 'void rainbow(uint8_t wait) { uint16_t i, j;\n';
      code3 += '      for(j=0; j<256; j++) {               \n';
      code3 += '        for(i=0; i<rgb_display_'+dropdown_rgbpin+'.numPixels(); i++) {\n';
      code3 += '         rgb_display_'+dropdown_rgbpin+'.setPixelColor(i, Wheel((i+j) & 255));}\n';                    
      code3 += '      rgb_display_'+dropdown_rgbpin+'.show();\n';
      code3 += '      delay(wait);}}\n';
  
  Blockly.Arduino.definitions_[funcName3] = code3;
  
  var code = 'rainbow('+ wait_time+');\n'
  return code;
};

Blockly.Arduino.ruilong_robot_rgb4=function(){
  var dropdown_rgbpin = Blockly.Arduino.valueToCode(this, 'PIN',Blockly.Arduino.ORDER_ATOMIC);
  var wait_time = Blockly.Arduino.valueToCode(this, 'WAIT',Blockly.Arduino.ORDER_ATOMIC);
  var value_brightness = Blockly.Arduino.valueToCode(this, 'NUM', Blockly.Arduino.ORDER_ATOMIC);
    Blockly.Arduino.definitions_['include_Adafruit_NeoPixel'] = '#include <Adafruit_NeoPixel.h>';
   if (!Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin]) {
      Blockly.Arduino.definitions_['var_rgb_display' + dropdown_rgbpin] = 'Adafruit_NeoPixel  rgb_display_' + dropdown_rgbpin + '' + '(12);';
      Blockly.Arduino.setups_['setup_rgb_display_begin_' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.begin();';
      Blockly.Arduino.setups_['setup_rgb_display_setpin' + dropdown_rgbpin] = 'rgb_display_' + dropdown_rgbpin + '.setPin(' + dropdown_rgbpin + ');';
	  Blockly.Arduino.setups_['setup_rgb_display_setBrightness' + dropdown_rgbpin]  = 'rgb_display_'+dropdown_rgbpin+'.setBrightness('+value_brightness+');';
  }
  var funcName2 = 'Wheel';
  var code2  = 'uint32_t Wheel(byte WheelPos) {\n';
      code2 += 'if(WheelPos < 85) {return rgb_display_'+dropdown_rgbpin+'.Color(WheelPos * 3, 255 - WheelPos * 3, 0);} \n';
      code2 += 'else if(WheelPos < 170) {WheelPos -= 85; return rgb_display_'+dropdown_rgbpin+'.Color(255 - WheelPos * 3, 0, WheelPos * 3);}\n ';
	  code2 += 'else {WheelPos -= 170;return rgb_display_'+dropdown_rgbpin+'.Color(0, WheelPos * 3, 255 - WheelPos * 3);}\n';
      code2 += '}\n';
  Blockly.Arduino.definitions_[funcName2] = code2;
  
  var funcName3 = 'rainbow';
  var code3  = 'void rainbow(uint8_t wait) { uint16_t i, j;\n';
      code3 += '      for(j=0; j<256; j++) {               \n';
      code3 += '        for(i=0; i<rgb_display_'+dropdown_rgbpin+'.numPixels(); i++) {\n';
      code3 += '         rgb_display_'+dropdown_rgbpin+'.setPixelColor(i, Wheel((i+j) & 255));}\n';                    
      code3 += '      rgb_display_'+dropdown_rgbpin+'.show();\n';
      code3 += '      delay(wait);}}\n';
  
  Blockly.Arduino.definitions_[funcName3] = code3;
  
   var funcName4 = 'rainbowCycle';
   var code4  = 'void rainbowCycle(uint8_t wait) {uint16_t i, j;\n';
       code4 += '    for(j=0; j<256*5; j++) { // 5 cycles of all colors on wheel\n';
       code4 += '      for(i=0; i< rgb_display_'+dropdown_rgbpin+'.numPixels(); i++) {\n';
       code4 += '        rgb_display_'+dropdown_rgbpin+'.setPixelColor(i, Wheel(((i * 256 / rgb_display_'+dropdown_rgbpin+'.numPixels()) + j) & 255));}\n';
       code4 += '     rgb_display_'+dropdown_rgbpin+'.show();\n';
       code4 += '     delay(wait);}}\n';
  
   Blockly.Arduino.definitions_[funcName4] = code4;

  var code = 'rainbowCycle('+ wait_time+');\n'
  return code;
};

Blockly.Arduino.ruilong_robot_tm1650_power=function(){
	var stat=this.getFieldValue("STAT");
	Blockly.Arduino.definitions_['dinclude_Wire'] = '#include <Wire.h>';
    Blockly.Arduino.definitions_['include_TM1650'] = '#include <TM1650.h>';
    Blockly.Arduino.definitions_['var_ruilong_4display'] = 'TM1650 ruilong_4display;';
	Blockly.Arduino.setups_['setup_wire_begin'] ='Wire.begin();';
	Blockly.Arduino.setups_['setup_ruilong_4display_init'] ='ruilong_4display.init();';
	return 'ruilong_4display.'+stat+'();\n';
};
Blockly.Arduino.ruilong_robot_tm1650_displayString=function(){
	var value = Blockly.Arduino.valueToCode(this, 'VALUE', Blockly.Arduino.ORDER_ATOMIC);
	 Blockly.Arduino.definitions_['dinclude_Wire'] = '#include <Wire.h>';
  Blockly.Arduino.definitions_['include_TM1650'] = '#include <TM1650.h>';
	Blockly.Arduino.definitions_['var_ruilong_4display'] = 'TM1650 ruilong_4display;';
	Blockly.Arduino.setups_['setup_wire_begin'] ='Wire.begin();';
	Blockly.Arduino.setups_['setup_ruilong_4display_init'] ='ruilong_4display.init();';
	return 'ruilong_4display.displayString('+value+');\n';
};
Blockly.Arduino.ruilong_robot_tm1650_showDot=function(){
	var no=this.getFieldValue("NO");
	var stat=this.getFieldValue("STAT");
	 Blockly.Arduino.definitions_['dinclude_Wire'] = '#include <Wire.h>';
    Blockly.Arduino.definitions_['include_TM1650'] = '#include <TM1650.h>';
	Blockly.Arduino.definitions_['var_ruilong_4display'] = 'TM1650 ruilong_4display;';
	Blockly.Arduino.setups_['setup_wire_begin'] ='Wire.begin();';
	Blockly.Arduino.setups_['setup_ruilong_4display_init'] ='ruilong_4display.init();';
	return 'ruilong_4display.setDot('+no+','+stat+');\n';
};
