'use strict';
goog.provide('Blockly.Blocks.ruilong');
goog.require('Blockly.Blocks');


Blockly.Blocks.ruilong.HUE = 120;
'use strict';
goog.provide('Blockly.Blocks.ruilong');
goog.require('Blockly.Blocks');

//按钮传感器
Blockly.Blocks.ruilong_button = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("按钮传感器")
     .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB405BS.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
    this.setOutput(true, Boolean);
  this.setInputsInline(true);
    this.setTooltip('');
  }
};

//热释电传感器
Blockly.Blocks.ruilong_pir = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("热释电传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB412FC.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
    this.setOutput(true, Boolean);
  this.setInputsInline(true);
    this.setTooltip('');
  }
};
//磁敏传感器
Blockly.Blocks.ruilong_magnetic = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("磁敏传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB160MS.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
    this.setOutput(true, Boolean);
  this.setInputsInline(true);
    this.setTooltip('');
  }
};
//震动传感器
Blockly.Blocks.ruilong_vibration = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("震动传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB180SW.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
    this.setOutput(true, Boolean);
  this.setInputsInline(true);
    this.setTooltip('');
  }
};
//单向倾角传感器
Blockly.Blocks.ruilong_tilt = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("单向倾角传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB200SW.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
    this.setOutput(true, Boolean);
  this.setInputsInline(true);
    this.setTooltip('');
  }
};
//触摸传感器
Blockly.Blocks.ruilong_touch = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("触摸传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB223TP.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
    this.setOutput(true, Boolean);
  this.setInputsInline(true);
    this.setTooltip('');
  }
};
//碰撞传感器
Blockly.Blocks.ruilong_collision = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("碰撞传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSSP382CS-R.png", 73, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
    this.setOutput(true, Boolean);
  this.setInputsInline(true);
    this.setTooltip('');
  }
};

//DHT11温湿度传感器
Blockly.Blocks.ruilong_dht11={
  init: function() {
  var WHAT = [[Blockly.MIXLY_DHT11_T, 'temperature'],[Blockly.MIXLY_DHT11_H, 'humidity']];
    this.setColour(Blockly.Blocks.ruilong.HUE);
  this.appendValueInput("PIN", Number)
        .appendField("温湿度传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB011HT.png", 63, 40))
    .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.appendDummyInput("")
      .appendField(new Blockly.FieldDropdown(WHAT), "WHAT");
  this.setOutput(true, Number);
  }
};
//超声波测距传感器
Blockly.Blocks.ruilong_hc_sr04 = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
  this.appendDummyInput("")
      .appendField("超声波测距")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB004HP.png", 63, 40))
  this.appendValueInput("PIN1", Number)
    .setCheck(Number)
    .setAlign(Blockly.ALIGN_RIGHT)
        .appendField("Trig#")
  this.appendValueInput("PIN2", Number)
    .setCheck(Number)
    .setAlign(Blockly.ALIGN_RIGHT)
        .appendField("Echo#");  
  this.setInputsInline(true); 
  this.setOutput(true, Number);
  this.setTooltip('');
  }
};
//自锁按钮传感器
Blockly.Blocks.ruilong_switch = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("自锁按钮传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB855SW.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
    this.setOutput(true, Boolean);
  this.setInputsInline(true);
    this.setTooltip('');
  }
};
//DS18B20温度传感器
Blockly.Blocks.ruilong_ds18B20 = {
    init: function () {
        var UNIT = [[Blockly.MIXLY_DS18B20_C, '0'], [Blockly.MIXLY_DS18B20_F, '1']];
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendValueInput("PIN", Number)
            .appendField("DS18B20温度传感器")
      .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB182DS.png", 63, 40))
            .setCheck(Number);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_DS18B20_GET_TEMP)
            .appendField(new Blockly.FieldDropdown(UNIT), "UNIT");
        this.setOutput(true, Number);
    }
};
//SHT20温湿度传感器
var ruilong_SHT20_TYPE = [
["温度(℃)", "sht20.readTemperature()"],
["湿度(%)", "sht20.readHumidity()"],
];
Blockly.Blocks.ruilong_SHT20 = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
    .appendField("SHT20温湿度传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB020HT.png", 63, 40));
    this.appendDummyInput("")
    .setAlign(Blockly.ALIGN_RIGHT)
    .appendField(new Blockly.FieldDropdown(ruilong_SHT20_TYPE), "SHT20_TYPE");
    this.setInputsInline(true);
    this.setOutput(true);
    this.setTooltip();
  }
};

//BMP280温度气压传感器
var ruilong_BMP280_TYPE = [
["温度(℃)", "bmp.readTemperature()"],
["气压(pa)", "bmp.readPressure()"],
["高度(m))", "bmp.readAltitude()"],
];
Blockly.Blocks.ruilong_BMP280 = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
    .appendField("BMP280温度气压传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB280BP.png", 63, 40));
    this.appendDummyInput("")
    .setAlign(Blockly.ALIGN_RIGHT)
    .appendField(new Blockly.FieldDropdown(ruilong_BMP280_TYPE), "BMP280_TYPE");
    this.setInputsInline(true);
    this.setOutput(true);
    this.setTooltip();
  }
};

//ADXL345传感器-重力感应块-获取数据
var ruilong_ADXL345_GETAB = [
[Blockly.MixGo_MPU9250_AX, "accel.getAccelerationX()"],
[Blockly.MixGo_MPU9250_AY, "accel.getAccelerationY()"],
[Blockly.MixGo_MPU9250_AZ, "accel.getAccelerationZ()"],
[Blockly.MixGo_MPU9250_AX+"(g)", "accel.getAccelerationX()/256.0"],
[Blockly.MixGo_MPU9250_AY+"(g)", "accel.getAccelerationY()/256.0"],
[Blockly.MixGo_MPU9250_AZ+"(g)", "accel.getAccelerationZ()/256.0"],
];


Blockly.Blocks.ruilong_ADXL345 = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
    .appendField(Blockly.MIXLY_ADXL345)
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB345AD.png", 63, 40));
    this.appendDummyInput("")
    .setAlign(Blockly.ALIGN_RIGHT)
    .appendField(new Blockly.FieldDropdown(ruilong_ADXL345_GETAB), "ADXL345_PIN");
    this.setInputsInline(true);
    this.setOutput(true);
    this.setTooltip();
  }
};

Blockly.Blocks.ruilong_ADXL345_setOffset = {
  init: function () {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
    .appendField(Blockly.MIXLY_SETTING)
    .appendField('ADXL345')
    .appendField(Blockly.MIXLY_MICROBIT_PY_STORAGE_FILE_SEEK_OFFSET)
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB345AD.png", 63, 40));
    this.appendValueInput("OFFSET")
    .setCheck(Number)
    .setAlign(Blockly.ALIGN_RIGHT)
    .appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_DISPLAY_MATRIX_X,"setOffsetX"],[Blockly.MIXLY_DISPLAY_MATRIX_Y,"setOffsetY"],[Blockly.MIXLY_Z_AXIS,"setOffsetZ"]]), "MIXEPI_ADXL345_OFFSET");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};

//夏普PM2.5粉尘传感器(GP2Y1026AU0F)
/*Blockly.Blocks.ruilong_GP2Y1026 = {
    init: function () {
        var UNIT = [[Blockly.MIXLY_DS18B20_C, '0'], [Blockly.MIXLY_DS18B20_F, '1']];
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendValueInput("PIN", Number)
            .appendField("PM2.5粉尘传感器")
      .appendField(new Blockly.FieldImage("../../media/ruilong/RLSPP126GP.jpg", 63, 40))
            .setCheck(Number);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_DS18B20_GET_TEMP)
            .appendField(new Blockly.FieldDropdown([["电压(mV)","1"],["粉尘浓度(ug/m3)","0"]]), "UNIT");
    this.setInputsInline(true);
        this.setOutput(true, Number);
    }
};*/

//传感器-TCS34725颜色识别-获取数据
var ruilong_TCS34725_GETRGB = [
[Blockly.Msg.COLOUR_RGB_RED, "tcs.getR()"],
[Blockly.Msg.COLOUR_RGB_GREEN, "tcs.getG()"],
[Blockly.Msg.COLOUR_RGB_BLUE, "tcs.getB()"],
];

Blockly.Blocks.ruilong_TCS34725_Get_RGB = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
    .setAlign(Blockly.ALIGN_RIGHT)
    .appendField(Blockly.TCS34725_Get_RGB)
      .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB347CS.png", 63, 40))
    .appendField(new Blockly.FieldDropdown(ruilong_TCS34725_GETRGB), "TCS34725_GETRGB");
    this.setInputsInline(true);
    this.setOutput(true);
  }
};

//MAX3010X心率传感器
var ruilong_MAX30102_TYPE = [
["温度(℃)", "particleSensor.readTemperature()"],
["温度(℉))", "particleSensor.readTemperatureF()"],
["红光", "particleSensor.getRed()"],
["红外光", "particleSensor.getIR()"],
["绿光", "particleSensor.getGreen()"],
];

Blockly.Blocks.ruilong_MAX3010X_Value= {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
    .appendField("MAX3010X心率血氧传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB312MX.png", 63, 63));
    this.appendDummyInput("")
    .setAlign(Blockly.ALIGN_RIGHT)
    .appendField(new Blockly.FieldDropdown(ruilong_MAX30102_TYPE), "MAX3010X_TYPE");
    this.setInputsInline(true);
    this.setOutput(true);
    this.setTooltip();
  }
};

Blockly.Blocks.ruilong_MAX3010X_HR = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField(new Blockly.FieldTextInput('Bmp_value'), 'VAR')
            .appendField("MAX3010X心率血氧传感器 心率");
        this.appendStatementInput('DO')
            .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB312MX.png", 63, 63));
        /*this.appendStatementInput('DO2')
            .appendField(Blockly.MIXLY_IR_RECEIVE_NO);*/
        this.setPreviousStatement(true);
        this.setNextStatement(true);
        this.setInputsInline(true);
       // this.setTooltip(Blockly.MIXLY_IR_RECIEVE_TOOLTIP);
    },
    getVars: function () {
        return [this.getFieldValue('VAR')];
    },
    renameVar: function (oldName, newName) {
        if (Blockly.Names.equals(oldName, this.getFieldValue('VAR'))) {
            this.setTitleValue(newName, 'VAR');
        }
    }
};

Blockly.Blocks.ruilong_GP2Y1026 = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendValueInput("PIN", Number)
            .appendField(new Blockly.FieldTextInput('Dust_value'), 'VAR')
            .appendField("PM2.5粉尘传感器")
            .setCheck(Number);
        this.appendStatementInput('DO')
            .appendField(new Blockly.FieldImage("../../media/ruilong/RLSPP126GP.jpg", 63, 63));
        /*this.appendStatementInput('DO2')
            .appendField(Blockly.MIXLY_IR_RECEIVE_NO);*/
        this.setPreviousStatement(true);
        this.setNextStatement(true);
        this.setInputsInline(true);
        this.setTooltip(Blockly.MIXLY_IR_RECIEVE_TOOLTIP);
    },
    getVars: function () {
        return [this.getFieldValue('VAR')];
    },
    renameVar: function (oldName, newName) {
        if (Blockly.Names.equals(oldName, this.getFieldValue('VAR'))) {
            this.setTitleValue(newName, 'VAR');
        }
    }
};

//MRP121触摸传感器
var MRP121_TOUCHLIST = [["E0", "0"],["E1", "1"],["E2", "2"],["E3", "3"],
                        ["E4", "4"],["E5", "5"],["E6", "6"],["E7", "7"],
                        ["E8", "8"],["E9", "9"],["E10", "10"],["E11", "11"]];

Blockly.Blocks.ruilong_MRP121 = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("MRP121触摸传感器");    
  this.appendDummyInput()     
        .appendField("如果");
  this.appendDummyInput("")
      .appendField(new Blockly.FieldDropdown(MRP121_TOUCHLIST), 'MRP121_TOUCH');
  this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown([["接触","1"],["释放","0"]]), 'MRP121_TOUCH_STATE');
  this.setInputsInline(true);
    this.appendStatementInput('DO')
      .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB121TS.png", 63, 63));
  this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip(Blockly.Msg.CONTROLS_IF_IF_TOOLTIP);
  this.setTooltip('');
  }
};



//LCD1602显示模块

Blockly.Blocks.ruilong_LCD1602_Print = {
  init: function() {
      this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendValueInput("TEXT", String)
        .setCheck([String,Number])
        .setAlign(Blockly.ALIGN_RIGHT)
    .appendField(Blockly.MIXLY_DF_LCD)
    .appendField(new Blockly.FieldTextInput('mylcd'), 'VAR')
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB162LD.png", 88, 32))
        .appendField(Blockly.MIXLY_LCD_PRINT1);
    this.appendValueInput("TEXT2", String)
        .setCheck([String,Number])
        .setAlign(Blockly.ALIGN_RIGHT)
        .appendField(Blockly.MIXLY_LCD_PRINT2);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};

Blockly.Blocks.ruilong_LCD1602_Print2 = {
  init: function() {
      this.setColour(Blockly.Blocks.ruilong.HUE);
  this.appendValueInput("row", Number)
        .setCheck(Number)
        .setAlign(Blockly.ALIGN_RIGHT)
    .appendField(Blockly.MIXLY_DF_LCD)
    .appendField(new Blockly.FieldTextInput('mylcd'), 'VAR')
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB162LD.png", 88, 32))
        .appendField(Blockly.MIXLY_LCD_ROW);
  this.appendValueInput("column", Number)
        .setCheck(Number)
        .setAlign(Blockly.ALIGN_RIGHT)
        .appendField(Blockly.MIXLY_LCD_COLUMN);
    this.appendValueInput("TEXT", String)
        .setCheck([String,Number])
        .setAlign(Blockly.ALIGN_RIGHT)
        .appendField(Blockly.MIXLY_LCD_PRINT);
    this.setPreviousStatement(true, null);
  this.setInputsInline(true);
    this.setNextStatement(true, null);
  }
};

Blockly.Blocks.ruilong_LCD1602_Power = {
  init: function() {
      this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput()
    .appendField(Blockly.MIXLY_DF_LCD)
    .appendField(new Blockly.FieldTextInput('mylcd'), 'VAR')
        .appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_LCD_STAT_ON, "display"], [Blockly.MIXLY_LCD_STAT_OFF, "noDisplay"], [Blockly.MIXLY_LCD_STAT_CURSOR, "cursor"], [Blockly.MIXLY_LCD_STAT_NOCURSOR, "noCursor"], [Blockly.MIXLY_LCD_STAT_CLEAR, "clear"], [Blockly.MIXLY_LCD_NOBACKLIGHT, "noBacklight"], [Blockly.MIXLY_LCD_BACKLIGHT, "backlight"]]), "STAT");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};

//RGB彩灯显示模块  初始化
Blockly.Blocks.ruilong_rgb_init = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_RGB)
        this.appendValueInput("PIN", Number)
           .setCheck(Number)
           .setAlign(Blockly.ALIGN_RIGHT)
           .appendField(Blockly.MIXLY_PIN);
        this.appendValueInput("LEDCOUNT")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_RGB_COUNT);
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setTooltip('');
    }
};
//RGB亮度调节
Blockly.Blocks.ruilong_rgb_brightness = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_RGB)
        this.appendValueInput("PIN", Number)
           .setCheck(Number)
           .setAlign(Blockly.ALIGN_RIGHT)
           .appendField(Blockly.MIXLY_PIN);
        this.appendValueInput("NUM")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField("亮度");
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setTooltip('');
    }
};
//RGB彩灯单独像素点设置
Blockly.Blocks.ruilong_rgb = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_RGB)
         this.appendValueInput("PIN", Number)
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_PIN);
        this.appendValueInput("_LED_")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_RGB_NUM);
        this.appendValueInput("RVALUE")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_RGB_R);
        this.appendValueInput("GVALUE")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_RGB_G);
        this.appendValueInput("BVALUE")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_RGB_B);
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setTooltip('');
    }
};
//RGB彩灯  选色块  设置颜色
Blockly.Blocks.ruilong_rgb2 = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_RGB)
         this.appendValueInput("PIN", Number)
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_PIN);
        this.appendValueInput("_LED_")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_RGB_NUM);
        this.appendDummyInput("")
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(new Blockly.FieldColour("#ff0000"), "RGB_LED_COLOR");
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};
//RGB彩灯  七彩变换切换
Blockly.Blocks.ruilong_rgb3 = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_RGB)
         this.appendValueInput("PIN", Number)
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_PIN);
    this.appendValueInput("NUM")
            .setCheck(Number)
            .appendField("初始亮度");
        this.appendValueInput("WAIT")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField("七彩变换切换时间");       
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};
//RGB彩灯 七彩循环切换
Blockly.Blocks.ruilong_rgb4 = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_RGB)
        this.appendValueInput("PIN", Number)
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_PIN);
        this.appendValueInput("NUM")
            .setCheck(Number)
            .appendField("初始亮度");
        this.appendValueInput("WAIT")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField("七彩循环切换时间");
        
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};
//RGB彩灯  点阵显示
Blockly.Blocks.ruilong_display_Matrix_DisplayChar = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(Blockly.MIXLY_RGB)
    this.appendValueInput("PIN", Number)
      .setCheck(Number)
        .setAlign(Blockly.ALIGN_LEFT)
        .appendField(Blockly.MIXLY_PIN);
  this.appendValueInput("NUM")
        .setCheck(Number)
        .setAlign(Blockly.ALIGN_LEFT)
        .appendField("初始亮度");//Blockly.MIXLY_RGB_BRIGHTNESS
    this.appendValueInput("RGBArray")
      .setAlign(Blockly.ALIGN_LEFT)
    .appendField(Blockly.MIXLY_DISPLAY_MATRIX_PICARRAY);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip();
  }
};
//RGB彩灯  点阵清屏
Blockly.Blocks.ruilong_display_Matrix_CLEAR = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
  this.appendDummyInput("")
        .appendField(Blockly.MIXLY_RGB)
    this.appendValueInput("PIN", Number)
      .setCheck(Number)
        .setAlign(Blockly.ALIGN_RIGHT)
        .appendField(Blockly.MIXLY_PIN);
    this.appendDummyInput("")
      .setAlign(Blockly.ALIGN_RIGHT)
      .appendField(Blockly.MIXLY_DISPLAY_MATRIX_CLEAR);
    this.setPreviousStatement(true);
    this.setNextStatement(true);  
    this.setTooltip();
  }
};
//RGB彩灯  点阵数组
Blockly.Blocks.ruilong_display_Matrix_LedArray = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField(Blockly.MIXLY_DISPLAY_MATRIX_ARRAYVAR)
    .appendField(new Blockly.FieldTextInput("RGBArray1"), "VAR");
    this.appendDummyInput("")
      .appendField(new Blockly.FieldColour("#ff0000"), "RGB_15")
      .appendField(new Blockly.FieldColour("#ffffff"), "RGB_14")
      .appendField(new Blockly.FieldColour("#ff0000"), "RGB_13")
      .appendField(new Blockly.FieldColour("#ffffff"), "RGB_12")
      .appendField(new Blockly.FieldColour("#ff0000"), "RGB_11");
    this.appendDummyInput("")
      .appendField(new Blockly.FieldColour("#ffffff"), "RGB_25")
      .appendField(new Blockly.FieldColour("#ffffff"), "RGB_24")
      .appendField(new Blockly.FieldColour("#ffffff"), "RGB_23")
      .appendField(new Blockly.FieldColour("#ffffff"), "RGB_22")
      .appendField(new Blockly.FieldColour("#ffffff"), "RGB_21");
    this.appendDummyInput("")
      .appendField(new Blockly.FieldColour("#ffffff"), "RGB_35")
      .appendField(new Blockly.FieldColour("#ffffff"), "RGB_34")
      .appendField(new Blockly.FieldColour("#ffffff"), "RGB_33")
      .appendField(new Blockly.FieldColour("#ffffff"), "RGB_32")
      .appendField(new Blockly.FieldColour("#ffffff"), "RGB_31");
    this.appendDummyInput("")
      .appendField(new Blockly.FieldColour("#ff0000"), "RGB_45")
      .appendField(new Blockly.FieldColour("#ffffff"), "RGB_44")
      .appendField(new Blockly.FieldColour("#ffffff"), "RGB_43")
      .appendField(new Blockly.FieldColour("#ffffff"), "RGB_42")
      .appendField(new Blockly.FieldColour("#ff0000"), "RGB_41"); 
  this.appendDummyInput("")
      .appendField(new Blockly.FieldColour("#ff0000"), "RGB_55")
      .appendField(new Blockly.FieldColour("#ff0000"), "RGB_54")
      .appendField(new Blockly.FieldColour("#ffffff"), "RGB_53")
      .appendField(new Blockly.FieldColour("#ff0000"), "RGB_52")
      .appendField(new Blockly.FieldColour("#ff0000"), "RGB_51"); 
    this.setOutput(true, Number);
    this.setTooltip();
  }
};
Blockly.Blocks.ruilong_display_Matrix_DisplayLedBar =  Blockly.Blocks.ruilong_display_Matrix_DisplayChar;

Blockly.Blocks.ruilong_display_Matrix_LedBar = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField(Blockly.MIXLY_DISPLAY_MATRIX_ARRAYVAR)
    .appendField(new Blockly.FieldTextInput("RGBBar1"), "VAR");

    this.appendDummyInput("")
      .appendField(new Blockly.FieldColour("#ffffff"), "RGB_5")
      .appendField(new Blockly.FieldColour("#ffffff"), "RGB_4")
      .appendField(new Blockly.FieldColour("#ffffff"), "RGB_3")
      .appendField(new Blockly.FieldColour("#ffffff"), "RGB_2")
      .appendField(new Blockly.FieldColour("#ffffff"), "RGB_1");
 //   this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip();
  }
};

Blockly.Blocks.ruilong_display_Matrix_DisplayChar2 = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(Blockly.MIXLY_RGB)
    this.appendValueInput("PIN", Number)
      .setCheck(Number)
        .setAlign(Blockly.ALIGN_LEFT)
        .appendField(Blockly.MIXLY_PIN);
  this.appendValueInput("NUM")
        .setCheck(Number)
        .setAlign(Blockly.ALIGN_LEFT)
        .appendField("初始亮度");
  this.appendDummyInput("")
    .setAlign(Blockly.ALIGN_LEFT)
    .appendField("颜色")
        .appendField(new Blockly.FieldColour("#ff0000"), "RGB_DOT_COLOR");
    this.appendValueInput("RGBArray_dot")
      .setAlign(Blockly.ALIGN_LEFT)
    .appendField(Blockly.MIXLY_DISPLAY_MATRIX_PICARRAY);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
          
    //this.setTooltip();
  }
};

Blockly.Blocks.ruilong_display_Matrix_LedArray2 = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField(Blockly.MIXLY_DISPLAY_MATRIX_ARRAYVAR)
    .appendField(new Blockly.FieldTextInput("RGBArray2"), "VAR");
    this.appendDummyInput("")
  .appendField(new Blockly.FieldCheckbox("FALSE"), "DOT_15")
  .appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_14")
  .appendField(new Blockly.FieldCheckbox("FALSE"), "DOT_13")
  .appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_12")
  .appendField(new Blockly.FieldCheckbox("FALSE"), "DOT_11");
    this.appendDummyInput("")
  .appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_25")
  .appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_24")
  .appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_23")
  .appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_22")
  .appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_21");
    this.appendDummyInput("")
  .appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_35")
  .appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_34")
  .appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_33")
  .appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_32")
  .appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_31");
    this.appendDummyInput("")
  .appendField(new Blockly.FieldCheckbox("FALSE"), "DOT_45")
  .appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_44")
  .appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_43")
  .appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_42")
  .appendField(new Blockly.FieldCheckbox("FALSE"), "DOT_41"); 
  this.appendDummyInput("")
  .appendField(new Blockly.FieldCheckbox("FALSE"), "DOT_55")
  .appendField(new Blockly.FieldCheckbox("FALSE"), "DOT_54")
  .appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_53")
  .appendField(new Blockly.FieldCheckbox("FALSE"), "DOT_52")
  .appendField(new Blockly.FieldCheckbox("FALSE"), "DOT_51"); 
    this.setOutput(true, Number);
    //this.setTooltip();
  }
};
Blockly.Blocks.ruilong_display_Matrix_DisplayBar2=Blockly.Blocks.ruilong_display_Matrix_DisplayChar2;

Blockly.Blocks.ruilong_display_Matrix_LedBar2 = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField(Blockly.MIXLY_DISPLAY_MATRIX_ARRAYVAR)
    .appendField(new Blockly.FieldTextInput("RGBArray2"), "VAR");
    this.appendDummyInput("")
  .appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_5")
  .appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_4")
  .appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_3")
  .appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_2")
  .appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_1");
    this.setOutput(true, Number);
    //this.setTooltip();
  }
};
Blockly.Blocks.ruilong_tm1650_power = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput()
            .appendField("TM1650四位数码管")
      .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB056DB.png", 88, 32))
            .appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_LCD_STAT_ON, "displayOn"], [Blockly.MIXLY_LCD_STAT_OFF, "displayOff"], [Blockly.MIXLY_LCD_STAT_CLEAR, "clear"]]), "STAT");
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};

Blockly.Blocks.ruilong_tm1650_displayString = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput()
            .appendField("TM1650四位数码管")
      .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB056DB.png", 88, 32));
        this.appendValueInput("VALUE")
//            .setCheck(String)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField("显示字符串");
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};

Blockly.Blocks.ruilong_tm1650_showDot = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput()
            .appendField("TM1650四位数码管")
      .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB056DB.png", 88, 32))
            .appendField("第")
            .appendField(new Blockly.FieldDropdown([["1", "0"], ["2", "1"], ["3", "2"], ["4", "3"]]), "NO")
            .appendField("个")
            .appendField("小数点")
            .appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_4DIGITDISPLAY_ON, "true"], [Blockly.MIXLY_4DIGITDISPLAY_OFF, "false"]]), "STAT");
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};

//显示-TM1637初始化
Blockly.Blocks.ruilong_tm1637_init = {
  init: function() {
  this.appendDummyInput()
    .appendField("TM1637四位数码管")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB057DB.png", 88, 32));
    this.appendValueInput("PIN2").setCheck(Number).setAlign(Blockly.ALIGN_RIGHT).appendField("DIO").appendField(Blockly.MIXLY_PIN);
    this.appendValueInput("PIN1").setCheck(Number).setAlign(Blockly.ALIGN_RIGHT).appendField("CLK").appendField(Blockly.MIXLY_PIN);

    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.setInputsInline(true);
    this.setTooltip("");
    this.setHelpUrl("");
  }
};

//显示-TM1637-4位数码管显示字符串
Blockly.Blocks.ruilong_tm1637_displayString = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput()
      .appendField("TM1637四位数码管")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB057DB.png", 88, 32));
  this.appendDummyInput()
      .appendField("显示字符串");
    this.appendValueInput("VALUE")
      .setCheck(String)
      .setAlign(Blockly.ALIGN_RIGHT);
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip("");
  }
};

//显示-TM1637-4位数码管显示时间
Blockly.Blocks.ruilong_tm1637_displayTime = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput()
      .appendField("TM1637四位数码管")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB057DB.png", 88, 32));
  this.appendDummyInput()
      .appendField("显示时间");
    this.appendValueInput("hour").setCheck(Number).setAlign(Blockly.ALIGN_RIGHT);
    this.appendDummyInput("").appendField(Blockly.MAKER17_HOUR);
    this.appendValueInput("minute").setCheck(Number).setAlign(Blockly.ALIGN_RIGHT);
    this.appendDummyInput("").appendField(Blockly.MAKER17_MINUTE);
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip("");
  }
};

//显示-TM1637-4位数码管设置亮度
Blockly.Blocks.ruilong_tm1637_Brightness = {
  init: function() {
     this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput()
      .appendField("TM1637四位数码管")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB057DB.png", 88, 32));
    this.appendDummyInput()
      .appendField("设置亮度");
    this.appendValueInput('BRIGHTNESS').setCheck(Number);
    this.appendDummyInput("").appendField("%");
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setInputsInline(true);
  }
};



Blockly.Blocks.ruilong_88display_Matrix_blink_rate = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField(new Blockly.FieldTextInput('myMatrix'), 'matrixName').appendField(Blockly.MIXLY_DISPLAY_MATRIX_SHOW);
    this.appendValueInput('Blink_rate')
    .setCheck(Number)
    .appendField(Blockly.MIXLY_ESP32_JS_MONITOR_SET_BLINK_RATE)
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setInputsInline(true);
    this.setTooltip("取值范围0/1/2");
  }
};

Blockly.Blocks.ruilong_88display_Matrix_brightness = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField(new Blockly.FieldTextInput('myMatrix'), 'matrixName').appendField(Blockly.MIXLY_DISPLAY_MATRIX_SHOW);
    this.appendValueInput("Brightness")
    .setCheck(Number)
    .setAlign(Blockly.ALIGN_RIGHT)
    .appendField(Blockly.MIXLY_BRIGHTNESS);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setInputsInline(true);
    this.setTooltip("取值范围0~15");
  }
};


//执行器_点阵屏显示_画点变量
var ruilong_88display_DrawPixel_NUM = [
  [Blockly.MIXLY_4DIGITDISPLAY_ON, "1"],
  [Blockly.MIXLY_4DIGITDISPLAY_OFF, "0"]
];

//执行器_点阵屏显示_画点显示
Blockly.Blocks.ruilong_88display_Matrix_POS = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField(new Blockly.FieldTextInput('myMatrix'), 'matrixName').appendField(Blockly.MIXLY_DISPLAY_MATRIX_SHOW);
    this.appendValueInput('XVALUE').setCheck(Number).setAlign(Blockly.ALIGN_RIGHT).appendField(Blockly.MIXLY_DISPLAY_MATRIX_X);
    this.appendValueInput("YVALUE").setCheck(Number).setAlign(Blockly.ALIGN_RIGHT).appendField(Blockly.MIXLY_DISPLAY_MATRIX_Y);
    this.appendDummyInput("").setAlign(Blockly.ALIGN_RIGHT).appendField(Blockly.MIXLY_DISPLAY_MATRIX_SHOWPOINT).appendField(new Blockly.FieldDropdown(ruilong_88display_DrawPixel_NUM), "DrawPixel_TYPE");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip(Blockly.MIXLY_DISPLAY_MATRIX_SHOWPOINT_TOOLTIP);
  }
};
//执行器_点阵屏显示_左右对称
var ruilong_88display_Rotation_NUM = [
  ["8*8点阵", "1"],
  ["8*16点阵", "0"],
];

//执行器_点阵屏显示_左右对称
Blockly.Blocks.ruilong_88display_Matrix_Rotation = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField(new Blockly.FieldTextInput('myMatrix'), 'matrixName').appendField(Blockly.MIXLY_DISPLAY_MATRIX_SHOW);
    this.appendDummyInput("").appendField("点阵屏滚动文字方向").appendField(new Blockly.FieldDropdown(ruilong_88display_Rotation_NUM), "Rotation_TYPE");
    this.setPreviousStatement(true);
    this.setNextStatement(true);
 //   this.setTooltip("");
  }
};
//执行器_点阵屏显示_字符显示
Blockly.Blocks.ruilong_88display_Matrix_TEXT={
  init:function(){
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField(new Blockly.FieldTextInput('myMatrix'), 'matrixName').appendField(Blockly.MIXLY_DISPLAY_MATRIX_SHOW);
    this.appendValueInput("TEXT", String).setCheck([Number, String]).setAlign(Blockly.ALIGN_RIGHT).appendField(" 显示");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setInputsInline(true);
    //this.setTooltip("");
  }
};
//执行器_点阵屏显示_显示图案
Blockly.Blocks.ruilong_88display_Matrix_DisplayChar = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField(new Blockly.FieldTextInput('myMatrix'), 'matrixName')
    .appendField(Blockly.MIXLY_DISPLAY_MATRIX_SHOW);
    this.appendValueInput("LEDArrayX")
      .setAlign(Blockly.ALIGN_RIGHT)
      .appendField(Blockly.MIXLY_DISPLAY_MATRIX_PICARRAY);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    //this.setTooltip();
  }
};
Blockly.Blocks.ruilong_816display_Matrix_DisplayChar=Blockly.Blocks.ruilong_88display_Matrix_DisplayChar;
//执行器_点阵屏显示_图案数组
Blockly.Blocks.ruilong_88display_Matrix_LedArray = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField(Blockly.MIXLY_DISPLAY_MATRIX_ARRAYVAR)
    .appendField(new Blockly.FieldTextInput("LedArray0808"), "VAR");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a81").appendField(new Blockly.FieldCheckbox("FALSE"), "a82").appendField(new Blockly.FieldCheckbox("FALSE"), "a83").appendField(new Blockly.FieldCheckbox("FALSE"), "a84").appendField(new Blockly.FieldCheckbox("FALSE"), "a85").appendField(new Blockly.FieldCheckbox("FALSE"), "a86").appendField(new Blockly.FieldCheckbox("FALSE"), "a87").appendField(new Blockly.FieldCheckbox("FALSE"), "a88");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a71").appendField(new Blockly.FieldCheckbox("FALSE"), "a72").appendField(new Blockly.FieldCheckbox("FALSE"), "a73").appendField(new Blockly.FieldCheckbox("FALSE"), "a74").appendField(new Blockly.FieldCheckbox("FALSE"), "a75").appendField(new Blockly.FieldCheckbox("FALSE"), "a76").appendField(new Blockly.FieldCheckbox("FALSE"), "a77").appendField(new Blockly.FieldCheckbox("FALSE"), "a78");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a61").appendField(new Blockly.FieldCheckbox("FALSE"), "a62").appendField(new Blockly.FieldCheckbox("FALSE"), "a63").appendField(new Blockly.FieldCheckbox("FALSE"), "a64").appendField(new Blockly.FieldCheckbox("FALSE"), "a65").appendField(new Blockly.FieldCheckbox("FALSE"), "a66").appendField(new Blockly.FieldCheckbox("FALSE"), "a67").appendField(new Blockly.FieldCheckbox("FALSE"), "a68");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a51").appendField(new Blockly.FieldCheckbox("FALSE"), "a52").appendField(new Blockly.FieldCheckbox("FALSE"), "a53").appendField(new Blockly.FieldCheckbox("FALSE"), "a54").appendField(new Blockly.FieldCheckbox("FALSE"), "a55").appendField(new Blockly.FieldCheckbox("FALSE"), "a56").appendField(new Blockly.FieldCheckbox("FALSE"), "a57").appendField(new Blockly.FieldCheckbox("FALSE"), "a58");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a41").appendField(new Blockly.FieldCheckbox("FALSE"), "a42").appendField(new Blockly.FieldCheckbox("FALSE"), "a43").appendField(new Blockly.FieldCheckbox("FALSE"), "a44").appendField(new Blockly.FieldCheckbox("FALSE"), "a45").appendField(new Blockly.FieldCheckbox("FALSE"), "a46").appendField(new Blockly.FieldCheckbox("FALSE"), "a47").appendField(new Blockly.FieldCheckbox("FALSE"), "a48");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a31").appendField(new Blockly.FieldCheckbox("FALSE"), "a32").appendField(new Blockly.FieldCheckbox("FALSE"), "a33").appendField(new Blockly.FieldCheckbox("FALSE"), "a34").appendField(new Blockly.FieldCheckbox("FALSE"), "a35").appendField(new Blockly.FieldCheckbox("FALSE"), "a36").appendField(new Blockly.FieldCheckbox("FALSE"), "a37").appendField(new Blockly.FieldCheckbox("FALSE"), "a38");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a21").appendField(new Blockly.FieldCheckbox("FALSE"), "a22").appendField(new Blockly.FieldCheckbox("FALSE"), "a23").appendField(new Blockly.FieldCheckbox("FALSE"), "a24").appendField(new Blockly.FieldCheckbox("FALSE"), "a25").appendField(new Blockly.FieldCheckbox("FALSE"), "a26").appendField(new Blockly.FieldCheckbox("FALSE"), "a27").appendField(new Blockly.FieldCheckbox("FALSE"), "a28");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a11").appendField(new Blockly.FieldCheckbox("FALSE"), "a12").appendField(new Blockly.FieldCheckbox("FALSE"), "a13").appendField(new Blockly.FieldCheckbox("FALSE"), "a14").appendField(new Blockly.FieldCheckbox("FALSE"), "a15").appendField(new Blockly.FieldCheckbox("FALSE"), "a16").appendField(new Blockly.FieldCheckbox("FALSE"), "a17").appendField(new Blockly.FieldCheckbox("FALSE"), "a18");
    this.setOutput(true, Number);
    //this.setTooltip();
  }
};

//执行器_点阵屏显示_图案数组
Blockly.Blocks.ruilong_816display_Matrix_LedArray = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField(Blockly.MIXLY_DISPLAY_MATRIX_ARRAYVAR)
    .appendField(new Blockly.FieldTextInput("LedArray0816"), "VAR");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a81").appendField(new Blockly.FieldCheckbox("FALSE"), "a82").appendField(new Blockly.FieldCheckbox("FALSE"), "a83").appendField(new Blockly.FieldCheckbox("FALSE"), "a84").appendField(new Blockly.FieldCheckbox("FALSE"), "a85").appendField(new Blockly.FieldCheckbox("FALSE"), "a86").appendField(new Blockly.FieldCheckbox("FALSE"), "a87").appendField(new Blockly.FieldCheckbox("FALSE"), "a88").appendField(new Blockly.FieldCheckbox("FALSE"), "a89").appendField(new Blockly.FieldCheckbox("FALSE"), "a810").appendField(new Blockly.FieldCheckbox("FALSE"), "a811").appendField(new Blockly.FieldCheckbox("FALSE"), "a812").appendField(new Blockly.FieldCheckbox("FALSE"), "a813").appendField(new Blockly.FieldCheckbox("FALSE"), "a814").appendField(new Blockly.FieldCheckbox("FALSE"), "a815").appendField(new Blockly.FieldCheckbox("FALSE"), "a816");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a71").appendField(new Blockly.FieldCheckbox("FALSE"), "a72").appendField(new Blockly.FieldCheckbox("FALSE"), "a73").appendField(new Blockly.FieldCheckbox("FALSE"), "a74").appendField(new Blockly.FieldCheckbox("FALSE"), "a75").appendField(new Blockly.FieldCheckbox("FALSE"), "a76").appendField(new Blockly.FieldCheckbox("FALSE"), "a77").appendField(new Blockly.FieldCheckbox("FALSE"), "a78").appendField(new Blockly.FieldCheckbox("FALSE"), "a79").appendField(new Blockly.FieldCheckbox("FALSE"), "a710").appendField(new Blockly.FieldCheckbox("FALSE"), "a711").appendField(new Blockly.FieldCheckbox("FALSE"), "a712").appendField(new Blockly.FieldCheckbox("FALSE"), "a713").appendField(new Blockly.FieldCheckbox("FALSE"), "a714").appendField(new Blockly.FieldCheckbox("FALSE"), "a715").appendField(new Blockly.FieldCheckbox("FALSE"), "a716");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a61").appendField(new Blockly.FieldCheckbox("FALSE"), "a62").appendField(new Blockly.FieldCheckbox("FALSE"), "a63").appendField(new Blockly.FieldCheckbox("FALSE"), "a64").appendField(new Blockly.FieldCheckbox("FALSE"), "a65").appendField(new Blockly.FieldCheckbox("FALSE"), "a66").appendField(new Blockly.FieldCheckbox("FALSE"), "a67").appendField(new Blockly.FieldCheckbox("FALSE"), "a68").appendField(new Blockly.FieldCheckbox("FALSE"), "a69").appendField(new Blockly.FieldCheckbox("FALSE"), "a610").appendField(new Blockly.FieldCheckbox("FALSE"), "a611").appendField(new Blockly.FieldCheckbox("FALSE"), "a612").appendField(new Blockly.FieldCheckbox("FALSE"), "a613").appendField(new Blockly.FieldCheckbox("FALSE"), "a614").appendField(new Blockly.FieldCheckbox("FALSE"), "a615").appendField(new Blockly.FieldCheckbox("FALSE"), "a616");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a51").appendField(new Blockly.FieldCheckbox("FALSE"), "a52").appendField(new Blockly.FieldCheckbox("FALSE"), "a53").appendField(new Blockly.FieldCheckbox("FALSE"), "a54").appendField(new Blockly.FieldCheckbox("FALSE"), "a55").appendField(new Blockly.FieldCheckbox("FALSE"), "a56").appendField(new Blockly.FieldCheckbox("FALSE"), "a57").appendField(new Blockly.FieldCheckbox("FALSE"), "a58").appendField(new Blockly.FieldCheckbox("FALSE"), "a59").appendField(new Blockly.FieldCheckbox("FALSE"), "a510").appendField(new Blockly.FieldCheckbox("FALSE"), "a511").appendField(new Blockly.FieldCheckbox("FALSE"), "a512").appendField(new Blockly.FieldCheckbox("FALSE"), "a513").appendField(new Blockly.FieldCheckbox("FALSE"), "a514").appendField(new Blockly.FieldCheckbox("FALSE"), "a515").appendField(new Blockly.FieldCheckbox("FALSE"), "a516");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a41").appendField(new Blockly.FieldCheckbox("FALSE"), "a42").appendField(new Blockly.FieldCheckbox("FALSE"), "a43").appendField(new Blockly.FieldCheckbox("FALSE"), "a44").appendField(new Blockly.FieldCheckbox("FALSE"), "a45").appendField(new Blockly.FieldCheckbox("FALSE"), "a46").appendField(new Blockly.FieldCheckbox("FALSE"), "a47").appendField(new Blockly.FieldCheckbox("FALSE"), "a48").appendField(new Blockly.FieldCheckbox("FALSE"), "a49").appendField(new Blockly.FieldCheckbox("FALSE"), "a410").appendField(new Blockly.FieldCheckbox("FALSE"), "a411").appendField(new Blockly.FieldCheckbox("FALSE"), "a412").appendField(new Blockly.FieldCheckbox("FALSE"), "a413").appendField(new Blockly.FieldCheckbox("FALSE"), "a414").appendField(new Blockly.FieldCheckbox("FALSE"), "a415").appendField(new Blockly.FieldCheckbox("FALSE"), "a416");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a31").appendField(new Blockly.FieldCheckbox("FALSE"), "a32").appendField(new Blockly.FieldCheckbox("FALSE"), "a33").appendField(new Blockly.FieldCheckbox("FALSE"), "a34").appendField(new Blockly.FieldCheckbox("FALSE"), "a35").appendField(new Blockly.FieldCheckbox("FALSE"), "a36").appendField(new Blockly.FieldCheckbox("FALSE"), "a37").appendField(new Blockly.FieldCheckbox("FALSE"), "a38").appendField(new Blockly.FieldCheckbox("FALSE"), "a39").appendField(new Blockly.FieldCheckbox("FALSE"), "a310").appendField(new Blockly.FieldCheckbox("FALSE"), "a311").appendField(new Blockly.FieldCheckbox("FALSE"), "a312").appendField(new Blockly.FieldCheckbox("FALSE"), "a313").appendField(new Blockly.FieldCheckbox("FALSE"), "a314").appendField(new Blockly.FieldCheckbox("FALSE"), "a315").appendField(new Blockly.FieldCheckbox("FALSE"), "a316");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a21").appendField(new Blockly.FieldCheckbox("FALSE"), "a22").appendField(new Blockly.FieldCheckbox("FALSE"), "a23").appendField(new Blockly.FieldCheckbox("FALSE"), "a24").appendField(new Blockly.FieldCheckbox("FALSE"), "a25").appendField(new Blockly.FieldCheckbox("FALSE"), "a26").appendField(new Blockly.FieldCheckbox("FALSE"), "a27").appendField(new Blockly.FieldCheckbox("FALSE"), "a28").appendField(new Blockly.FieldCheckbox("FALSE"), "a29").appendField(new Blockly.FieldCheckbox("FALSE"), "a210").appendField(new Blockly.FieldCheckbox("FALSE"), "a211").appendField(new Blockly.FieldCheckbox("FALSE"), "a212").appendField(new Blockly.FieldCheckbox("FALSE"), "a213").appendField(new Blockly.FieldCheckbox("FALSE"), "a214").appendField(new Blockly.FieldCheckbox("FALSE"), "a215").appendField(new Blockly.FieldCheckbox("FALSE"), "a216");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a11").appendField(new Blockly.FieldCheckbox("FALSE"), "a12").appendField(new Blockly.FieldCheckbox("FALSE"), "a13").appendField(new Blockly.FieldCheckbox("FALSE"), "a14").appendField(new Blockly.FieldCheckbox("FALSE"), "a15").appendField(new Blockly.FieldCheckbox("FALSE"), "a16").appendField(new Blockly.FieldCheckbox("FALSE"), "a17").appendField(new Blockly.FieldCheckbox("FALSE"), "a18").appendField(new Blockly.FieldCheckbox("FALSE"), "a19").appendField(new Blockly.FieldCheckbox("FALSE"), "a110").appendField(new Blockly.FieldCheckbox("FALSE"), "a111").appendField(new Blockly.FieldCheckbox("FALSE"), "a112").appendField(new Blockly.FieldCheckbox("FALSE"), "a113").appendField(new Blockly.FieldCheckbox("FALSE"), "a114").appendField(new Blockly.FieldCheckbox("FALSE"), "a115").appendField(new Blockly.FieldCheckbox("FALSE"), "a116");
    this.setOutput(true, Number);
    this.setTooltip();
    
  }
};
//执行器_点阵屏显示_清除屏幕
Blockly.Blocks.ruilong_88display_Matrix_CLEAR = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField(new Blockly.FieldTextInput('myMatrix'), 'matrixName').appendField(Blockly.MIXLY_DISPLAY_MATRIX_SHOW);
    this.appendDummyInput("").setAlign(Blockly.ALIGN_RIGHT).appendField(Blockly.MIXLY_DISPLAY_MATRIX_CLEAR);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    //this.setTooltip();
  }
};
//显示预设图案
Blockly.Blocks.ruilong_88display_Matrix_Ledimg = {
  init: function() {
    this.appendDummyInput("").appendField("8*8点阵预设图案").appendField(new Blockly.FieldDropdown([
      ["↑", "18181818db7e3c18"],
      ["↓", "183c7edb18181818"],
      ["←", "103060ffff603010"],
      ["→", "080c06ffff060c08"],
      ["♥", "183c7effffffff42"],
      ["▲", "00000000ff7e3c18"],
      ["▼", "183c7eff00000000"],
      ["◄", "103070f0f0703010"],
      ["►", "080c0e0f0f0e0c08"],
      ["△", "00000000ff422418"],
      ["▽", "182442ff00000000"],
      ["☺", "3c4299a581a5423c"],
      ["○", "3c4281818181423c"],
      ["◑", "3c4e8f8f8f8f4e3c"],
      ["◐", "3c72f1f1f1f1723c"],
      ["￥", "080808ff08ff2442"],
      ["Χ", "8142241818244281"],
      ["✓", "2050880402010000"],
      ["□", "007e424242427e00"],
      ["▣", "007e425a5a427e00"],
      ["◇", "1824428181422418"],
      ["♀", "107c103844444438"],
      ["♂", "70d888d87905030f"],
      ["♪", "60f87808080b0e0c"],
      ["✈", "203098ffff983020"],
      ["︱", "1010101010101010"],
      ["—", "000000ff00000000"],
      ["╱", "8040201008040201"],
      ["＼", "0102040810204080"],
      ["大", "8244281010fe1010"],
      ["中", "1010fe9292fe1010"],
      ["小", "7010925454101010"],
      ["米", "925438fe38549200"],
      ["正", "ff50505e1010fe00"],
      ["囧", "ffa5a5bdc3a5a5ff"]
    ]), "img_");
    this.setOutput(true);
    this.setTooltip('');
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.setHelpUrl('');
  }
};

Blockly.Blocks.ruilong_816display_Matrix_Ledimg = {
  init: function() {
    this.appendDummyInput("").appendField("8*16点阵预设图案").appendField(new Blockly.FieldDropdown([
      ["❤", "0100038007c00fe01ff01ff00ee00640"],
      ["♥", "00000100038007c00fe00ee004400000"],
      ["▲", "00003ffc1ff80ff007e003c001800000"],
      ["▼", "0000018003c007e00ff01ff83ffc0000"],
      ["◄", "100030007000f000f000700030001000"],
    ["►", "0008000c000e000f000f000e000c0008"],
    ["↑", "01800180018009900db007e003c00180"],
      ["↓", "018003c007e00db00990018001800180"],
      ["←", "180030006000ff00ff00600030001800"],
      ["→", "0018000c000600ff00ff0006000c0018"],
      ["☺", "000003c004200000000022441c380000"],
    ["☹", "0000042003c0000000001c3822440000"],
      ["♀♂", "10707cd8108838d8447944054403380f"],
      ["♪♪", "6060f8f87878080808080b0b0e0e0c0c"],
      ["囧","0ff00a500a500bd00c300a500a500ff0"]
    ]), "img_");
    this.setOutput(true);
    this.setTooltip('');
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.setHelpUrl('');
  }
};



 //执行器-电机转速
 Blockly.Blocks.ruilong_8833motor = {
   init: function() {
     this.setColour(Blockly.Blocks.ruilong.HUE);
   //this.appendDummyInput("").appendField("电机控制");
   this.appendValueInput("ID").setCheck(Number).appendField("HR8833驱动器电机控制");
     this.appendValueInput("SPEED").setCheck(Number).appendField("速度-255~255");
     this.setInputsInline(true);
     this.setPreviousStatement(true);
     this.setNextStatement(true);
  }
};
 //执行器-电机转速
 Blockly.Blocks.ruilong_293motor = {
   init: function() {
     this.setColour(Blockly.Blocks.ruilong.HUE);
   //this.appendDummyInput("").appendField("电机控制");
   this.appendValueInput("ID").setCheck(Number).appendField("L293驱动器电机控制");
     this.appendValueInput("SPEED").setCheck(Number).appendField("速度-255~255");
     this.setInputsInline(true);
     this.setPreviousStatement(true);
     this.setNextStatement(true);
  }
};

var L_PIN=[["A0", "A0"],["A1", "A1"], ["A2", "A2"], ["A6", "A6"],["A7", "A7"]];
var S_PIN=[["A3", "A3"]];
var B_PIN=[["D2", "2"],["D3", "3"]];
var BU_PIN=[["D8", "8"]];
var LED_PIN=[["D9", "9"]];
var U1_PIN=[["D10", "10"]];
var U2_PIN=[["D11", "11"]];
var IR_PIN=[["D12", "12"]];
var BL_PIN=[["D13", "13"]];
var CH_PIN=[["左轮电机D4-D5", "1"],["右轮电机D6-D7", "2"]];


//机器人部分程序
Blockly.Blocks.ruilong_robot_linefinder_pins_analog = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown(L_PIN), 'PIN');
    this.setOutput(true, Number);
  }
};

Blockly.Blocks.ruilong_robot_sound_pins_analog = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown(S_PIN), 'PIN');
    this.setOutput(true, Number);
  }
};

Blockly.Blocks.ruilong_robot_button_pins_digital = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown(B_PIN), 'PIN');
    this.setOutput(true, Number);
  }
};

Blockly.Blocks.ruilong_robot_hc_sr04_trig = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown(U1_PIN), 'PIN1');
    this.setOutput(true, Number);
  }
};

Blockly.Blocks.ruilong_robot_hc_sr04_echo = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown(U2_PIN), 'PIN2');
    this.setOutput(true, Number);
  }
};

Blockly.Blocks.ruilong_robot_pins_ir_recv = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown(IR_PIN), 'PIN');
    this.setOutput(true, Number);
  }
};

Blockly.Blocks.ruilong_robot_pins_blink = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown(BL_PIN), 'PIN');
    this.setOutput(true, Number);
  }
};


Blockly.Blocks.ruilong_robot_pins_8833motor = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown(CH_PIN), 'ID')
    this.setOutput(true, Number);
  }
};

Blockly.Blocks.ruilong_robot_pins_buzzer = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown(BU_PIN), 'PIN')
    this.setOutput(true, Number);
  }
};
Blockly.Blocks.ruilong_robot_pins_led = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown(LED_PIN), 'PIN')
    this.setOutput(true, Number);
  }
};

Blockly.Blocks.ruilong_robot_inout_onoff = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown([["开", "1"], ["关", "0"]]), 'BL')
    this.setOutput(true, Number);
  }
};


Blockly.Blocks.ruilong_robot_linefinder = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("寻迹传感器");
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_robot_sound = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("声音传感器");
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};
Blockly.Blocks.ruilong_robot_tm1650_power = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput()
            .appendField("TM1650四位数码管")
            .appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_LCD_STAT_ON, "displayOn"], [Blockly.MIXLY_LCD_STAT_OFF, "displayOff"], [Blockly.MIXLY_LCD_STAT_CLEAR, "clear"]]), "STAT");
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};

Blockly.Blocks.ruilong_robot_tm1650_displayString = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput()
            .appendField("TM1650四位数码管")
        this.appendValueInput("VALUE")
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField("显示数值");
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};

Blockly.Blocks.ruilong_robot_tm1650_showDot = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput()
            .appendField("TM1650四位数码管")
            .appendField("第")
            .appendField(new Blockly.FieldDropdown([["1", "0"], ["2", "1"], ["3", "2"], ["4", "3"]]), "NO")
            .appendField("个")
            .appendField("小数点")
            .appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_4DIGITDISPLAY_ON, "true"], [Blockly.MIXLY_4DIGITDISPLAY_OFF, "false"]]), "STAT");
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};
Blockly.Blocks.ruilong_robot_button = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("按钮传感器")
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
    this.setOutput(true, Boolean);
  this.setInputsInline(true);
    this.setTooltip('');
  }
};

 //执行器-电机转速
 Blockly.Blocks.ruilong_robot_8833motor = {
   init: function() {
     this.setColour(Blockly.Blocks.ruilong.HUE);
   this.appendValueInput("ID").setCheck(Number).appendField("8833驱动器电机控制");
     this.appendValueInput("SPEED").setCheck(Number).appendField("速度-255~255");
     this.setInputsInline(true);
     this.setPreviousStatement(true);
     this.setNextStatement(true);
  }
};


 //执行器-电机转速
 Blockly.Blocks.ruilong_robot_8833motor2 = {
   init: function() {
     this.setColour(Blockly.Blocks.ruilong.HUE);
   this.appendDummyInput("").appendField("双电机控制");
     this.appendValueInput("SPEED").setCheck(Number).appendField("速度-255~255");
     this.setInputsInline(true);
     this.setPreviousStatement(true);
     this.setNextStatement(true);
  }
};
//蜂鸣器频率
var TONE_NOTES = [
  ["NOTE_C5", "532"],
  ["NOTE_D5", "587"],
  ["NOTE_E5", "659"],
  ["NOTE_F5", "698"],
  ["NOTE_G5", "784"],
  ["NOTE_A5", "880"],
  ["NOTE_B5", "988"],
  ["NOTE_C6", "1048"],
  ["NOTE_D6", "1176"],
  ["NOTE_E6", "1320"],
  ["NOTE_F6", "1396"],
  ["NOTE_G6", "1568"],
  ["NOTE_A6", "1760"],
  ["NOTE_B6", "1976"],
  ["NOTE_C7", "2096"],
  ["NOTE_D7", "2352"],
  ["NOTE_E7", "2640"],
  ["NOTE_F7", "2792"],
  ["NOTE_G7", "3136"],
  ["NOTE_A7", "3520"],
  ["NOTE_B7", "3952"]];

//执行器-蜂鸣器的频率选择
Blockly.Blocks.ruilong_robot_tone_notes = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField(new Blockly.FieldDropdown(TONE_NOTES), 'STAT');
   this.setOutput(true, Number);
  }
};

//执行器-蜂鸣器模块
Blockly.Blocks.ruilong_robot_tone = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("蜂鸣器模块");
    this.appendValueInput("PIN", Number).appendField(Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput('FREQUENCY').setCheck(Number).appendField(Blockly.MIXLY_FREQUENCY);
    this.appendValueInput('DURATION', Number).setCheck(Number).appendField(Blockly.MIXLY_DURATION).appendField("(ms)");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
  }
};

//执行器-蜂鸣器停止模块
Blockly.Blocks.ruilong_robot_newNoTone = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("蜂鸣器停止模块");     
    this.appendValueInput("PIN", Number).appendField(Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("DELAY_TIME", Number).appendField(Blockly.MIXLY_DELAY).setCheck(Number).appendField("(ms)");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
  }
};

//执行器-扬声器模块
Blockly.Blocks.ruilong_speaker_tone = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("扬声器模块")
      .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB802SB.png", 63, 40));
    this.appendValueInput("PIN", Number).appendField(Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput('FREQUENCY').setCheck(Number).appendField(Blockly.MIXLY_FREQUENCY);
    this.appendValueInput('DURATION', Number).setCheck(Number).appendField(Blockly.MIXLY_DURATION).appendField("(ms)");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
  }
};

//执行器-扬声器停止模块
Blockly.Blocks.ruilong_speaker_Notone = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("扬声器停止模块")
  .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB802SB.png", 63, 40));
    this.appendValueInput("PIN", Number).appendField(Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("DELAY_TIME", Number).appendField(Blockly.MIXLY_DELAY).setCheck(Number).appendField("(ms)");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
  }
};


//RGB
Blockly.Blocks.ruilong_robot_rgb_init = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_RGB)
        this.appendValueInput("PIN", Number)
           .setCheck(Number)
           .setAlign(Blockly.ALIGN_RIGHT)
           .appendField(Blockly.MIXLY_PIN);
        this.appendValueInput("LEDCOUNT")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_RGB_COUNT);
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setTooltip('');
    }
};

Blockly.Blocks.ruilong_robot_rgb = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_RGB)
         this.appendValueInput("PIN", Number)
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_PIN);
        this.appendValueInput("_LED_")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_RGB_NUM);
        this.appendValueInput("RVALUE")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_RGB_R);
        this.appendValueInput("GVALUE")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_RGB_G);
        this.appendValueInput("BVALUE")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_RGB_B);
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setTooltip('');
    }
};

Blockly.Blocks.ruilong_robot_rgb_brightness = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_RGB)
        this.appendValueInput("PIN", Number)
           .setCheck(Number)
           .setAlign(Blockly.ALIGN_RIGHT)
           .appendField(Blockly.MIXLY_PIN);
        this.appendValueInput("NUM")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField("亮度");
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setTooltip('');
    }
};

Blockly.Blocks.ruilong_robot_rgb2 = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_RGB)
         this.appendValueInput("PIN", Number)
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_PIN);
        this.appendValueInput("_LED_")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_RGB_NUM);
        this.appendDummyInput("")
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(new Blockly.FieldColour("#ff0000"), "RGB_LED_COLOR");
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};

Blockly.Blocks.ruilong_rgb2 = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_RGB)
         this.appendValueInput("PIN", Number)
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_PIN);
        this.appendValueInput("_LED_")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_RGB_NUM);
        this.appendDummyInput("")
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(new Blockly.FieldColour("#ff0000"), "RGB_LED_COLOR");
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};

Blockly.Blocks.ruilong_robot_rgb3 = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_RGB)
         this.appendValueInput("PIN", Number)
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_PIN);
    this.appendValueInput("NUM")
            .setCheck(Number)
            .appendField("初始亮度");
        this.appendValueInput("WAIT")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField("七彩变换切换时间");
        
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};

Blockly.Blocks.ruilong_robot_rgb4 = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_RGB)
        this.appendValueInput("PIN", Number)
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_PIN);
        this.appendValueInput("NUM")
            .setCheck(Number)
            .appendField("初始亮度");
        this.appendValueInput("WAIT")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField("七彩循环切换时间");
        
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};


//超声测距
Blockly.Blocks.ruilong_robot_hc_sr04 = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
  this.appendDummyInput("")
      .appendField("超声波测距")
    //.appendField(new Blockly.FieldImage("../../media/lobo/RGB_BLOCK.jpg", 33, 32))
  this.appendValueInput("PIN1", Number)
    .setCheck(Number)
    .setAlign(Blockly.ALIGN_RIGHT)
        .appendField("Trig#")
  this.appendValueInput("PIN2", Number)
    .setCheck(Number)
    .setAlign(Blockly.ALIGN_RIGHT)
        .appendField("Echo#");  

  this.setInputsInline(true); 
  this.setOutput(true, Number);
  this.setTooltip('');
  }
};
//红外接收模块
Blockly.Blocks.ruilong_robot_ir_recv = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendValueInput("PIN", Number)
            .appendField(new Blockly.FieldTextInput('ir_item'), 'VAR')
            .appendField(Blockly.MIXLY_IR_RECEIVE)
            .setCheck(Number);
        this.appendStatementInput('DO')
            .appendField(Blockly.MIXLY_IR_RECEIVE_YES);
        this.appendStatementInput('DO2')
            .appendField(Blockly.MIXLY_IR_RECEIVE_NO);
        this.setPreviousStatement(true);
        this.setNextStatement(true);
        this.setInputsInline(true);
        this.setTooltip(Blockly.MIXLY_IR_RECIEVE_TOOLTIP);
    },
    getVars: function () {
        return [this.getFieldValue('VAR')];
    },
    renameVar: function (oldName, newName) {
        if (Blockly.Names.equals(oldName, this.getFieldValue('VAR'))) {
            this.setTitleValue(newName, 'VAR');
        }
    }
};

//蓝色闪灯
Blockly.Blocks.ruilong_robot_blink = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
  this.appendValueInput("PIN").setCheck(Number).appendField("蓝色闪灯");
    this.appendValueInput("BL").setCheck([Number,Boolean]).appendField("设为");
  this.setInputsInline(true); 
    this.setPreviousStatement(true);
    this.setNextStatement(true);
  }
};

Blockly.Blocks.ruilong_robot_blink_read = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("蓝色闪灯状态")
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
    this.setOutput(true, Boolean);
  this.setInputsInline(true);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong.HUE = 120;
//电阻侦测传感器
Blockly.Blocks.ruilong_resistor_scratch = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("电阻侦测传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB013SB.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};
//温度传感器（LM35）
Blockly.Blocks.ruilong_temp = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("温度传感器（LM35）")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB035AA.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};
//热敏传感器
Blockly.Blocks.ruilong_temp2 = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("热敏传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB103NK.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};
//声音传感器
Blockly.Blocks.ruilong_sound = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("声音传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB050SS.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};
//土壤湿度传感器
Blockly.Blocks.ruilong_moisture = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("土壤湿度传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB100SH.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};
//水滴传感器
Blockly.Blocks.ruilong_steam = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("水滴传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB105SS.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};
//寻迹传感器
Blockly.Blocks.ruilong_linefinder = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("寻迹传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB114QR.png", 63, 26));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};
//红外测障传感器
Blockly.Blocks.ruilong_obstacle = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("红外测障传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB188ST.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};
//旋钮传感器
Blockly.Blocks.ruilong_knob = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("旋钮传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB125KS.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};
//滑杆传感器
Blockly.Blocks.ruilong_slider = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("滑杆传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB243SB.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};
//摇杆传感器
Blockly.Blocks.ruilong_joystick_x = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("摇杆传感器(X)")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB506JB.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};
//摇杆传感器
Blockly.Blocks.ruilong_joystick_y = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("摇杆传感器(Y)")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB506JB.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};
//光线传感器
Blockly.Blocks.ruilong_light = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("光线传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB550PT.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};
//气体传感器（MQ系列）
Blockly.Blocks.ruilong_mqx = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("气体传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB011MX.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};
//5按键传感器
Blockly.Blocks.ruilong_5button = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("5按键传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB665AS.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('数值返回1、2、3、4、5，默认为0');
  }
};
//火焰传感器
Blockly.Blocks.ruilong_fire = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("火焰传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB940IR.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};
//mini摇杆传感器
Blockly.Blocks.ruilong_minijoystick = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("mini摇杆传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB019MJ.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('数值返回1、2、3、4、5，默认为0');
  }
};
//浊度传感器
Blockly.Blocks.ruilong_turbidity = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("浊度传感器")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB020TS.png", 63, 40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};

//GD5800 MP3模块
var ruilong_GD5800_MP3_CONTROL_TYPE = [
["播放", "play();"],
["暂停", "pause();"],
["下一曲", "next();"],
["上一曲", "prev();"],
["音量加", "volumeUp();"],
["音量减", "volumeDn();"]
];

//GD5800 MP3模块
Blockly.Blocks.ruilong_GD5800_UART_MP3_CONTROL = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("GD5800 串口MP3模块")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB580GD.png", 63,63));
    this.appendValueInput("RXPIN", Number).appendField("接收(R)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("TXPIN", Number).appendField("发送(T)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendDummyInput("").appendField(Blockly.MIXLY_STAT).appendField(new Blockly.FieldDropdown(ruilong_GD5800_MP3_CONTROL_TYPE), "CONTROL_TYPE");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip();
    this.setHelpUrl();
  }
};

//MP3循环模式
var ruilong_GD5800_MP3_LOOP_MODE = [
[Blockly.MIXLY_MP3_LOOP_ALL, "MP3_LOOP_ALL"],
[Blockly.MIXLY_MP3_LOOP_FOLDER, "MP3_LOOP_FOLDER"],
[Blockly.MIXLY_MP3_LOOP_ONE, "MP3_LOOP_ONE"],
[Blockly.MIXLY_MP3_LOOP_RAM, "MP3_LOOP_RAM"]
];

//GD5800 MP3模块循环模式
Blockly.Blocks.ruilong_GD5800_MP3_LOOP_MODE = {
  init: function () {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("GD5800 串口MP3模块");
    this.appendValueInput("RXPIN", Number).appendField("接收(R)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("TXPIN", Number).appendField("发送(T)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendDummyInput("")
    .appendField(Blockly.MIXLY_MP3_LOOP_MODE)
    .appendField(Blockly.MIXLY_STAT)
    .appendField(new Blockly.FieldDropdown(ruilong_GD5800_MP3_LOOP_MODE), "LOOP_MODE");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip();
    this.setHelpUrl();
  }
};

//MP3 设置EQ
var ruilong_GD5800_MP3_EQ_MODE = [
[Blockly.MIXLY_MP3_EQ_NORMAL, "MP3_EQ_NORMAL"],
[Blockly.MIXLY_MP3_EQ_POP, "MP3_EQ_POP"],
[Blockly.MIXLY_MP3_EQ_ROCK, "MP3_EQ_ROCK"],
[Blockly.MIXLY_MP3_EQ_JAZZ, "MP3_EQ_JAZZ"],
[Blockly.MIXLY_MP3_EQ_CLASSIC, "MP3_EQ_CLASSIC"],
[Blockly.MIXLY_MP3_EQ_BASS, "MP3_EQ_BASS"]
];

//GD5800 MP3模块EQ模式
Blockly.Blocks.ruilong_GD5800_MP3_EQ_MODE = {
  init: function () {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
    .appendField("GD5800 串口MP3模块");
    this.appendValueInput("RXPIN", Number)
    .appendField("接收(R)"+Blockly.MIXLY_PIN)
    .setCheck(Number);
    this.appendValueInput("TXPIN", Number)
    .appendField("发送(T)"+Blockly.MIXLY_PIN)
    .setCheck(Number);
    this.appendDummyInput("")
    .appendField(Blockly.MIXLY_MP3_EQ_MODE)
    .appendField(Blockly.MIXLY_STAT)
    .appendField(new Blockly.FieldDropdown(ruilong_GD5800_MP3_EQ_MODE), "EQ_MODE");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip();
    this.setHelpUrl();
  }
};

//GD5800 MP3模块设置音量
Blockly.Blocks.ruilong_GD5800_MP3_VOL = {
  init: function () {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
    .appendField("GD5800 串口MP3模块");
    this.appendValueInput("RXPIN", Number)
    .appendField("接收(R)"+Blockly.MIXLY_PIN)
    .setCheck(Number);
    this.appendValueInput("TXPIN", Number)
    .appendField("发送(T)"+Blockly.MIXLY_PIN)
    .setCheck(Number);
    this.appendDummyInput("")
    .appendField(Blockly.MIXLY_MP3_VOL);
    this.appendValueInput("vol", Number)
    .appendField(Blockly.MIXLY_STAT)
    .setCheck(Number);
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip();
    this.setHelpUrl();
  }
};

//GD5800 MP3模块播放第N首
Blockly.Blocks.ruilong_GD5800_MP3_PLAY_NUM = {
  init: function () {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
    .appendField("GD5800 串口MP3模块");
    this.appendValueInput("RXPIN", Number)
    .appendField("接收(R)"+Blockly.MIXLY_PIN)
    .setCheck(Number);
    this.appendValueInput("TXPIN", Number)
    .appendField("发送(T)"+Blockly.MIXLY_PIN)
    .setCheck(Number);
    this.appendValueInput("NUM", Number)
    .appendField(Blockly.MIXLY_MP3_PLAY_NUM)
    .setCheck(Number);
    this.appendDummyInput("")
    .appendField("首");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip();
    this.setHelpUrl();
  }
};

//YX5300 MP3模块
var ruilong_YX5300_MP3_CONTROL_TYPE = [
["播放", "play();"],
["暂停", "pause();"],
["停止", "stop();"],
["下一曲", "playNext();"],
["上一曲", "playPrevious();"],
["音量加", "volUp();"],
["音量减", "volDown();"]
];

//YX5300 MP3模块
Blockly.Blocks.ruilong_YX5300_UART_MP3_CONTROL = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("YX5300 串口MP3模块").appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB530YX.png", 63,40));
    this.appendValueInput("RXPIN", Number).appendField("接收(R)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("TXPIN", Number).appendField("发送(T)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendDummyInput("").appendField(Blockly.MIXLY_STAT).appendField(new Blockly.FieldDropdown(ruilong_YX5300_MP3_CONTROL_TYPE), "CONTROL_TYPE");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip();
    this.setHelpUrl();
  }
};
//YX5300 MP3模块设置音量
Blockly.Blocks.ruilong_YX5300_MP3_VOL = {
  init: function () {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("YX5300 串口MP3模块");
    this.appendValueInput("RXPIN", Number).appendField("接收(R)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("TXPIN", Number).appendField("发送(T)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendDummyInput("").appendField(Blockly.MIXLY_MP3_VOL);
    this.appendValueInput("vol", Number).appendField(Blockly.MIXLY_STAT).setCheck(Number);
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip();
    this.setHelpUrl();
  }
};

//YX5300 MP3模块播放第N首
Blockly.Blocks.ruilong_YX5300_MP3_PLAY_NUM = {
  init: function () {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("YX5300 串口MP3模块");
    this.appendValueInput("RXPIN", Number).appendField("接收(R)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("TXPIN", Number).appendField("发送(T)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("NUM", Number).appendField(Blockly.MIXLY_MP3_PLAY_NUM).setCheck(Number);
    this.appendDummyInput("").appendField("首");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip();
    this.setHelpUrl();
  }
};
//YX5300 MP3模块循环播放第N首
Blockly.Blocks.ruilong_YX5300_MP3_PLAYSL = {
  init: function () {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("YX5300 串口MP3模块");
    this.appendValueInput("RXPIN", Number).appendField("接收(R)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("TXPIN", Number).appendField("发送(T)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("NUM", Number).appendField("循环播放第").setCheck(Number);
    this.appendDummyInput("").appendField("首");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip();
    this.setHelpUrl();
  }
};
//YX5300 MP3模块循环播放在F文件夹 第N首
Blockly.Blocks.ruilong_YX5300_MP3_PLAYFSL = {
  init: function () {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("YX5300 串口MP3模块");
    this.appendValueInput("RXPIN", Number).appendField("接收(R)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("TXPIN", Number).appendField("发送(T)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("FOLDER", Number).appendField("循环播放文件夹").setCheck(Number);
    this.appendDummyInput("");
    this.appendValueInput("NUM", Number).appendField("第").setCheck(Number);
    this.appendDummyInput("").appendField("首");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip();
    this.setHelpUrl();
  }
};
//YX5300 MP3模块循环播放文件夹
Blockly.Blocks.ruilong_YX5300_MP3_PLAYF = {
  init: function () {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("YX5300 串口MP3模块");
    this.appendValueInput("RXPIN", Number).appendField("接收(R)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("TXPIN", Number).appendField("发送(T)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("FOLDER", Number).appendField("循环播放文件夹").setCheck(Number);
    this.appendDummyInput("");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip();
    this.setHelpUrl();
  }
};
//N910X MP3模块 控制
var M9101X_S_MP3_CONTROL_TYPE = [
["播放", "play();"],
["暂停", "pause();"],
["停止", "stop();"],
["下一曲", "play_down();"],
["上一曲", "play_up();"],
["全部循环", "cycle_all();"],
["单曲循环", "cycle_single();"],
["切换到TF卡", "set_sd();"],
["切换到U盘", "set_usb_flash();"],
["切换到MP3模式", "set_mp3();"],
["切换到flash模式", "set_flash();"],
["切换音乐风格", "set_eq();"],
];

Blockly.Blocks.ruilong_M9101X_S_MP3_CONTROL = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("M9101X 单线控制 MP3模块")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB911NX.png", 63,63));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
    this.appendDummyInput("").appendField(Blockly.MIXLY_STAT).appendField(new Blockly.FieldDropdown(M9101X_S_MP3_CONTROL_TYPE), "CONTROL_TYPE");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip();
    this.setHelpUrl();
  }
};
//N910X MP3模块 音量设置
Blockly.Blocks.ruilong_M9101X_S_MP3_VOL_CONTROL = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("M9101X 单线控制 MP3模块");
    this.appendValueInput("PIN", Number).appendField(Blockly.MIXLY_PIN).setCheck(Number);
    this.appendDummyInput("").appendField(Blockly.MIXLY_MP3_VOL);
    this.appendValueInput("NUM", Number).appendField(Blockly.MIXLY_STAT).setCheck(Number);
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip();
    this.setHelpUrl();
  }
};

//N910X MP3模块播放第N首
Blockly.Blocks.ruilong_M9101X_S_MP3_PLAY_NUM = {
  init: function () {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("M9101X 单线控制 MP3模块");
    this.appendValueInput("PIN", Number).appendField(Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("NUM", Number).appendField(Blockly.MIXLY_MP3_PLAY_NUM).setCheck(Number);
    this.appendDummyInput("").appendField("首");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip();
    this.setHelpUrl();
  }
};

Blockly.Blocks.ruilong_SYN6288_VOICE_TEXT={
  init:function(){
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("机器人语音模块").appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB628SY.png", 63,63));
    this.appendValueInput("RXPIN", Number).appendField("接收(R)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("TXPIN", Number).appendField("发送(T)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("NUM", Number).appendField("语音编号").setCheck(Number);
    this.appendValueInput("TEXT", String).setCheck([Number, String]).setAlign(Blockly.ALIGN_RIGHT).appendField(" 内容为");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip();
    this.setHelpUrl();  
  }
};

Blockly.Blocks.ruilong_SYN6288_VOICE_NUM={
  init:function(){
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("机器人语音模块");
    this.appendValueInput("RXPIN", Number).appendField("接收(R)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("TXPIN", Number).appendField("发送(T)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("NUM", Number).appendField("变量编号").setCheck(Number);
    this.appendValueInput("VALUE", String).setCheck([Number, String]).setAlign(Blockly.ALIGN_RIGHT).appendField("数值为");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip("数值位数5位以内");
    this.setHelpUrl();  
  }
};

var SYN6288_VOICE_VOL_LIST = [
["静音", "[v0]"],["1", "[v1]"],["2", "[v2]"],["3", "[v3]"],
["4", "[v4]"],["5", "[v5]"],["6", "[v6]"],["7", "[v7]"],
["8", "[v8]"],["9", "[v9]"],["10", "[v10]"],["11", "[v12]"],
["13", "[v13]"],["14", "[v14]"],["15", "[v15]"],["16", "[v16]"]
];

var SYN6288_VOICE_BKVOL_LIST = [
["静音", "[m0]"],["1", "[m1];"],["2", "[m2]"],["3", "[m3];"],
["4", "[m4]"],["5", "[m5];"],["6", "[m6]"],["7", "[m7];"],
["8", "[m8]"],["9", "[m9];"],["10", "[m10]"],["11", "[m12];"],
["13", "[m13]"],["14", "[m14];"],["15", "[m15]"],["16", "[m16];"]
];

var SYN6288_VOICE_SPEED_LIST = [
["0", "[t0]"],["1", "[t1];"],["2", "[t2]"],["3", "[t3];"],
["4", "[t4]"],["5", "[t5];"]
];

Blockly.Blocks.ruilong_SYN6288_VOICE_VOL={
  init:function(){
    this.setColour(Blockly.Blocks.ruilong.HUE);
  this.appendDummyInput("").appendField("机器人语音模块");
    this.appendValueInput("RXPIN", Number).appendField("接收(R)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("TXPIN", Number).appendField("发送(T)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendDummyInput("").appendField("文本播放音量").appendField(Blockly.MIXLY_STAT).appendField(new Blockly.FieldDropdown(SYN6288_VOICE_VOL_LIST), "CONTROL_TYPE");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip();
    this.setHelpUrl();  
  }
};

Blockly.Blocks.ruilong_SYN6288_VOICE_BKVOL={
  init:function(){
    this.setColour(Blockly.Blocks.ruilong.HUE);
  this.appendDummyInput("").appendField("机器人语音模块");
    this.appendValueInput("RXPIN", Number).appendField("接收(R)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("TXPIN", Number).appendField("发送(T)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendDummyInput("").appendField("背景音乐音量").appendField(Blockly.MIXLY_STAT).appendField(new Blockly.FieldDropdown(SYN6288_VOICE_BKVOL_LIST), "CONTROL_TYPE");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip();
    this.setHelpUrl();  
  }
};

Blockly.Blocks.ruilong_SYN6288_VOICE_SPEED={
  init:function(){
    this.setColour(Blockly.Blocks.ruilong.HUE);
  this.appendDummyInput("").appendField("机器人语音模块");   
    this.appendValueInput("RXPIN", Number).appendField("接收(R)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("TXPIN", Number).appendField("发送(T)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendDummyInput("").appendField("语音速度").appendField(Blockly.MIXLY_STAT).appendField(new Blockly.FieldDropdown(SYN6288_VOICE_SPEED_LIST), "CONTROL_TYPE");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip();
    this.setHelpUrl();  
  }
};

var SYN6288_VOICE_CONTROL_TYPE = [
["停止", "Stop();"],
["暂停", "Pause();"],
["恢复", "Recover();"],
["休眠", "EnterSleep();"],
["唤醒", "ExitSleep();"],
];

//SYN6288 语音模块
Blockly.Blocks.ruilong_SYN6288_VOICE_CONTROL = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("机器人语音模块");
    this.appendValueInput("RXPIN", Number).appendField("接收(R)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("TXPIN", Number).appendField("发送(T)"+Blockly.MIXLY_PIN).setCheck(Number);
    this.appendDummyInput("").appendField(Blockly.MIXLY_STAT).appendField(new Blockly.FieldDropdown(SYN6288_VOICE_CONTROL_TYPE), "CONTROL_TYPE");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip();
    this.setHelpUrl();
  }
};


var VS1053_GM1 =         [["大钢琴", "VS1053_GM1_ACOUSTIC_GRAND_PIANO"], //钢琴
                  ["亮音钢琴", "VS1053_GM1_Bright_Acoustic_Piano"],
                  ["大电钢琴", "VS1053_GM1_ELECTRIC_GRAND_PIANO"],
                  ["酒吧钢琴", "VS1053_GM1_Honky_tonk_Piano"],
                  ["电钢琴1", "VS1053_GM1_Electric_Piano_1"],
                  ["电钢琴2", "VS1053_GM1_Electric_Piano_2"],
                  ["大键琴", "VS1053_GM1_Harpsichord"],
                  ["电翼琴", "VS1053_GM1_Clavichord"],
                  ["钢片琴", "VS1053_GM1_Celesta"],//打击乐器
                  ["钟琴","VS1053_GM1_Glockenspiel"],
                  ["八音盒","VS1053_GM1_Music_box"],
                  ["颤音琴","VS1053_GM1_Vibraphone"],
                  ["马林巴","VS1053_GM1_Marimba"],
                  ["木琴", "VS1053_GM1_Xylophone"],
                  ["管钟", "VS1053_GM1_Tubular_Bells"],
                  ["扬琴","VS1053_GM1_Dulcimer"],
                  ["音栓风琴", "VS1053_GM1_Drawbar_Organ"],//风琴
                  ["敲击风琴", "VS1053_GM1_Percussive_Organ"],
                  ["摇滚风琴", "VS1053_GM1_Rock_Organ"],
                  ["教堂风琴", "VS1053_GM1_Church_Organ"],
                  ["簧管风琴", "VS1053_GM1_Reed_Organ"],
                  ["手风琴", "VS1053_GM1_Accordian"],
                  ["口琴 ", "VS1053_GM1_Harmonica"],
                  ["探戈手风琴", "VS1053_GM1_Tango_Accordian"],
                  ["木吉他（尼龙弦）", "VS1053_GM1_Acoustic_Guitar1"],//吉他
                  ["木吉他（钢弦）", "VS1053_GM1_Acoustic_Guitar2"],
                  ["电吉他（爵士）", "VS1053_GM1_Electric_Guitar1"],
                  ["电吉他（清音）", "VS1053_GM1_Electric_Guitar2"],
                  ["电吉他（闷音）","VS1053_GM1_Electric_Guitar3"],
                  ["电吉他（驱动音效）","VS1053_GM1_Overdriven_Guitar"],
                  ["电吉他（失真音效）","VS1053_GM1_Distortion_Guitar"],
                  ["吉他泛音","VS1053_GM1_Guitar_Harmonics"],
                  ["贝斯","VS1053_GM1_Acoustic_Bass"],//贝司
                  ["电贝斯（指奏）","VS1053_GM1_Electric_Bass_finger"],
                  ["电贝斯（拨奏）","VS1053_GM1_Electric_Bass_pick"],
                  ["无品贝斯","VS1053_GM1_Fretless_Bass"],
                  ["捶鈎贝斯1","VS1053_GM1_Slap_Bass1"],
                  ["捶鈎贝斯2","VS1053_GM1_Slap_Bass2"],
                  ["合成贝斯1","VS1053_GM1_Synth_Bass1"],
                  ["合成贝斯2","VS1053_GM1_Synth_Bass2"],
                  ["小提琴","VS1053_GM1_Violin"],//弦乐
                  ["中提琴","VS1053_GM1_Viola"],
                  ["大提琴","VS1053_GM1_Cello"],
                  ["低音大提琴","VS1053_GM1_Contrabass"],
                  ["颤弓弦乐","VS1053_GM1_Tremolo_Strings"],
                  ["弹拨弦乐","VS1053_GM1_Pizzicato_Strings"],
                  ["竖琴","VS1053_GM1_Orchestral_Harp"],
                  ["定音鼓","VS1053_GM1_Timpani"],
                  ["弦乐合奏1","VS1053_GM1_String_Ensemble1"],//合奏
                  ["弦乐合奏2","VS1053_GM1_String_Ensemble2"],
                  ["合成弦乐合奏1","VS1053_GM1_Synth_Strings1"],
                  ["合成弦乐合奏2","VS1053_GM1_Synth_Strings2"],
                  ["人声“啊”","VS1053_GM1_Choir_Aahs"],
                  ["人声“喔”","VS1053_GM1_Voice_Oohs"],
                  ["合成人声","VS1053_GM1_Synth_Voice"],
                  ["交响打击乐","VS1053_GM1_Orchestra_Hit"],
                  ["小号","VS1053_GM1_Trumpet"],//铜管乐器
                  ["长号","VS1053_GM1_Trombone"],
                  ["大号","VS1053_GM1_Tuba"],
                  ["闷音小号","VS1053_GM1_Muted_Trumpet"],
                  ["法国号（圆号）","VS1053_GM1_French_Horn"],
                  ["铜管乐","VS1053_GM1_Brass_Section"],
                  ["合成铜管1","VS1053_GM1_Synth_Brass1"],
                  ["合成铜管2","VS1053_GM1_ynth_Brass2"],
                  ["高音萨克斯风","VS1053_GM1_Soprano_Sax"],//簧乐器
                  ["次中音萨克斯风","VS1053_GM1_Alto_Sax"],
                  ["中音萨克斯风","VS1053_GM1_Tenor_Sax"],
                  ["低音萨克斯风","VS1053_GM1_Baritone_Sax"],
                  ["双簧管","VS1053_GM1_Oboe"],
                  ["英国管","VS1053_GM1_English_Horn"],
                  ["巴松（大管）","VS1053_GM1_Bassoon"],
                  ["单簧管（黑管）","VS1053_GM1_Clarinet"],
                  ["短笛","VS1053_GM1_Piccolo"],//笛 
                  ["长笛","VS1053_GM1_Flute"],
                  ["竖笛","VS1053_GM1_Recorder"],
                  ["排笛","VS1053_GM1_Pan_Flute"],
                  ["瓶笛","VS1053_GM1_Bottle_Blow"],
                  ["尺八","VS1053_GM1_Shakuhachi"],
                  ["哨子","VS1053_GM1_Whistle"],
                  ["陶笛","VS1053_GM1_Ocarina"],
                  ["方波","VS1053_GM1_Lead1"],//合成主音 
                  ["锯齿波","VS1053_GM1_Lead2"],
                  ["汽笛风琴","VS1053_GM1_Lead3"],
                  ["合成吹管","VS1053_GM1_Lead4"],
                  ["合成电吉他","VS1053_GM1_Lead5"],
                  ["人声键盘","VS1053_GM1_Lead6"],
                  ["五度音","VS1053_GM1_Lead7"],
                  ["贝斯吉他合奏","VS1053_GM1_Lead8"],
                  ["新世纪","VS1053_GM1_Pad1"],//合成音色
                  ["温暖","VS1053_GM1_Pad2"],
                  ["多重合音","VS1053_GM1_Pad3"],
                  ["人声合唱","VS1053_GM1_Pad4"],
                  ["玻璃","VS1053_GM1_Pad5"],
                  ["金属","VS1053_GM1_Pad6"],
                  ["光华","VS1053_GM1_Pad7"],
                  ["扫掠","VS1053_GM1_Pad8"],
                  ["雨","VS1053_GM1_FX1"],//合成效果 
                  ["电影音效","VS1053_GM1_FX2"],
                  ["水晶","VS1053_GM1_FX3"],
                  ["气氛","VS1053_GM1_FX4"],
                  ["明亮","VS1053_GM1_FX5"],
                  ["魅影","VS1053_GM1_FX6"],
                  ["回音","VS1053_GM1_FX7"],
                  ["科幻","VS1053_GM1_FX8"],
                  ["西塔琴","VS1053_GM1_Sitar"],//民间乐器
                  ["五弦琴（斑鸠琴）","VS1053_GM1_Banjo"],
                  ["三味线","VS1053_GM1_Shamisen"],
                  ["十三弦琴（古筝）","VS1053_GM1_Koto"],
                  ["卡林巴铁片琴","VS1053_GM1_Kalimba"],
                  ["苏格兰风笛","VS1053_GM1_Bagpipe"],
                  ["古提琴","VS1053_GM1_Fiddle"],
                  ["兽笛","VS1053_GM1_Shanai"],
                  ["叮当铃","VS1053_GM1_Tinkle_Bell"],//打击乐器
                  ["阿哥哥鼓","VS1053_GM1_Agogo"],
                  ["钢鼓","VS1053_GM1_Steel_Drums"],
                  ["木鱼","VS1053_GM1_Woodblock"],
                  ["太鼓","VS1053_GM1_Taiko_Drum"],
                  ["定音筒鼓","VS1053_GM1_Melodic_Tom"],
                  ["合成鼓","VS1053_GM1_Synth_Drum"],
                  ["逆转钹声","VS1053_GM1_Reverse_Cymbal"],
                  ["吉他滑弦杂音","VS1053_GM1_Guitar_Fret_Noise"],//Sound Effects 特殊 音效
                  ["呼吸杂音","VS1053_GM1_122_Breath_Noise"],
                  ["海岸","VS1053_GM1_Seashore"],
                  ["鸟鸣","VS1053_GM1_Bird_Tweet"],
                  ["电话铃声","VS1053_GM1_Telephone_Ring"],
                  ["直升机","VS1053_GM1_Helicopter"],
                  ["拍手","VS1053_GM1_Applause"],
                  ["枪声","VS1053_GM1_Gunshot"]
                  ];

var VS1053_GM1_GM2 = [["电子乐中的按钮声", "VS1053_GM1_GM2_High_Q"],
                  ["拍打声", "VS1053_GM1_GM2_Slap"],
                  ["特效处理推音","VS1053_GM1_GM2_Scratch_Push"],
                  ["特效处理拉（勾）音","VS1053_GM1_GM2_Scratch_Pull"],
                  ["鼓棒敲击声","VS1053_GM1_GM2_Sticks"],
                  ["敲方板","VS1053_GM1_GM2_SquareClick"],
                  ["Click-节拍器击打","VS1053_GM1_GM2_Metronome"],
                  ["节拍器铃声","VS1053_GM1_GM2_Metronome_Bell"],
                  ["原声大鼓（低音大鼓）","VS1053_GM1_GM2_Acoustic_Bass_Drum"],
                  ["大鼓1（低音鼓）","VS1053_GM1_GM2_Bass_Drum_1"],
                  ["敲鼓边","VS1053_GM1_GM2_Side_Stick"],
                  ["原声小鼓（军鼓、小鼓）","VS1053_GM1_GM2_Acoustic_Snare"],
                  ["拍手","VS1053_GM1_GM2_Hand_Clap"],
                  ["电子小鼓（电子军鼓）","VS1053_GM1_GM2_Electric_Snare"],
                  ["低音落地筒鼓","VS1053_GM1_GM2_Low_Floor_Tom"],
                  ["闭合踩镲（闭合双面镲）","VS1053_GM1_GM2_Closed_Hi_Hat"],
                  ["高音落地筒鼓","VS1053_GM1_GM2_High_Floor_Tom"],
                  ["踩镲（踩镲双面镲）","VS1053_GM1_GM2_Pedal_Hi_Hat"],
                  ["低音筒鼓","VS1053_GM1_GM2_Low_Tom"],
                  ["开放（双面）镲","VS1053_GM1_GM2_Open_Hi_Hat"],
                  ["中低音筒鼓","VS1053_GM1_GM2_Low_Mid_Tom"],
                  ["中高音筒鼓","VS1053_GM1_GM2_Hi_Mid_Tom"],
                  ["镲击（吊镲）1","VS1053_GM1_GM2_Crash_Cymbal"],
                  ["高音筒鼓","VS1053_GM1_GM2_High_Tom"],
                  ["高架镲1","VS1053_GM1_GM2_Ride_Cymbal_1"],
                  ["中国镲","VS1053_GM1_GM2_Chinese_Cymbal"],
                  ["悬挂钟玲","VS1053_GM1_GM2_Ride_Bell"],
                  ["铃鼓、小手鼓","VS1053_GM1_GM2_Tambourine"],
                  ["侧击镲、溅开镲声","VS1053_GM1_GM2_Splash_Cymbal"],
                  ["牛铃、颈铃","VS1053_GM1_GM2_Cowbell"],
                  ["镲击（吊镲）2","VS1053_GM1_GM2_Crash_Cymbal"],
                  ["颤击","VS1053_GM1_GM2_Vibraslap"],
                  ["高架镲2","VS1053_GM1_GM2_Ride_Cymbal"],
                  ["高音邦加鼓","VS1053_GM1_GM2_High_Bongo"],
                  ["低音邦加鼓","VS1053_GM1_GM2_Low_Bongo"],
                  ["闷音高音康加鼓","VS1053_GM1_GM2_Mute_Hi_Conga"],
                  ["开放音高音康加鼓","VS1053_GM1_GM2_Open_Hi_Conga"],
                  ["低音康加鼓","VS1053_GM1_GM2_Low_Conga"],
                  ["高音定音鼓","VS1053_GM1_GM2_High_Timbale"],
                  ["低音定音鼓","VS1053_GM1_GM2_Low_Timbale"],
                  ["高音撞铃（拉丁打铃）","VS1053_GM1_GM2_High_Agogo"],
                  ["低音撞铃（拉丁打铃）","VS1053_GM1_GM2_Low_Agogo"],
                  ["卡巴沙铃（珠铃）","VS1053_GM1_GM2_Cabasa"],
                  ["砂槌（砂铃）","VS1053_GM1_GM2_Maracas"],
                  ["短口哨","VS1053_GM1_GM2_Short_Whistle"],
                  ["长口哨","VS1053_GM1_GM2_Long_Whistle"],
                  ["短音刮板（短锯琴、短梗笛）","VS1053_GM1_GM2_Short_Guiro"],
                  ["长音刮板（长梗笛）","VS1053_GM1_GM2_Long_Guiro"],
                  ["音棒","VS1053_GM1_GM2_Claves"],
                  ["高音木鱼","VS1053_GM1_GM2_Hi_Wood_Block"],
                  ["低音木鱼","VS1053_GM1_GM2_Low_Wood_Block"],
                  ["闷音鸟鸣桶（短笛）","VS1053_GM1_GM2_Mute_Cuica"],
                  ["开音鸟鸣桶（短笛）","VS1053_GM1_GM2_Open_Cuica"],
                  ["闷音三角铁（三角铃）","VS1053_GM1_GM2_Mute_Triangle"],
                  ["开音三角铁","VS1053_GM1_GM2_Open_Triangle"],
                  ["摇筛（振动筛）","VS1053_GM1_GM2_Shaker"],
                  ["门铃（信号铃、铃铛）","VS1053_GM1_GM2_Jingle_Bell"],
                  ["铃树（树铃）","VS1053_GM1_GM2_Bell_Tree"],
                  ["响板","VS1053_GM1_GM2_Castinets"],
                  ["闷音苏多鼓","VS1053_GM1_GM2_Mute_Surdo"],
                  ["开音苏多鼓","VS1053_GM1_GM2_Open_Surdo"]];


Blockly.Blocks.ruilong_vs1053_midi_GM1 = {
      init: function() {
  this.setColour(Blockly.Blocks.ruilong.HUE);
  this.appendDummyInput("")         
         .appendField(new Blockly.FieldDropdown(VS1053_GM1),"VS1053_GM1");
  this.setOutput(true,Number);
  }
};


Blockly.Blocks.ruilong_vs1053_midi_Instrument={
    init:function(){
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("设置Midi").appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB153VS.png", 63,63));
    this.appendValueInput("TXPIN", Number).appendField(Blockly.MIXLY_PIN).setCheck(Number);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown([["通道0","0"],["通道1","1"],["通道2","2"],["通道3","3"],
                                            ["通道4","4"],["通道5","5"],["通道6","6"],["通道7","7"],
                                            ["通道8","8"],["通道9","9"],["通道10","10"],["通道11","11"],
                                            ["通道12","12"],["通道13","13"],["通道14","14"],["通道15","15"]]),"CH");
    this.appendValueInput("INSTRUMENT", Number).appendField(new Blockly.FieldDropdown([["旋律乐器","0x79"],["打击乐器","0x78"]]),"TYPE").setCheck(Number).setAlign(Blockly.ALIGN_RIGHT);
    this.appendDummyInput("").appendField("音量");
    this.appendValueInput("MIDIVolume", Number).setCheck(Number).setAlign(Blockly.ALIGN_RIGHT);
    this.setInputsInline(true);
    //var tip="音调/音量范围(0~127)\n";
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip(Blockly.MIXLY_VOLUMEChoose);
    //this.setOutput(true);
  }
};



Blockly.Blocks.ruilong_midiPitch = {
    init: function() {
     var highlist  = [["1","-36"],["2","-24"],["3","-12"],["4","0"],["5","12"],["6","24"],["7","36"]];
     var midipitch  = [["C","60"],["C#","61"],["D","62"],["D#","63"],["E","64"],["F","65"],["F#","66"],["G","67"],["G#","68"],["A","69"],["A#","70"],["B","71"]];
    //this.setHelpUrl(Blockly.Msg.MATH_ARITHMETIC_HELPURL);
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("音区")
        .appendField(new Blockly.FieldDropdown(highlist),"highlist");
    this.appendDummyInput("")
        .appendField("音高")
        .appendField(new Blockly.FieldDropdown(midipitch),"midipitch");
    this.setInputsInline(true);
    this.setOutput(true,Number);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_vs1053_midi_GM1_GM2 = {
   init: function() {
  this.setColour(Blockly.Blocks.ruilong.HUE);
  
  this.appendDummyInput("")
      .appendField("打击乐器")
      .appendField(new Blockly.FieldDropdown(VS1053_GM1_GM2),"VS1053_GM1_GM2");
  this.setOutput(true,Number);

  }
};

Blockly.Blocks.ruilong_vs1053_midi_note={
    init:function(){
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("设置Midi");
    this.appendValueInput("TXPIN", Number).appendField(Blockly.MIXLY_PIN).setCheck(Number);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown([["通道0","0"],["通道1","1"],["通道2","2"],["通道3","3"],
                                            ["通道4","4"],["通道5","5"],["通道6","6"],["通道7","7"],
                                            ["通道8","8"],["通道9","9"],["通道10","10"],["通道11","11"],
                                            ["通道12","12"],["通道13","13"],["通道14","14"],["通道15","15"]]),"CH");
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown([["播放","1"],["停止","0"]]),"NOTE_ON_OFF");
    this.appendValueInput("NOTE", Number)
        .setCheck(Number)
        .setAlign(Blockly.ALIGN_RIGHT);     
    this.appendDummyInput("")
        .appendField("力度");
    this.appendValueInput("VELOCITY", Number)
        .setCheck(Number)
        .setAlign(Blockly.ALIGN_RIGHT);
    this.setInputsInline(true);
    //var tip="音调/音量范围(0~127)\n";
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip(Blockly.MIXLY_VOLUMEChoose);
    //this.setOutput(true);
  }
};

var MOUSE_KEYBOARD_LIST = [
    ["A", "KEY_A"],["B", "KEY_B"],["C", "KEY_C"],["D", "KEY_D"],["E", "KEY_E"],
    ["F", "KEY_F"],["G", "KEY_G"],["H", "KEY_H"],["I", "KEY_I"],["J", "KEY_J"],
    ["K", "KEY_K"],["L", "KEY_L"],["M", "KEY_M"],["N", "KEY_N"],["O", "KEY_O"],
    ["P", "KEY_P"],["Q", "KEY_Q"],["R", "KEY_R"],["S", "KEY_S"],["T", "KEY_T"],
    ["U", "KEY_U"],["V", "KEY_V"],["W", "KEY_W"],["X", "KEY_X"],["Y", "KEY_Y"],
    ["Z", "KEY_Z"],["1", "KEY_1"],["2", "KEY_2"],["3", "KEY_3"],["4", "KEY_4"],
    ["5", "KEY_5"],["6", "KEY_6"],["7", "KEY_7"],["8", "KEY_8"],["9", "KEY_9"],
    ["0", "KEY_0"],["↑", "KEY_UP_ARROW"],["↓", "KEY_DOWN_ARROW"],["←", "KEY_LEFT_ARROW"],["→", "KEY_RIGHT_ARROW"],
    ["鼠标左键", "MOUSE_LEFT"],["鼠标右键", "MOUSE_RIGHT"],["鼠标中键", "MOUSE_MIDDLE"]];

Blockly.Blocks.ruilong_ch9329_mouse_keyboard={
    init:function(){
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("设置键盘鼠标模块").appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB329CH.png", 40,63));;
    this.appendValueInput("TXPIN", Number).appendField(Blockly.MIXLY_PIN).setCheck(Number);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown(MOUSE_KEYBOARD_LIST),"MOUSE_KEYBOARD");
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown([["键盘按下","KEYBOARD_PRESS"],["键盘释放","KEYBOARD_RELEASE"],["键盘全释放","KEYBOARD_RELEASE_ALL"],
                                                ["鼠标按下","MOUSE_PRESS"],["鼠标释放","MOUSE_PRESS"],["鼠标全释放","MOUSE_RELEASEALL"]]),"PRESS_RELEASE");
    this.setInputsInline(true);   
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip(Blockly.MIXLY_VOLUMEChoose);
  }
};

//闪灯模块
Blockly.Blocks.ruilong_lamp = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("闪灯模块")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB003LB.png", 63,40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.appendDummyInput("")
    .appendField(Blockly.MIXLY_STAT)
        .appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_ON, "HIGH"], [Blockly.MIXLY_OFF, "LOW"]]), "STAT");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};
//LED模块
Blockly.Blocks.ruilong_led = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("LED模块")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB005LR.png", 63,40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.appendDummyInput("")
    .appendField(Blockly.MIXLY_STAT)
        .appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_ON, "HIGH"], [Blockly.MIXLY_OFF, "LOW"]]), "STAT");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};
//交通灯
Blockly.Blocks.ruilong_traffic_light = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField("交通灯")
      .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB283TL.png", 120, 40)); 
         this.appendValueInput("PIN", Number)
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_PIN);
        this.appendDummyInput("")
            .appendField(new Blockly.FieldDropdown([["红灯开","#ff0000"],["红灯灭","#000000"]]), 'RGB_LED_COLOR0')
            .appendField(new Blockly.FieldDropdown([["黄灯开","#ffff00"],["黄灯灭","#000000"]]), 'RGB_LED_COLOR1')
            .appendField(new Blockly.FieldDropdown([["绿灯开","#00ff00"],["绿灯灭","#000000"]]), 'RGB_LED_COLOR2');
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};
//蜂鸣器模块
Blockly.Blocks.ruilong_buzzer = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("蜂鸣器模块")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB005AB.png", 63, 40));     
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.appendDummyInput("")
    .appendField(Blockly.MIXLY_STAT)
        .appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_ON, "HIGH"], [Blockly.MIXLY_OFF, "LOW"]]), "STAT");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};
//继电器模块
Blockly.Blocks.ruilong_relay = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("继电器模块(5V/10A)")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB510RB.png", 63, 40));     
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.appendDummyInput("")
    .appendField(Blockly.MIXLY_STAT)
        .appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_ON, "LOW"], [Blockly.MIXLY_OFF, "HIGH"]]), "STAT");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};
//继电器模块
Blockly.Blocks.ruilong_relay_3V = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("继电器模块(3V/3A)")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB303RB.png", 63, 40));     
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.appendDummyInput("")
    .appendField(Blockly.MIXLY_STAT)
        .appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_ON, "LOW"], [Blockly.MIXLY_OFF, "HIGH"]]), "STAT");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};
//震动马达模块
Blockly.Blocks.ruilong_vibrator = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("震动马达模块")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB127VB.png", 63,40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.appendDummyInput("")
    .appendField(Blockly.MIXLY_STAT)
        .appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_ON, "HIGH"], [Blockly.MIXLY_OFF, "LOW"]]), "STAT");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};
//马达风扇模块
Blockly.Blocks.ruilong_motor = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("马达风扇模块")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB300MB.png", 63,40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.appendDummyInput("")
    .appendField(Blockly.MIXLY_STAT)
        .appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_ON, "HIGH"], [Blockly.MIXLY_OFF, "LOW"]]), "STAT");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};
//USB模块
Blockly.Blocks.ruilong_usb = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("USB模块")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB005UP.png", 63,40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.appendDummyInput("")
    .appendField(Blockly.MIXLY_STAT)
        .appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_ON, "HIGH"], [Blockly.MIXLY_OFF, "LOW"]]), "STAT");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};
//语音模块(68段日常用语)
var VOICE_PIN=[["老师", "0x00"],["爸爸", "0x01"],["妈妈", "0x02"],["爷爷", "0x03"],
               ["奶奶", "0x04"],["姥姥", "0x05"],["姥爷", "0x06"],["哥哥", "0x07"],
         ["姐姐", "0x08"],["叔叔", "0x09"],["阿姨", "0x0A"],["上午", "0x0B"],
               ["下午", "0x0C"],["晚上", "0x0D"],["前方", "0x0E"],["厘米", "0x0F"],
               ["新年快乐", "0x10"],["身体健康", "0x11"],["工作顺利", "0x12"],["学习进步", "0x13"],
               ["您好", "0x14"],["谢谢", "0x15"],["的", "0x16"],["祝", "0x17"],
         ["慢走", "0x18"],["欢迎光临", "0x19"],["亲爱的", "0x1A"],["同学们", "0x1B"],
         ["工作辛苦了", "0x1C"],["点", "0x1D"],["打开", "0x1E"],["关闭", "0x1F"],
         ["千", "0x20"],["百", "0x21"],["十", "0x22"],["1", "0x23"],
         ["2", "0x24"],["3", "0x25"],["4", "0x26"],["5", "0x27"],
         ["6", "0x28"],["7", "0x29"],["8", "0x2A"],["9", "0x2B"],
         ["0", "0x2C"],["当前", "0x2D"],["转", "0x2E"],["左", "0x2F"],
         ["右", "0x30"],["请", "0x31"],["已", "0x32"],["现在", "0x33"],
         ["是", "0x34"],["红灯", "0x35"],["绿灯", "0x36"],["黄灯", "0x37"],
         ["温度", "0x38"],["湿度", "0x39"],["欢迎常来", "0x3A"],["还有", "0x3B"],
         ["秒", "0x3C"],["分", "0x3D"],["变", "0x3E"],["等", "0x3F"],
         ["下一次", "0x40"],["功能", "0x41"],["障碍物", "0x42"],["世界那么大，我想去看看", "0x43"]];
        

Blockly.Blocks.ruilong_pins_voice = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown(VOICE_PIN), 'VOICE');
    this.setOutput(true, Number);
  }
};

Blockly.Blocks.ruilong_voice = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("语音模块(68段日常用语)")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB068NV.png", 63,40));
  this.appendValueInput("PIN", Number).appendField(Blockly.MIXLY_PIN).setCheck(Number);
  this.appendValueInput("VOICE").appendField("播放").setCheck(Number);
  this.appendValueInput("WAIT").setCheck(Number).appendField("等待（ms）");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  this.setInputsInline(true);
  }
};

Blockly.Blocks.ruilong_voice_NUM = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("语音模块(68段日常用语)");
  this.appendValueInput("PIN", Number).appendField(Blockly.MIXLY_PIN).setCheck(Number);
  this.appendValueInput("NUM").appendField("播放数值").setCheck(Number);
  this.appendValueInput("WAIT").setCheck(Number).appendField("等待（ms）");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  this.setInputsInline(true);
  }
};

Blockly.Blocks.ruilong_vibrator = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
      .appendField("震动马达模块")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB127VB.png", 63,40));
  this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
  this.appendDummyInput("")
    .appendField(Blockly.MIXLY_STAT)
        .appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_ON, "HIGH"], [Blockly.MIXLY_OFF, "LOW"]]), "STAT");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};



Blockly.Blocks.ruilong_lamp = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField("闪灯模块")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB003LB.png", 63,40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.appendDummyInput("")
		.appendField(Blockly.MIXLY_STAT)
      	.appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_ON, "HIGH"], [Blockly.MIXLY_OFF, "LOW"]]), "STAT");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};

Blockly.Blocks.ruilong_led = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField("LED模块")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB005LR.png", 63,40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.appendDummyInput("")
		.appendField(Blockly.MIXLY_STAT)
      	.appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_ON, "HIGH"], [Blockly.MIXLY_OFF, "LOW"]]), "STAT");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};

Blockly.Blocks.ruilong_traffic_light = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField("交通灯")
			.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB283TL.png", 120, 40)); 
         this.appendValueInput("PIN", Number)
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_PIN);
        this.appendDummyInput("")
            .appendField(new Blockly.FieldDropdown([["红灯开","#ff0000"],["红灯灭","#000000"]]), 'RGB_LED_COLOR0')
            .appendField(new Blockly.FieldDropdown([["黄灯开","#ffff00"],["黄灯灭","#000000"]]), 'RGB_LED_COLOR1')
            .appendField(new Blockly.FieldDropdown([["绿灯开","#00ff00"],["绿灯灭","#000000"]]), 'RGB_LED_COLOR2');
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};

Blockly.Blocks.ruilong_buzzer = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField("蜂鸣器模块")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB005AB.png", 63, 40));   	
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.appendDummyInput("")
		.appendField(Blockly.MIXLY_STAT)
      	.appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_ON, "HIGH"], [Blockly.MIXLY_OFF, "LOW"]]), "STAT");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};

Blockly.Blocks.ruilong_relay = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField("继电器模块(5V/10A)")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB510RB.png", 63, 40));   	
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.appendDummyInput("")
		.appendField(Blockly.MIXLY_STAT)
      	.appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_ON, "LOW"], [Blockly.MIXLY_OFF, "HIGH"]]), "STAT");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};

Blockly.Blocks.ruilong_relay_3V = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField("继电器模块(3V/3A)")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB303RB.png", 63, 40));   	
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.appendDummyInput("")
		.appendField(Blockly.MIXLY_STAT)
      	.appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_ON, "LOW"], [Blockly.MIXLY_OFF, "HIGH"]]), "STAT");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};

Blockly.Blocks.ruilong_vibrator = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField("震动马达模块")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB127VB.png", 63,40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.appendDummyInput("")
		.appendField(Blockly.MIXLY_STAT)
      	.appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_ON, "HIGH"], [Blockly.MIXLY_OFF, "LOW"]]), "STAT");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};

Blockly.Blocks.ruilong_motor = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField("马达风扇模块")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB300MB.png", 63,40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.appendDummyInput("")
		.appendField(Blockly.MIXLY_STAT)
      	.appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_ON, "HIGH"], [Blockly.MIXLY_OFF, "LOW"]]), "STAT");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};

Blockly.Blocks.ruilong_usb = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField("USB模块")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB005UP.png", 63,40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.appendDummyInput("")
		.appendField(Blockly.MIXLY_STAT)
      	.appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_ON, "HIGH"], [Blockly.MIXLY_OFF, "LOW"]]), "STAT");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};



Blockly.Blocks.ruilong_pir = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField("热释电传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB412FC.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
    this.setOutput(true, Boolean);
	this.setInputsInline(true);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_magnetic = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField("磁敏传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB160MS.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
    this.setOutput(true, Boolean);
	this.setInputsInline(true);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_vibration = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField("震动传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB180SW.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
    this.setOutput(true, Boolean);
	this.setInputsInline(true);
    this.setTooltip('');
  }
};




Blockly.Blocks.ruilong_tilt = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField("单向倾角传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB200SW.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
    this.setOutput(true, Boolean);
	this.setInputsInline(true);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_touch = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField("触摸传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB223TP.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
    this.setOutput(true, Boolean);
	this.setInputsInline(true);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_collision = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField("碰撞传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSSP382CS-R.png", 73, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
    this.setOutput(true, Boolean);
	this.setInputsInline(true);
    this.setTooltip('');
  }
};



//DHT11传感器
Blockly.Blocks.ruilong_dht11={
	init: function() {
	var WHAT = [[Blockly.blynk_IOT_IR_TEMP, 'temperature'],[Blockly.MIXLY_Humidity, 'humidity']];
    this.setColour(Blockly.Blocks.ruilong.HUE);
	this.appendValueInput("PIN", Number)
        .appendField("温湿度传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB011HT.png", 63, 40))
		.appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.appendDummyInput("")
	    .appendField(new Blockly.FieldDropdown(WHAT), "WHAT");
	this.setOutput(true, Number);
  }
};
Blockly.Blocks.ruilong_hc_sr04 = {
	init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
	this.appendDummyInput("")
	    .appendField("超声波测距")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB004HP.png", 63, 40))
	this.appendValueInput("PIN1", Number)
		.setCheck(Number)
		.setAlign(Blockly.ALIGN_RIGHT)
        .appendField("Trig#")
	this.appendValueInput("PIN2", Number)
		.setCheck(Number)
		.setAlign(Blockly.ALIGN_RIGHT)
        .appendField("Echo#");	
	this.setInputsInline(true);	
	this.setOutput(true, Number);
	this.setTooltip('');
  }
};
Blockly.Blocks.ruilong_switch = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField("自锁按钮传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB855SW.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
    this.setOutput(true, Boolean);
	this.setInputsInline(true);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_ds18B20 = {
    init: function () {
        var UNIT = [[Blockly.MIXLY_DS18B20_C, '0'], [Blockly.MIXLY_DS18B20_F, '1']];
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendValueInput("PIN", Number)
            .appendField("DS18B20温度传感器")
			.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB182DS.png", 63, 40))
            .setCheck(Number);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_DS18B20_GET_TEMP)
            .appendField(new Blockly.FieldDropdown(UNIT), "UNIT");
        this.setOutput(true, Number);
    }
};

var MRP121_TOUCHLIST = [["E0", "0"],["E1", "1"],["E2", "2"],["E3", "3"],
                        ["E4", "4"],["E5", "5"],["E6", "6"],["E7", "7"],
                        ["E8", "8"],["E9", "9"],["E10", "10"],["E11", "11"]];

Blockly.Blocks.ruilong_MRP121 = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField("MRP121触摸传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB121TS.png", 63, 63));
	this.appendDummyInput()
        .appendField("如果");
	this.appendDummyInput("")
	    .appendField(new Blockly.FieldDropdown(MRP121_TOUCHLIST), 'MRP121_TOUCH');
	this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown([["接触","1"],["释放","0"]]), 'MRP121_TOUCH_STATE');
	this.setInputsInline(true);
    this.appendStatementInput('DO');
	this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip(Blockly.Msg.CONTROLS_IF_IF_TOOLTIP);
	this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_vibrator = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField("震动马达模块")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB127VB.png", 63,40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.appendDummyInput("")
		.appendField(Blockly.MIXLY_STAT)
      	.appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_ON, "HIGH"], [Blockly.MIXLY_OFF, "LOW"]]), "STAT");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};

Blockly.Blocks.ruilong_resistor_scratch = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("电阻侦测传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB013SB.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_temp = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("温度传感器（LM35）")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB035AA.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_temp2 = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("热敏传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB103NK.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_sound = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("声音传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB050SS.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_moisture = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("土壤湿度传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB100SH.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_steam = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("水滴传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB105SS.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_linefinder = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("寻迹传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB114QR.png", 63, 26));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_obstacle = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("红外测障传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB188ST.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_knob = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("旋钮传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB125KS.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_slider = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("滑杆传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB243SB.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_joystick_x = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("摇杆传感器(X)")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB506JB.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_joystick_y = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("摇杆传感器(Y)")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB506JB.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_light = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("光线传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB550PT.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_mqx = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("气体传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB011MX.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_5button = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("5按键传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB665AS.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('数值返回1、2、3、4、5，默认为0');
  }
};

Blockly.Blocks.ruilong_fire = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("火焰传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB940IR.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_minijoystick = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("mini摇杆传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB019MJ.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('数值返回1、2、3、4、5，默认为0');
  }
};

Blockly.Blocks.ruilong_turbidity = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("浊度传感器")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB020TS.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};

//ADS1015模拟数字转换模块-获取数据
var ruilong_ADS1015_setGain = [
["±6.144V 3mv/bit（默认）", "GAIN_TWOTHIRDS"],
["±4.096V 2mv/bit", "GAIN_ONE"],
["±2.048V 1mv/bit", "GAIN_TWO"],
["±1.024V 0.5mv/bit", "GAIN_FOUR"],
["±0.512V 0.25mv/bit", "GAIN_EIGHT"],
["±0.256V 0.125mv/bit", "GAIN_SIXTEEN"],
];

Blockly.Blocks.ruilong_ADS1015_setGain = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
    .appendField(Blockly.MIXLY_SETTING)
    .appendField("ADS1015模数转换模块")
    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB345AD.png", 63, 40))
    .appendField("采样范围和精度");
    this.appendDummyInput("")
    .setAlign(Blockly.ALIGN_RIGHT)
    .appendField(new Blockly.FieldDropdown(ruilong_ADS1015_setGain), "ADS1015_setGain");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip();
  }
};

Blockly.Blocks.ruilong_ADS1015 = {
  init: function () {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("ADS1015模数转换模块")
        .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB345AD.png", 63, 40));
    this.appendDummyInput("")
    .appendField(new Blockly.FieldDropdown([["AIN0","ads.readADC_SingleEnded(0)"],["AIN1","ads.readADC_SingleEnded(1)"],["AIN2","ads.readADC_SingleEnded(2)"],["AIN3","ads.readADC_SingleEnded(3)"]]), "ADS1015_AIN");
    this.setInputsInline(true);
    this.setOutput(true);

  }
};





Blockly.Blocks.ruilong_LCD1602_Print = {
  init: function() {
      this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendValueInput("TEXT", String)
        .setCheck([String,Number])
        .setAlign(Blockly.ALIGN_RIGHT)
		.appendField(Blockly.MIXLY_DF_LCD)
		.appendField(new Blockly.FieldTextInput('mylcd'), 'VAR')
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB162LD.png", 88, 32))
        .appendField(Blockly.MIXLY_LCD_PRINT1);
    this.appendValueInput("TEXT2", String)
        .setCheck([String,Number])
        .setAlign(Blockly.ALIGN_RIGHT)
        .appendField(Blockly.MIXLY_LCD_PRINT2);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};

Blockly.Blocks.ruilong_LCD1602_Print2 = {
  init: function() {
      this.setColour(Blockly.Blocks.ruilong.HUE);
	this.appendValueInput("row", Number)
        .setCheck(Number)
        .setAlign(Blockly.ALIGN_RIGHT)
		.appendField(Blockly.MIXLY_DF_LCD)
		.appendField(new Blockly.FieldTextInput('mylcd'), 'VAR')
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB162LD.png", 88, 32))
        .appendField(Blockly.MIXLY_LCD_ROW);
	this.appendValueInput("column", Number)
        .setCheck(Number)
        .setAlign(Blockly.ALIGN_RIGHT)
        .appendField(Blockly.MIXLY_LCD_COLUMN);
    this.appendValueInput("TEXT", String)
        .setCheck([String,Number])
        .setAlign(Blockly.ALIGN_RIGHT)
        .appendField(Blockly.MIXLY_LCD_PRINT);
    this.setPreviousStatement(true, null);
	this.setInputsInline(true);
    this.setNextStatement(true, null);
  }
};

Blockly.Blocks.ruilong_LCD1602_Power = {
  init: function() {
      this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput()
		.appendField(Blockly.MIXLY_DF_LCD)
		.appendField(new Blockly.FieldTextInput('mylcd'), 'VAR')
        .appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_ON, "display"], [Blockly.MIXLY_OFF, "noDisplay"], [Blockly.MIXLY_LCD_STAT_CURSOR, "cursor"], [Blockly.MIXLY_LCD_STAT_NOCURSOR, "noCursor"], [Blockly.MIXLY_LCD_STAT_CLEAR, "clear"], [Blockly.MIXLY_LCD_NOBACKLIGHT, "noBacklight"], [Blockly.MIXLY_LCD_BACKLIGHT, "backlight"]]), "STAT");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};

//RGB
Blockly.Blocks.ruilong_rgb= {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
	this.appendDummyInput("")
		.appendField("RGB彩灯模块")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB288WS.png", 63, 40));		
	this.appendValueInput("PIN", Number)
		.setCheck(Number)
		.setAlign(Blockly.ALIGN_RIGHT)
        .appendField(Blockly.MIXLY_PIN);
    this.appendValueInput("_LED_")
		.setCheck(Number)
		.setAlign(Blockly.ALIGN_RIGHT)
		.appendField("灯号");	
	this.appendValueInput("RVALUE")
		.setCheck(Number)
		.setAlign(Blockly.ALIGN_RIGHT)
		.appendField("R");  
	this.appendValueInput("GVALUE")
		.setCheck(Number)
		.setAlign(Blockly.ALIGN_RIGHT)
		.appendField("G");	
	this.appendValueInput("BVALUE")
		.setCheck(Number)
		.setAlign(Blockly.ALIGN_RIGHT)
		.appendField("B");
	this.setInputsInline(true);
	this.setPreviousStatement(true, null);
	this.setNextStatement(true, null);
	this.setTooltip('');
  }
};
Blockly.Blocks.ruilong_rgb2 = {
	init: function() {
	this.setColour(Blockly.Blocks.ruilong.HUE);
	this.appendDummyInput("")
		.appendField("RGB显示模块")
		.appendField(new Blockly.FieldImage("../../media/ruilong/rgb.png", 63, 40));			
	this.appendValueInput("PIN", Number)
		.setCheck(Number)
		.setAlign(Blockly.ALIGN_RIGHT)
        .appendField(Blockly.MIXLY_PIN);
    this.appendValueInput("_LED_")
        .setCheck(Number)
		.setAlign(Blockly.ALIGN_RIGHT)
		.appendField(Blockly.MIXLY_RUILONG_RGB_NUM);
    this.appendDummyInput("")
		.setAlign(Blockly.ALIGN_RIGHT)
        .appendField(new Blockly.FieldColour("#ff0000"), "RGB_LED_color");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
  }
};
Blockly.Blocks.ruilong_display_Matrix_DisplayChar = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(Blockly.MIXLY_RGB)
    this.appendValueInput("PIN", Number)
	    .setCheck(Number)
        .setAlign(Blockly.ALIGN_RIGHT)
        .appendField(Blockly.MIXLY_PIN);
	this.appendValueInput("NUM")
        .setCheck(Number)
        .setAlign(Blockly.ALIGN_RIGHT)
        .appendField("初始亮度");//Blockly.MIXLY_RGB_BRIGHTNESS
    this.appendValueInput("RGBArray")
	    .setAlign(Blockly.ALIGN_RIGHT)
		.appendField(Blockly.MIXLY_DISPLAY_MATRIX_PICARRAY);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    //this.setTooltip();
  }
};
Blockly.Blocks.ruilong_display_Matrix_CLEAR = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
	this.appendDummyInput("")
        .appendField(Blockly.MIXLY_RGB)
    this.appendValueInput("PIN", Number)
	    .setCheck(Number)
        .setAlign(Blockly.ALIGN_RIGHT)
        .appendField(Blockly.MIXLY_PIN);
    this.appendDummyInput("")
	    .setAlign(Blockly.ALIGN_RIGHT)
	    .appendField(Blockly.MIXLY_DISPLAY_MATRIX_CLEAR);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    //this.setTooltip();
  }
};
Blockly.Blocks.ruilong_display_Matrix_LedArray = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField(Blockly.MIXLY_DISPLAY_MATRIX_ARRAYVAR)
		.appendField(new Blockly.FieldTextInput("RGBArray1"), "VAR");
    this.appendDummyInput("")
	.appendField(new Blockly.FieldColour("#ff0000"), "RGB_15")
	.appendField(new Blockly.FieldColour("#ffffff"), "RGB_14")
	.appendField(new Blockly.FieldColour("#ff0000"), "RGB_13")
	.appendField(new Blockly.FieldColour("#ffffff"), "RGB_12")
	.appendField(new Blockly.FieldColour("#ff0000"), "RGB_11");
    this.appendDummyInput("")
	.appendField(new Blockly.FieldColour("#ffffff"), "RGB_25")
	.appendField(new Blockly.FieldColour("#ffffff"), "RGB_24")
	.appendField(new Blockly.FieldColour("#ffffff"), "RGB_23")
	.appendField(new Blockly.FieldColour("#ffffff"), "RGB_22")
	.appendField(new Blockly.FieldColour("#ffffff"), "RGB_21");
    this.appendDummyInput("")
	.appendField(new Blockly.FieldColour("#ffffff"), "RGB_35")
	.appendField(new Blockly.FieldColour("#ffffff"), "RGB_34")
	.appendField(new Blockly.FieldColour("#ffffff"), "RGB_33")
	.appendField(new Blockly.FieldColour("#ffffff"), "RGB_32")
	.appendField(new Blockly.FieldColour("#ffffff"), "RGB_31");
    this.appendDummyInput("")
	.appendField(new Blockly.FieldColour("#ff0000"), "RGB_45")
	.appendField(new Blockly.FieldColour("#ffffff"), "RGB_44")
	.appendField(new Blockly.FieldColour("#ffffff"), "RGB_43")
	.appendField(new Blockly.FieldColour("#ffffff"), "RGB_42")
	.appendField(new Blockly.FieldColour("#ff0000"), "RGB_41");	
	this.appendDummyInput("")
	.appendField(new Blockly.FieldColour("#ff0000"), "RGB_55")
	.appendField(new Blockly.FieldColour("#ff0000"), "RGB_54")
	.appendField(new Blockly.FieldColour("#ffffff"), "RGB_53")
	.appendField(new Blockly.FieldColour("#ff0000"), "RGB_52")
	.appendField(new Blockly.FieldColour("#ff0000"), "RGB_51");	
    this.setOutput(true, Number);
    //this.setTooltip();
  }
};

Blockly.Blocks.ruilong_display_Matrix_DisplayChar2 = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(Blockly.MIXLY_RGB)
    this.appendValueInput("PIN", Number)
	    .setCheck(Number)
        .setAlign(Blockly.ALIGN_LEFT)
        .appendField(Blockly.MIXLY_PIN);
	this.appendValueInput("NUM")
        .setCheck(Number)
        .setAlign(Blockly.ALIGN_LEFT)
        .appendField("初始亮度");
	this.appendDummyInput("")
		.setAlign(Blockly.ALIGN_LEFT)
		.appendField("颜色")
        .appendField(new Blockly.FieldColour("#ff0000"), "RGB_DOT_COLOR");
    this.appendValueInput("RGBArray_dot")
	    .setAlign(Blockly.ALIGN_LEFT)
		.appendField(Blockly.MIXLY_DISPLAY_MATRIX_PICARRAY);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    //this.setTooltip();
  }
};

Blockly.Blocks.ruilong_display_Matrix_LedArray2 = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField(Blockly.MIXLY_DISPLAY_MATRIX_ARRAYVAR)
		.appendField(new Blockly.FieldTextInput("RGBArray2"), "VAR");
    this.appendDummyInput("")
	.appendField(new Blockly.FieldCheckbox("FALSE"), "DOT_15")
	.appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_14")
	.appendField(new Blockly.FieldCheckbox("FALSE"), "DOT_13")
	.appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_12")
	.appendField(new Blockly.FieldCheckbox("FALSE"), "DOT_11");
    this.appendDummyInput("")
	.appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_25")
	.appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_24")
	.appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_23")
	.appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_22")
	.appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_21");
    this.appendDummyInput("")
	.appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_35")
	.appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_34")
	.appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_33")
	.appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_32")
	.appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_31");
    this.appendDummyInput("")
	.appendField(new Blockly.FieldCheckbox("FALSE"), "DOT_45")
	.appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_44")
	.appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_43")
	.appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_42")
	.appendField(new Blockly.FieldCheckbox("FALSE"), "DOT_41");	
	this.appendDummyInput("")
	.appendField(new Blockly.FieldCheckbox("FALSE"), "DOT_55")
	.appendField(new Blockly.FieldCheckbox("FALSE"), "DOT_54")
	.appendField(new Blockly.FieldCheckbox("TRUE"), "DOT_53")
	.appendField(new Blockly.FieldCheckbox("FALSE"), "DOT_52")
	.appendField(new Blockly.FieldCheckbox("FALSE"), "DOT_51");	
    this.setOutput(true, Number);
    //this.setTooltip();
  }
};
Blockly.Blocks.ruilong_tm1650_power = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput()
            .appendField("TM1650四位数码管")
			.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB056DB.png", 88, 32))
            .appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_ON, "displayOn"], [Blockly.MIXLY_OFF, "displayOff"], [Blockly.MIXLY_LCD_STAT_CLEAR, "clear"]]), "STAT");
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};

Blockly.Blocks.ruilong_tm1650_displayString = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput()
            .appendField("TM1650四位数码管")
			.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB056DB.png", 88, 32));
        this.appendValueInput("VALUE")
//            .setCheck(String)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField("显示字符串");
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};

Blockly.Blocks.ruilong_tm1650_showDot = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput()
            .appendField("TM1650四位数码管")
			.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB056DB.png", 88, 32))
            .appendField("第")
            .appendField(new Blockly.FieldDropdown([["1", "0"], ["2", "1"], ["3", "2"], ["4", "3"]]), "NO")
            .appendField("个")
            .appendField("小数点")
            .appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_4DIGITDISPLAY_ON, "true"], [Blockly.MIXLY_4DIGITDISPLAY_OFF, "false"]]), "STAT");
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};

//显示-TM1637初始化
Blockly.Blocks.ruilong_tm1637_init = {
  init: function() {
	this.appendDummyInput()
		.appendField("TM1637四位数码管")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB057DB.png", 88, 32));
    this.appendValueInput("PIN2").setCheck(Number).setAlign(Blockly.ALIGN_RIGHT).appendField("DIO").appendField(Blockly.MIXLY_PIN);
    this.appendValueInput("PIN1").setCheck(Number).setAlign(Blockly.ALIGN_RIGHT).appendField("CLK").appendField(Blockly.MIXLY_PIN);

    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.setInputsInline(true);
    this.setTooltip("");
    this.setHelpUrl("");
  }
};

//显示-TM1637-4位数码管显示字符串
Blockly.Blocks.ruilong_tm1637_displayString = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput()
	    .appendField("TM1637四位数码管")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB057DB.png", 88, 32));
	this.appendDummyInput()
	    .appendField("显示字符串");
    this.appendValueInput("VALUE")
	    .setCheck(String)
	    .setAlign(Blockly.ALIGN_RIGHT);
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip("");
  }
};

//显示-TM1637-4位数码管显示时间
Blockly.Blocks.ruilong_tm1637_displayTime = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput()
	    .appendField("TM1637四位数码管")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB057DB.png", 88, 32));
	this.appendDummyInput()
	    .appendField("显示时间");
    this.appendValueInput("hour").setCheck(Number).setAlign(Blockly.ALIGN_RIGHT);
    this.appendDummyInput("").appendField(Blockly.MAKER17_HOUR);
    this.appendValueInput("minute").setCheck(Number).setAlign(Blockly.ALIGN_RIGHT);
    this.appendDummyInput("").appendField(Blockly.MAKER17_MINUTE);
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip("");
  }
};

//显示-TM1637-4位数码管设置亮度
Blockly.Blocks.ruilong_tm1637_Brightness = {
  init: function() {
     this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput()
	    .appendField("TM1637四位数码管")
		.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB057DB.png", 88, 32));
    this.appendDummyInput()
	    .appendField("设置亮度");
    this.appendValueInput('BRIGHTNESS').setCheck(Number);
    this.appendDummyInput("").appendField("%");
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setInputsInline(true);
  }
};

Blockly.Blocks.ruilong_88display_Matrix_Init = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField(Blockly.MIXLY_DISPLAY_MATRIX_INIT);
    this.appendDummyInput("").setAlign(Blockly.ALIGN_RIGHT).appendField(new Blockly.FieldTextInput('myMatrix'), 'matrixName');
    this.appendValueInput("PIN1").setCheck(Number).setAlign(Blockly.ALIGN_RIGHT).appendField("SDA#");
    this.appendValueInput("PIN2").setCheck(Number).setAlign(Blockly.ALIGN_RIGHT).appendField("SCL#"); 
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
//   this.setTooltip("display_点阵屏初始化");
   }
};

//执行器_点阵屏显示_画点变量
var ruilong_88display_DrawPixel_NUM = [
  [Blockly.MIXLY_4DIGITDISPLAY_ON, "1"],
  [Blockly.MIXLY_4DIGITDISPLAY_OFF, "0"]
];

//执行器_点阵屏显示_画点显示
Blockly.Blocks.ruilong_88display_Matrix_POS = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField(new Blockly.FieldTextInput('myMatrix'), 'matrixName').appendField(Blockly.MIXLY_DISPLAY_MATRIX_SHOW);
    this.appendValueInput('XVALUE').setCheck(Number).setAlign(Blockly.ALIGN_RIGHT).appendField(Blockly.MIXLY_DISPLAY_MATRIX_X);
    this.appendValueInput("YVALUE").setCheck(Number).setAlign(Blockly.ALIGN_RIGHT).appendField(Blockly.MIXLY_DISPLAY_MATRIX_Y);
    this.appendDummyInput("").setAlign(Blockly.ALIGN_RIGHT).appendField(Blockly.MIXLY_DISPLAY_MATRIX_SHOWPOINT).appendField(new Blockly.FieldDropdown(ruilong_88display_DrawPixel_NUM), "DrawPixel_TYPE");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip(Blockly.MIXLY_DISPLAY_MATRIX_SHOWPOINT_TOOLTIP);
  }
};
//执行器_点阵屏显示_旋转变量
var ruilong_88display_Rotation_NUM = [
  ["0°", "0"],
  ["-90°", "1"],
  ["+90°", "3"],
  ["180°", "2"]
];

//执行器_点阵屏显示_显示旋转
Blockly.Blocks.ruilong_88display_Matrix_Rotation = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField(new Blockly.FieldTextInput('myMatrix'), 'matrixName').appendField(Blockly.MIXLY_DISPLAY_MATRIX_SHOW);
    this.appendDummyInput("").setAlign(Blockly.ALIGN_RIGHT).appendField(Blockly.MIXLY_DISPLAY_MATRIX_ROTATE).appendField(new Blockly.FieldDropdown(ruilong_88display_Rotation_NUM), "Rotation_TYPE");
    this.setPreviousStatement(true);
    this.setNextStatement(true);
 //   this.setTooltip("");
  }
};
//执行器_点阵屏显示_字符显示
Blockly.Blocks.ruilong_88display_Matrix_TEXT={
  init:function(){
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField(new Blockly.FieldTextInput('myMatrix'), 'matrixName').appendField(Blockly.MIXLY_DISPLAY_MATRIX_SHOW);
    this.appendValueInput("TEXT", String).setCheck([Number, String]).setAlign(Blockly.ALIGN_RIGHT).appendField(" 显示");
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setInputsInline(true);
    //this.setTooltip("");
  }
};
//执行器_点阵屏显示_显示图案
Blockly.Blocks.ruilong_88display_Matrix_DisplayChar = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField(new Blockly.FieldTextInput('myMatrix'), 'matrixName')
		.appendField(Blockly.MIXLY_DISPLAY_MATRIX_SHOW);
    this.appendValueInput("LEDArrayX")
	    .setAlign(Blockly.ALIGN_RIGHT)
	    .appendField(Blockly.MIXLY_DISPLAY_MATRIX_PICARRAY);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    //this.setTooltip();
  }
};
//执行器_点阵屏显示_图案数组
Blockly.Blocks.ruilong_88display_Matrix_LedArray = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField(Blockly.MIXLY_DISPLAY_MATRIX_ARRAYVAR)
		.appendField(new Blockly.FieldTextInput("LedArray1"), "VAR");
    this.appendDummyInput("")
	.appendField(new Blockly.FieldCheckbox("FALSE"), "a81")
	.appendField(new Blockly.FieldCheckbox("FALSE"), "a82")
	.appendField(new Blockly.FieldCheckbox("FALSE"), "a83")
	.appendField(new Blockly.FieldCheckbox("FALSE"), "a84")
	.appendField(new Blockly.FieldCheckbox("FALSE"), "a85")
	.appendField(new Blockly.FieldCheckbox("FALSE"), "a86")
	.appendField(new Blockly.FieldCheckbox("FALSE"), "a87")
	.appendField(new Blockly.FieldCheckbox("FALSE"), "a88");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a71").appendField(new Blockly.FieldCheckbox("FALSE"), "a72").appendField(new Blockly.FieldCheckbox("FALSE"), "a73").appendField(new Blockly.FieldCheckbox("FALSE"), "a74").appendField(new Blockly.FieldCheckbox("FALSE"), "a75").appendField(new Blockly.FieldCheckbox("FALSE"), "a76").appendField(new Blockly.FieldCheckbox("FALSE"), "a77").appendField(new Blockly.FieldCheckbox("FALSE"), "a78");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a61").appendField(new Blockly.FieldCheckbox("FALSE"), "a62").appendField(new Blockly.FieldCheckbox("FALSE"), "a63").appendField(new Blockly.FieldCheckbox("FALSE"), "a64").appendField(new Blockly.FieldCheckbox("FALSE"), "a65").appendField(new Blockly.FieldCheckbox("FALSE"), "a66").appendField(new Blockly.FieldCheckbox("FALSE"), "a67").appendField(new Blockly.FieldCheckbox("FALSE"), "a68");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a51").appendField(new Blockly.FieldCheckbox("FALSE"), "a52").appendField(new Blockly.FieldCheckbox("FALSE"), "a53").appendField(new Blockly.FieldCheckbox("FALSE"), "a54").appendField(new Blockly.FieldCheckbox("FALSE"), "a55").appendField(new Blockly.FieldCheckbox("FALSE"), "a56").appendField(new Blockly.FieldCheckbox("FALSE"), "a57").appendField(new Blockly.FieldCheckbox("FALSE"), "a58");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a41").appendField(new Blockly.FieldCheckbox("FALSE"), "a42").appendField(new Blockly.FieldCheckbox("FALSE"), "a43").appendField(new Blockly.FieldCheckbox("FALSE"), "a44").appendField(new Blockly.FieldCheckbox("FALSE"), "a45").appendField(new Blockly.FieldCheckbox("FALSE"), "a46").appendField(new Blockly.FieldCheckbox("FALSE"), "a47").appendField(new Blockly.FieldCheckbox("FALSE"), "a48");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a31").appendField(new Blockly.FieldCheckbox("FALSE"), "a32").appendField(new Blockly.FieldCheckbox("FALSE"), "a33").appendField(new Blockly.FieldCheckbox("FALSE"), "a34").appendField(new Blockly.FieldCheckbox("FALSE"), "a35").appendField(new Blockly.FieldCheckbox("FALSE"), "a36").appendField(new Blockly.FieldCheckbox("FALSE"), "a37").appendField(new Blockly.FieldCheckbox("FALSE"), "a38");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a21").appendField(new Blockly.FieldCheckbox("FALSE"), "a22").appendField(new Blockly.FieldCheckbox("FALSE"), "a23").appendField(new Blockly.FieldCheckbox("FALSE"), "a24").appendField(new Blockly.FieldCheckbox("FALSE"), "a25").appendField(new Blockly.FieldCheckbox("FALSE"), "a26").appendField(new Blockly.FieldCheckbox("FALSE"), "a27").appendField(new Blockly.FieldCheckbox("FALSE"), "a28");
    this.appendDummyInput("").appendField(new Blockly.FieldCheckbox("FALSE"), "a11").appendField(new Blockly.FieldCheckbox("FALSE"), "a12").appendField(new Blockly.FieldCheckbox("FALSE"), "a13").appendField(new Blockly.FieldCheckbox("FALSE"), "a14").appendField(new Blockly.FieldCheckbox("FALSE"), "a15").appendField(new Blockly.FieldCheckbox("FALSE"), "a16").appendField(new Blockly.FieldCheckbox("FALSE"), "a17").appendField(new Blockly.FieldCheckbox("FALSE"), "a18");
    this.setOutput(true, Number);
    //this.setTooltip();
  }
};
//执行器_点阵屏显示_清除屏幕
Blockly.Blocks.ruilong_88display_Matrix_CLEAR = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField(new Blockly.FieldTextInput('myMatrix'), 'matrixName').appendField(Blockly.MIXLY_DISPLAY_MATRIX_SHOW);
    this.appendDummyInput("").setAlign(Blockly.ALIGN_RIGHT).appendField(Blockly.MIXLY_DISPLAY_MATRIX_CLEAR);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
    //this.setTooltip();
  }
};

var L_PIN=[["A0", "A0"],["A1", "A1"], ["A2", "A2"], ["A6", "A6"],["A7", "A7"]];
var S_PIN=[["A3", "A3"]];
var B_PIN=[["D2", "2"],["D3", "3"]];
var BU_PIN=[["D8", "8"]];
var LED_PIN=[["D9", "9"]];
var U1_PIN=[["D10", "10"]];
var U2_PIN=[["D11", "11"]];
var IR_PIN=[["D12", "12"]];
var BL_PIN=[["D13", "13"]];
var CH_PIN=[["左轮电机D4-D5", "1"],["右轮电机D6-D7", "2"]];


//机器人部分程序
Blockly.Blocks.ruilong_robot_linefinder_pins_analog = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown(L_PIN), 'PIN');
    this.setOutput(true, Number);
  }
};

Blockly.Blocks.ruilong_robot_sound_pins_analog = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown(S_PIN), 'PIN');
    this.setOutput(true, Number);
  }
};

Blockly.Blocks.ruilong_robot_button_pins_digital = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown(B_PIN), 'PIN');
    this.setOutput(true, Number);
  }
};

Blockly.Blocks.ruilong_robot_hc_sr04_trig = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown(U1_PIN), 'PIN1');
    this.setOutput(true, Number);
  }
};

Blockly.Blocks.ruilong_robot_hc_sr04_echo = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown(U2_PIN), 'PIN2');
    this.setOutput(true, Number);
  }
};

Blockly.Blocks.ruilong_robot_pins_ir_recv = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown(IR_PIN), 'PIN');
    this.setOutput(true, Number);
  }
};

Blockly.Blocks.ruilong_robot_pins_blink = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown(BL_PIN), 'PIN');
    this.setOutput(true, Number);
  }
};


Blockly.Blocks.ruilong_robot_pins_8833motor = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown(CH_PIN), 'ID')
    this.setOutput(true, Number);
  }
};

Blockly.Blocks.ruilong_robot_pins_buzzer = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown(BU_PIN), 'PIN')
    this.setOutput(true, Number);
  }
};
Blockly.Blocks.ruilong_robot_pins_led = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown(LED_PIN), 'PIN')
    this.setOutput(true, Number);
  }
};

Blockly.Blocks.ruilong_robot_inout_onoff = {
   init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField(new Blockly.FieldDropdown([["开", "1"], ["关", "0"]]), 'BL')
    this.setOutput(true, Number);
    //this.setTooltip(Blockly.MIXLY_TOOLTIP_INOUT_HIGHLOW);
  }
};


Blockly.Blocks.ruilong_robot_linefinder = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("寻迹传感器");
		//.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB114QR.png", 63, 26));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};

Blockly.Blocks.ruilong_robot_sound = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
        .appendField("声音传感器");
		//.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB114QR.png", 63, 26));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
	this.setInputsInline(true);
    this.setOutput(true, Number);
    this.setTooltip('');
  }
};
Blockly.Blocks.ruilong_robot_tm1650_power = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput()
            .appendField("TM1650四位数码管")
			//.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB056DB.png", 88, 32))
            .appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_ON, "displayOn"], [Blockly.MIXLY_OFF, "displayOff"], [Blockly.MIXLY_LCD_STAT_CLEAR, "clear"]]), "STAT");
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};

Blockly.Blocks.ruilong_robot_tm1650_displayString = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput()
            .appendField("TM1650四位数码管")
			//.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB056DB.png", 88, 32));
        this.appendValueInput("VALUE")
//            .setCheck(String)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField("显示数值");
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};

Blockly.Blocks.ruilong_robot_tm1650_showDot = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput()
            .appendField("TM1650四位数码管")
			//.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB056DB.png", 88, 32))
            .appendField("第")
            .appendField(new Blockly.FieldDropdown([["1", "0"], ["2", "1"], ["3", "2"], ["4", "3"]]), "NO")
            .appendField("个")
            .appendField("小数点")
            .appendField(new Blockly.FieldDropdown([[Blockly.MIXLY_4DIGITDISPLAY_ON, "true"], [Blockly.MIXLY_4DIGITDISPLAY_OFF, "false"]]), "STAT");
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};
Blockly.Blocks.ruilong_robot_button = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField("按钮传感器")
		//.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB405BS-W.png", 63, 40));
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
    this.setOutput(true, Boolean);
	this.setInputsInline(true);
    this.setTooltip('');
  }
};

 //执行器-电机转速
 Blockly.Blocks.ruilong_robot_8833motor = {
   init: function() {
     this.setColour(Blockly.Blocks.ruilong.HUE);
	 //this.appendDummyInput("").appendField("电机控制");
	 this.appendValueInput("ID").setCheck(Number).appendField("8833驱动器电机控制");
     this.appendValueInput("SPEED").setCheck(Number).appendField("速度-255~255");
     this.setInputsInline(true);
     this.setPreviousStatement(true);
     this.setNextStatement(true);
  }
};
 //执行器-电机转速
 Blockly.Blocks.ruilong_robot_293motor = {
   init: function() {
     this.setColour(Blockly.Blocks.ruilong.HUE);
	 //this.appendDummyInput("").appendField("电机控制");
	 this.appendValueInput("ID").setCheck(Number).appendField("L293驱动器电机控制");
     this.appendValueInput("SPEED").setCheck(Number).appendField("速度-255~255");
     this.setInputsInline(true);
     this.setPreviousStatement(true);
     this.setNextStatement(true);
  }
};

 //执行器-电机转速
 Blockly.Blocks.ruilong_robot_8833motor2 = {
   init: function() {
     this.setColour(Blockly.Blocks.ruilong.HUE);
	 this.appendDummyInput("").appendField("双电机控制");
	 //this.appendValueInput("ID").setCheck(Number).appendField("电机控制");
     this.appendValueInput("SPEED").setCheck(Number).appendField("速度-255~255");
     this.setInputsInline(true);
     this.setPreviousStatement(true);
     this.setNextStatement(true);
  }
};
//蜂鸣器频率
var TONE_NOTES = [
   ["NOTE_C5", "532"],
  ["NOTE_D5", "587"],
  ["NOTE_E5", "659"],
  ["NOTE_F5", "698"],
  ["NOTE_G5", "784"],
  ["NOTE_A5", "880"],
  ["NOTE_B5", "988"],
  ["NOTE_C6", "1048"],
  ["NOTE_D6", "1176"],
  ["NOTE_E6", "1320"],
  ["NOTE_F6", "1396"],
  ["NOTE_G6", "1568"],
  ["NOTE_A6", "1760"],
  ["NOTE_B6", "1976"],
  ["NOTE_C7", "2096"],
  ["NOTE_D7", "2352"],
  ["NOTE_E7", "2640"],
  ["NOTE_F7", "2792"],
  ["NOTE_G7", "3136"],
  ["NOTE_A7", "3520"],
  ["NOTE_B7", "3952"]];

//执行器-蜂鸣器的频率选择
Blockly.Blocks.ruilong_robot_tone_notes = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField(new Blockly.FieldDropdown(TONE_NOTES), 'STAT');
   this.setOutput(true, Number);
  }
};

//执行器-蜂鸣器模块
Blockly.Blocks.ruilong_robot_tone = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("蜂鸣器模块");
    this.appendValueInput("PIN", Number).appendField(Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput('FREQUENCY').setCheck(Number).appendField(Blockly.MIXLY_FREQUENCY);
    this.appendValueInput('DURATION', Number).setCheck(Number).appendField(Blockly.MIXLY_DURATION).appendField("(ms)");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
  }
};

//执行器-蜂鸣器停止模块
Blockly.Blocks.ruilong_robot_newNoTone = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("蜂鸣器停止模块");	    
    this.appendValueInput("PIN", Number).appendField(Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("DELAY_TIME", Number).appendField(Blockly.MIXLY_DELAY).setCheck(Number).appendField("(ms)");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
  }
};

//执行器-扬声器模块
Blockly.Blocks.ruilong_speaker_tone = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("扬声器模块")
	    .appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB802SB.png", 63, 40));
    this.appendValueInput("PIN", Number).appendField(Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput('FREQUENCY').setCheck(Number).appendField(Blockly.MIXLY_FREQUENCY);
    this.appendValueInput('DURATION', Number).setCheck(Number).appendField(Blockly.MIXLY_DURATION).appendField("(ms)");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
  }
};

//执行器-扬声器停止模块
Blockly.Blocks.ruilong_speaker_Notone = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("").appendField("扬声器停止模块")
	.appendField(new Blockly.FieldImage("../../media/ruilong/RLSEB802SB.png", 63, 40));
    this.appendValueInput("PIN", Number).appendField(Blockly.MIXLY_PIN).setCheck(Number);
    this.appendValueInput("DELAY_TIME", Number).appendField(Blockly.MIXLY_DELAY).setCheck(Number).appendField("(ms)");
    this.setInputsInline(true);
    this.setPreviousStatement(true);
    this.setNextStatement(true);
  }
};


//RGB
Blockly.Blocks.ruilong_robot_rgb_init = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_RGB)
        this.appendValueInput("PIN", Number)
           .setCheck(Number)
           .setAlign(Blockly.ALIGN_RIGHT)
           .appendField(Blockly.MIXLY_PIN);
        this.appendValueInput("LEDCOUNT")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_RGB_COUNT);
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setTooltip('');
    }
};

Blockly.Blocks.ruilong_robot_rgb = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_RGB)
         this.appendValueInput("PIN", Number)
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_PIN);
        this.appendValueInput("_LED_")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_RGB_NUM);
        this.appendValueInput("RVALUE")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_RGB_R);
        this.appendValueInput("GVALUE")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_RGB_G);
        this.appendValueInput("BVALUE")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_RGB_B);
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setTooltip('');
    }
};

Blockly.Blocks.ruilong_robot_rgb_brightness = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_RGB)
        this.appendValueInput("PIN", Number)
           .setCheck(Number)
           .setAlign(Blockly.ALIGN_RIGHT)
           .appendField(Blockly.MIXLY_PIN);
        this.appendValueInput("NUM")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField("亮度");
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setTooltip('');
    }
};

Blockly.Blocks.ruilong_robot_rgb2 = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_RGB)
         this.appendValueInput("PIN", Number)
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_PIN);
        this.appendValueInput("_LED_")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_RGB_NUM);
        this.appendDummyInput("")
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(new Blockly.FieldColour("#ff0000"), "RGB_LED_COLOR");
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};

Blockly.Blocks.ruilong_rgb2 = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_RGB)
         this.appendValueInput("PIN", Number)
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_PIN);
        this.appendValueInput("_LED_")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_RGB_NUM);
        this.appendDummyInput("")
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(new Blockly.FieldColour("#ff0000"), "RGB_LED_COLOR");
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};

Blockly.Blocks.ruilong_robot_rgb3 = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_RGB)
         this.appendValueInput("PIN", Number)
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_PIN);
		this.appendValueInput("NUM")
            .setCheck(Number)
            .appendField("初始亮度");
        this.appendValueInput("WAIT")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField("七彩变换切换时间");
        
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};

Blockly.Blocks.ruilong_robot_rgb4 = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendDummyInput("")
            .appendField(Blockly.MIXLY_RGB)
        this.appendValueInput("PIN", Number)
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField(Blockly.MIXLY_PIN);
        this.appendValueInput("NUM")
            .setCheck(Number)
            .appendField("初始亮度");
        this.appendValueInput("WAIT")
            .setCheck(Number)
            .setAlign(Blockly.ALIGN_RIGHT)
            .appendField("七彩循环切换时间");
        
        this.setInputsInline(true);
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
    }
};


//超声测距
Blockly.Blocks.ruilong_robot_hc_sr04 = {
	init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
	this.appendDummyInput("")
	    .appendField("超声波测距")
		//.appendField(new Blockly.FieldImage("../../media/lobo/RGB_BLOCK.jpg", 33, 32))
	this.appendValueInput("PIN1", Number)
		.setCheck(Number)
		.setAlign(Blockly.ALIGN_RIGHT)
        .appendField("Trig#")
	this.appendValueInput("PIN2", Number)
		.setCheck(Number)
		.setAlign(Blockly.ALIGN_RIGHT)
        .appendField("Echo#");	

	this.setInputsInline(true);	
	this.setOutput(true, Number);
	this.setTooltip('');
  }
};
//红外接收模块
Blockly.Blocks.ruilong_robot_ir_recv = {
    init: function () {
        this.setColour(Blockly.Blocks.ruilong.HUE);
        this.appendValueInput("PIN", Number)
            .appendField(new Blockly.FieldTextInput('ir_item'), 'VAR')
            .appendField(Blockly.MIXLY_IR_RECEIVE)
            .setCheck(Number);
        this.appendStatementInput('DO')
            .appendField(Blockly.MIXLY_IR_RECEIVE_YES);
        this.appendStatementInput('DO2')
            .appendField(Blockly.MIXLY_IR_RECEIVE_NO);
        this.setPreviousStatement(true);
        this.setNextStatement(true);
        this.setInputsInline(true);
        this.setTooltip(Blockly.MIXLY_IR_RECIEVE_TOOLTIP);
    },
    getVars: function () {
        return [this.getFieldValue('VAR')];
    },
    renameVar: function (oldName, newName) {
        if (Blockly.Names.equals(oldName, this.getFieldValue('VAR'))) {
            this.setTitleValue(newName, 'VAR');
        }
    }
};

//蓝色闪灯
Blockly.Blocks.ruilong_robot_blink = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
	this.appendValueInput("PIN").setCheck(Number).appendField("蓝色闪灯");
    this.appendValueInput("BL").setCheck([Number,Boolean]).appendField("设为");
	this.setInputsInline(true);	
    this.setPreviousStatement(true);
    this.setNextStatement(true);
  }
};

Blockly.Blocks.ruilong_robot_blink_read = {
  init: function() {
    this.setColour(Blockly.Blocks.ruilong.HUE);
    this.appendDummyInput("")
	    .appendField("蓝色闪灯状态")
	this.appendValueInput("PIN", Number)
        .appendField(Blockly.MIXLY_PIN)
        .setCheck(Number);
    this.setOutput(true, Boolean);
	this.setInputsInline(true);
    this.setTooltip('');
  }
};
